

AsciiToMqttJsonCommon.prototype._GetMqttJsonGroupName_ = async function() 
{
    var Return = [];
    var Class = new LoadFile();
    try {
        var JSON = await Class._ReadFile_("./File/IoT_Platform/MqttJsonGroup.json", {});
        var Index = Object.keys(JSON);
        for (var i = 0; i < Index.length; i++) {
            if (JSON[Index[i]]["Name"] != "") {
                Return.push(JSON[Index[i]]["Name"]);
            }
        }
    } catch (error) {
        //console.error("Error reading file:", error);
    }
    return Return;
}

AsciiToMqttJsonCommon.prototype._GetAzureName_ = async function() 
{
	const Return = [];
	const Class = new LoadFile();
	
	try {
		const JSON = await Class._ReadFile_("./File/IoT_Platform/Microsoft_Azure_Platform.json", new Object());
		const Index = Object.keys(JSON);
		for (let i = 0; i < Index.length; i++) {
			if (JSON[Index[i]]["Name"] !== "") {
				Return.push(JSON[Index[i]]["Name"] + " (Azure)");
			}
		}
	} catch (error) {
		//console.error("Error reading file:", error);
	}
	
	return Return;
};

AsciiToMqttJsonCommon.prototype._GetConnectionName_ = async function()
{
	var Return = new Array();
	var MqttJsonGroupName = await AsciiToMqttJsonCommon.prototype._GetMqttJsonGroupName_();
	var AzureName = await AsciiToMqttJsonCommon.prototype._GetAzureName_();
	Return = MqttJsonGroupName.concat(AzureName);
	return Return;
}





















AsciiToMqttJsonUpdatePage.prototype._SaveGlobalVariable_ = function(Row)
{
	var Class = new StepFlow();
	Class.LockAllUi();
	var ssocket = io.connect();
	var Index=0, Length=Row.length;
	Row.eq(Index).find(".Button").click();
	ssocket.emit("BackgroundExecution");
	ssocket.on("BackgroundExecution", function (Return) {
		if(Row.eq(Index).find(".Message").is(":visible") == true && 
		   Row.eq(Index).find(".Message").css("color") == "rgb(34, 119, 0)")
		{
			Index++;
			Row.eq(Index).find(".Button").click();
			ssocket.emit("BackgroundExecution");
			if(Index==Length)
			{
				ssocket.emit("SocketClose");
				AsciiToMqttJsonUpdatePage.prototype._ShowFirstPage_();
				Class.UnLockAllUi();
			}
		}
		else if(Index<Length)
		{
			ssocket.emit("BackgroundExecution");
		}
	});
}

AsciiToMqttJsonUpdatePage.prototype._IsSaveGlobalVariable_ = async function() 
{
    var Return = false;
    var Class = new LoadFile();

    try {
        var [Index, Module, Variable, Setting, MqttJsonGroup, AzurePlatform] = await Promise.all([
            Class._ReadFile_("./File/ASCII_Module/Index.json", []),
            Class._ReadFile_("./File/ASCII_Module/Module.json", {}),
            Class._ReadFile_("./File/ASCII_Module/AsciiVariable.json", {}),
            Class._ReadFile_("./File/ASCII_Module/AsciiSetting.json", {}),
            Class._ReadFile_("./File/IoT_Platform/MqttJsonGroup.json", {}),
            Class._ReadFile_("./File/IoT_Platform/Microsoft_Azure_Platform.json", {})
        ]);

        if (JSON.stringify(Index) == JSON.stringify(Global_AsciiIndex) &&
            JSON.stringify(Module) == JSON.stringify(Global_AsciiModule) &&
            JSON.stringify(Variable) == JSON.stringify(Global_AsciiVariable) &&
            JSON.stringify(Setting) == JSON.stringify(Global_AsciiSetting) &&
            JSON.stringify(MqttJsonGroup) == JSON.stringify(Global_MqttJsonGroup) &&
            JSON.stringify(AzurePlatform) == JSON.stringify(Global_AzurePlatform)) {
            Return = true;
        }
    } catch (error) {
        //console.error("Error reading file:", error);
    }

    return Return;
}

AsciiToMqttJsonUpdatePage.prototype._ShowFirstPage_ = function()
{
	$("#Main_Center-Content").find(".Body").hide();
	$("#Main_Center-Content").find(".Body").eq(1).show();
	AsciiToMqttJsonFirstPage.prototype._Initialization_();
}

AsciiToMqttJsonUpdatePage.prototype._Initialization_ = async function()
{
	$("#Main_Center-Content").find(".Body").hide();
	$("#Main_Center-Content").find(".Body").eq(0).show();

	if(await AsciiToMqttJsonUpdatePage.prototype._IsSaveGlobalVariable_() == true)
	{
		AsciiToMqttJsonUpdatePage.prototype._ShowFirstPage_();
		return 0;
	}
	var Row = $("#Main_Center-Content").find(".Body").eq(0).find(".Table").find(".Row");
	AsciiToMqttJsonUpdatePage.prototype._SaveGlobalVariable_(Row);
}





















AsciiToMqttJsonFirstPage.prototype._SetConnectionName_ = function(that)
{
	var number = $(that).closest(".DynamicRow").find(".Column").eq(0).text();
	if(typeof(Global_AsciiToMqttJsonVariable[number]) != "object")	{return 0;}
	
	var Button = $(that).closest(".Column").find(".Button");
	var Combobox =  $(that).closest(".Column").find(".Select");
	var SystemVariable = Object.keys(Global_AsciiToMqttJsonVariable[number]);
	var object=new Object();
	for(var i=0; i<SystemVariable.length; i++)
	{
		Global_AsciiToMqttJsonVariable[number][SystemVariable[i]]["ConnectionGroup"] = Combobox.val();
	}
	Button.attr('disabled', true);
}

AsciiToMqttJsonFirstPage.prototype._ChangeConnectionName_ = function(that)
{
	var number = $(that).closest(".DynamicRow").find(".Column").eq(0).text();
	if(typeof(Global_AsciiToMqttJsonVariable[number]) != "object")	{return 0;}
	
	var Button = $(that).closest(".Column").find(".Button");
	var Combobox =  $(that).closest(".Column").find(".Select");
	var SystemVariable = Object.keys(Global_AsciiToMqttJsonVariable[number]);
	var object=new Object();
	for(var i=0; i<SystemVariable.length; i++)
	{
		var ConnectionGroup=Global_AsciiToMqttJsonVariable[number][SystemVariable[i]]["ConnectionGroup"]
		object[ConnectionGroup]=new Object();
	}
	var array=Object.keys(object);
	if(array.length == 1 && array[0] == Combobox.val()){
		Button.attr('disabled', true);
	}
	else{
		Button.attr('disabled', false);
	}
}

AsciiToMqttJsonFirstPage.prototype._LoadConnectionName_ = async function(index, number)
{
	var Combobox = $("#ModuleTable").find(".DynamicRow").eq(index).find(".Column").eq(3).find(".Select");
	var ConnectionName = await AsciiToMqttJsonCommon.prototype._GetConnectionName_();
	for(var i=0; i<ConnectionName.length; i++){
		Combobox.append($("<option></option>").attr("value",ConnectionName[i]).text(ConnectionName[i]));
	}
	Combobox.append($("<option></option>").attr("disabled",true).text("(Groups)"));
	Combobox.val("");
	if(typeof(Global_AsciiToMqttJsonVariable[number]) !="object"){
		return 0;
	}
	AsciiToMqttJsonFirstPage.prototype._ApplyButton_(index, number, Combobox);
}

AsciiToMqttJsonFirstPage.prototype._ApplyButton_ = function(index, number, Combobox)
{
	var Button = $("#ModuleTable").find(".DynamicRow").eq(index).find(".Column").eq(3).find(".Button");
	var SystemVariable=Object.keys(Global_AsciiToMqttJsonVariable[number]);
	var object=new Object();
	for(var i=0; i<SystemVariable.length; i++){
		var ConnectionGroup=Global_AsciiToMqttJsonVariable[number][SystemVariable[i]]["ConnectionGroup"];
		object[ConnectionGroup]=new Object();
	}
	var array=Object.keys(object);
	if(array.length == 1 && array[0] != ""){
		Combobox.val(array[0]);
		Button.attr('disabled', true);
	}
	else if(array.length == 1 && array[0] == ""){
		Combobox.val(array[0]);
		Button.attr('disabled', false);
	}
	else if(array.length >1){
		Combobox.val("(Groups)");
		Button.attr('disabled', true);
	}
}

AsciiToMqttJsonFirstPage.prototype._ChangeCheckbox_ = function(that)
{
	var Bool = $(that).closest(".DynamicRow").find(".Column").eq(4).find(":checkbox").prop("checked");
	var number = $(that).closest(".DynamicRow").find(".Column").eq(0).text();
	if(typeof(Global_AsciiToMqttJsonVariable[number])!="object"){
		return;
	}
	var SystemVariable = Object.keys(Global_AsciiVariable[number]);
	for(var i=0; i<SystemVariable.length; i++)
	{
		Global_AsciiToMqttJsonVariable[number][SystemVariable[i]]["TransformMqttJson"] = Bool;
	}
}

AsciiToMqttJsonFirstPage.prototype._ChangeAllCheckbox_ = function(that)
{
	var ModuleTableId = $(that).closest(".Table").attr("id");
	var Bool = $(that).closest(".Row").find(":checkbox").prop("checked");
	var Element = $("#"+ModuleTableId).find(".DynamicRow");
	for(var i=0; i<Element.length; i++)
	{
		if(Element.eq(i).find(":checkbox").prop("checked") != Bool)
		{
			Element.eq(i).find(":checkbox").prop("checked",Bool);
			var that = Element.eq(i).find(":checkbox");
			AsciiToMqttJsonFirstPage.prototype._ChangeCheckbox_(that);
		}
	}
}

AsciiToMqttJsonFirstPage.prototype._IsAllTransformMqttJson_ = function(number)
{
	var Return=false;
	if(typeof(Global_AsciiToMqttJsonVariable[number]) != "object")
	{
		return Return;
	}
	var SystemVariable=Object.keys(Global_AsciiToMqttJsonVariable[number]);
	if(SystemVariable.length==0)
	{
		return Return;
	}
	for(var i=0; i<SystemVariable.length; i++)
	{
		if(Global_AsciiToMqttJsonVariable[number][SystemVariable[i]]["TransformMqttJson"]==false)
		{
			return Return;
		}
	}
	Return=true;
	return Return;
}

AsciiToMqttJsonFirstPage.prototype._GetAllModuleData_ = function()
{
	var Return = new Object();
	var DeviceName = Object.keys(Global_AsciiModule);
	for(var i=0; i<DeviceName.length; i++)
	{
		var nmuber = Object.keys(Global_AsciiModule[DeviceName[i]]);
		for(var j=0; j<nmuber.length; j++)
		{
			Return[nmuber[j]] = new Object();
			Return[nmuber[j]] = jQuery.parseJSON(JSON.stringify(Global_AsciiModule[DeviceName[i]][nmuber[j]]));
		}
	}
	return Return;
}

AsciiToMqttJsonFirstPage.prototype._GetAllDeviceName_ = function()
{
	var Return=Object.keys(Global_AsciiModule);
	return Return;
}

AsciiToMqttJsonFirstPage.prototype._GetAllNumber_ = function()
{
	var AllDeviceName = AsciiToMqttJsonFirstPage.prototype._GetAllDeviceName_();
	var ObjectKey = new Array();
	for(var i=0; i<AllDeviceName.length; i++)
	{
		if(typeof(Global_AsciiModule[AllDeviceName[i]]) == "object")
		{
			ObjectKey = ObjectKey.concat(Object.keys(Global_AsciiModule[AllDeviceName[i]]));
		}
	}
	ObjectKey = ObjectKey.sort(function (a, b) {return a - b});
	return ObjectKey;
}

AsciiToMqttJsonFirstPage.prototype._ShowTable_ = async function(ObjectKey, DisplayNumber)
{
	var AllModuleData = AsciiToMqttJsonFirstPage.prototype._GetAllModuleData_();
	$("#ModuleTable").find(".DynamicRow").remove();
	var html = $(".Dynamic").html();
	var PageNumber = $("#ModuleToolbar").find(".Text").val();
	var Start = (PageNumber-1)*DisplayNumber;
	if((ObjectKey.length-Start)>DisplayNumber){
		var End = Start + DisplayNumber;
	}
	else{
		var End = ObjectKey.length;
	}
	var index = 0;
	for(var i=Start; i<End && End!=0; i++)
	{
		$("#ModuleTable").append(html);
		$("#ModuleTable").find(".DynamicRow").eq(index).find(".Column").eq(0).text(ObjectKey[i]);
		$("#ModuleTable").find(".DynamicRow").eq(index).find(".Column").eq(1).text(AllModuleData[ObjectKey[i]]["ModuleName"]);
		await AsciiToMqttJsonFirstPage.prototype._LoadConnectionName_(index, ObjectKey[i]);
		var Bool = AsciiToMqttJsonFirstPage.prototype._IsAllTransformMqttJson_(ObjectKey[i]);
		$("#ModuleTable").find(".DynamicRow").eq(index).find(".Column").eq(4).find(":checkbox").prop("checked",Bool);
		index++;
	}
}

AsciiToMqttJsonFirstPage.prototype._UpdateTableToolbar_ = function(ObjectKey, DisplayNumber)
{
	var NumberOfPages = Math.ceil(ObjectKey.length/DisplayNumber);
	var Id = "#ModuleToolbar";
	$(Id).find("label").eq(1).text(NumberOfPages);
	var CurrentlyPage = $(Id).find(".Text").val();
	CurrentlyPage = parseInt(CurrentlyPage);
	if(CurrentlyPage>NumberOfPages)
	{
		$(Id).find(".Text").val(NumberOfPages);
	}
	else if(CurrentlyPage<=0 || isNaN(CurrentlyPage)==true)
	{
		$(Id).find(".Text").val(1);
	}
	else
	{
		$(Id).find(".Text").val(CurrentlyPage);
	}
}

AsciiToMqttJsonFirstPage.prototype._RedisplayUi_ = function()
{
	var DisplayNumber = 20;//RTU 20 TCP 40 ASCII 20
	var ObjectKey = AsciiToMqttJsonFirstPage.prototype._GetAllNumber_();
	AsciiToMqttJsonFirstPage.prototype._UpdateTableToolbar_(ObjectKey, DisplayNumber);
	AsciiToMqttJsonFirstPage.prototype._ShowTable_(ObjectKey, DisplayNumber);
	var Id = "#ModuleTable";
	$(Id).find(".Row").eq(0).find(":checkbox").prop("checked",false);
}

AsciiToMqttJsonFirstPage.prototype._ShowPreviousPage_ = function()
{
	var Id = "#ModuleToolbar";
	var CurrentlyPage = $(Id).find(".Text").val();
	$(Id).find(".Text").val(parseInt(CurrentlyPage)-1);
	AsciiToMqttJsonFirstPage.prototype._RedisplayUi_();
}

AsciiToMqttJsonFirstPage.prototype._ShowNextPage_ = function()
{
	var Id = "#ModuleToolbar";
	var CurrentlyPage = $(Id).find(".Text").val();
	$(Id).find(".Text").val(parseInt(CurrentlyPage)+1);
	AsciiToMqttJsonFirstPage.prototype._RedisplayUi_();
}

AsciiToMqttJsonFirstPage.prototype._Initialization_ = function()
{
	AsciiToMqttJsonFirstPage.prototype._RedisplayUi_();
}

AsciiToMqttJsonFirstPage.prototype._TransmissionJson_ = function(ssocket, Command, string, Callback)
{
	var Length=20000, index=0;  var array = new Array("Start","");
	ssocket.emit(Command, array);	
	ssocket.on(Command, function (Return) {
		if(Return == "Start" || Return == "Send")
		{
			if(string.length > (index+Length)){
				array = new Array("Send", string.substring(index, index+Length));
			}
			else if(string.length <= (index+Length)){
				array = new Array("End", string.substring(index, string.length));
			}
			index = index + Length;
			ssocket.emit(Command, array);	
		}
		else if(Return == "End")
		{
			Callback();
		}
	});
}

AsciiToMqttJsonFirstPage.prototype._SaveFinished_ = function(that, ssocket)
{
	$(that).closest('.Row').find(".Loading").hide();
	$(that).closest('.Row').find(".Message").eq(1).show();
	ssocket.emit("SaveFinished");
	ssocket.on("SaveFinished", function (Return) {
		if(Return == true)
		{
			$(that).closest('.Row').find(".Message").hide();
			$(that).closest('.Row').find(".Message").eq(0).show();
		}
		else
		{
			$(that).closest('.Row').find(".Message").hide();
			$(that).closest('.Row').find(".Message").eq(2).show();
		}
		ssocket.emit("SocketClose");
	});
}

AsciiToMqttJsonFirstPage.prototype._SaveStart_ = function(that, ssocket)
{
	that.disabled = true;
	ssocket.emit("BackgroundExecution");
	ssocket.on("BackgroundExecution", function (Return) {
    if (Return == true) {
      var Callback0 = function () {
		that.disabled = false;
        AsciiToMqttJsonFirstPage.prototype._SaveFinished_(that, ssocket);
      };
      var JsonString = JSON.stringify(Global_AsciiToMqttJsonVariable);
      $(that).closest(".Row").find(".Message").hide();
      $(that).closest(".Row").find(".Loading").show();
      AsciiToMqttJsonFirstPage.prototype._TransmissionJson_(
        ssocket,
        "SaveAsciiToMqttJsonVariable",
        JsonString,
        Callback0
      );
    }
	else{
		that.disabled = false;
	}
  });
} 

AsciiToMqttJsonFirstPage.prototype._EditButton_ = function(that)
{
	$(that).closest(".Column").find(".Message").show();
	var ssocket = io.connect();
	ssocket.emit("BackgroundExecution");
	ssocket.on("BackgroundExecution", function (Return) {
	if(Return == true)
	{
		$("#Main_Center-Content").find(".Body").eq(2).find(".Message").hide();
		var number = parseInt($(that).closest(".DynamicRow").find(".Column").eq(0).text());
		$("#Main_Center-Content").find(".Body").eq(1).hide();
		AsciiToMqttJsonSecondPage.prototype._HideColumn_();
		$("#Main_Center-Content").find(".Body").eq(2).show();
		var Name = $("#Main_Center-Content").find(".Body").eq(2).find(".FormTitle").eq(0).text();
		var Class = new Path();
		Class.LoadPathHtml(Name, 2);
		
		AsciiToMqttJsonSecondPage.prototype._SetInitialValue_(number);
		$(that).closest(".Column").find(".Message").hide();
	}
	});
}

AsciiToMqttJsonFirstPage.prototype._SaveButton_ = function(that)
{
	$(that).closest('.Row').find(".Loading").hide();
	$(that).closest('.Row').find(".Message").hide();
	var ssocket = io.connect();
	AsciiToMqttJsonFirstPage.prototype._SaveStart_(that, ssocket);
}





















AsciiToMqttJsonSecondPage.prototype._LoadConnectionName_ = async function(Index, ConnectionGroup)
{
	var Combobox = $("#VariableTable").find(".DynamicRow").eq(Index).find(".Column").eq(5).find(".Select");
	var ConnectionName = await AsciiToMqttJsonCommon.prototype._GetConnectionName_();
	for(var i=0; i<ConnectionName.length; i++)
	{
		Combobox.append($("<option></option>").attr("value",ConnectionName[i]).text(ConnectionName[i]));
	}
	Combobox.val(ConnectionGroup);
}

AsciiToMqttJsonSecondPage.prototype._VariableTableAddNewRow_ = function(number)
{
	if(typeof(Global_AsciiToMqttJsonVariable[number]) != "object")	{return 0;}
	var html="", TempHtml = $("#Main_Center-Content").find(".Body").eq(2).find(".Dynamic").html();
	var SystemVariable = Object.keys(Global_AsciiToMqttJsonVariable[number]);
	for(var i=0; i<SystemVariable.length; i++)
	{
		html = html + TempHtml;
	}
	$("#VariableTable").append(html);
}

AsciiToMqttJsonSecondPage.prototype._SetVariableTableNewRowValue_ = async function(number)
{
	if(typeof(Global_AsciiToMqttJsonVariable[number]) != "object")	{return 0;}
	var Variable = Global_AsciiVariable[number];
	var Class=new Algorithm();
	var SystemVariable = Object.keys(Global_AsciiToMqttJsonVariable[number]).sort(Class.StringNumberMixedSort());
	var Row = $("#VariableTable").find(".DynamicRow");
	for(var i=0; i<SystemVariable.length; i++)
	{
		Row.eq(i).find(".Column").eq(0).text(SystemVariable[i]);
		Row.eq(i).find(".Column").eq(1).find(".Text").val(Variable[SystemVariable[i]]["VariableName"]);
		Row.eq(i).find(".Column").eq(2).find(".Text").val(Global_AsciiToMqttJsonVariable[number][SystemVariable[i]]["Alias"]);
		var ReadWriteType = AsciiToMqttJsonSecondPage.prototype._GetReadWriteType_(SystemVariable[i].split("-")[0]);
		Row.eq(i).find(".Column").eq(3).find(".Select").val(ReadWriteType);
		Row.eq(i).find(".Column").eq(4).text(SystemVariable[i].split("-")[1]);
		await AsciiToMqttJsonSecondPage.prototype._LoadConnectionName_(i, Global_AsciiToMqttJsonVariable[number][SystemVariable[i]]["ConnectionGroup"]);
		var Bool = Global_AsciiToMqttJsonVariable[number][SystemVariable[i]]["TransformMqttJson"];
		Row.eq(i).find(".Column").eq(6).find(".Checkbox").prop("checked",Bool);
	}
}

AsciiToMqttJsonSecondPage.prototype._GetModuleName_ = function(number)
{
	var Return="";
	var DeviceName = Object.keys(Global_AsciiModule);
	for(var i=0; i<DeviceName.length; i++)
	{
		if(typeof(Global_AsciiModule[DeviceName[i]][number]) == "object")
		{
			Return = Global_AsciiModule[DeviceName[i]][number]["ModuleName"];
			break;
		}
	}
	return Return;
}

AsciiToMqttJsonSecondPage.prototype._ClearTable_ = function(number)
{
	$("#VariableTable").find(".Row").eq(0).find(".Checkbox").prop("checked",false);
	$("#VariableTable").find(".DynamicRow").remove();
}

AsciiToMqttJsonSecondPage.prototype._SetVariableTableInitialValue_ = function(number)
{
	AsciiToMqttJsonSecondPage.prototype._VariableTableAddNewRow_(number);
	AsciiToMqttJsonSecondPage.prototype._SetVariableTableNewRowValue_(number);
}

AsciiToMqttJsonSecondPage.prototype._SetFormInitialValue_ = function(number)
{
	var ModuleName=AsciiToMqttJsonSecondPage.prototype._GetModuleName_(number);
	var ContentSettings = $("#Main_Center-Content").find(".Body").eq(2).find(".Form").eq(0).find(".Row");
	ContentSettings.eq(0).find(".Text").val(number);
	ContentSettings.eq(1).find(".Text").val(ModuleName);
}

AsciiToMqttJsonSecondPage.prototype._SetInitialValue_ = function(number)
{
	AsciiToMqttJsonSecondPage.prototype._ClearTable_(number);
	AsciiToMqttJsonSecondPage.prototype._SetFormInitialValue_(number);
	AsciiToMqttJsonSecondPage.prototype._SetVariableTableInitialValue_(number);
}

AsciiToMqttJsonSecondPage.prototype._ModifyAsciiToMqttJsonVariableObject_ = function(number)
{
	var Row = $("#VariableTable").find(".DynamicRow");
	for(var i=0; i<Row.length; i++)
	{
		var SystemVariable = Row.eq(i).find(".Column").eq(0).text();
		var Alias = Row.eq(i).find(".Column").eq(2).find(".Text").val();
		var ConnectionGroup = Row.eq(i).find(".Column").eq(5).find(".Select").val();
		if(ConnectionGroup == null)
		{
			ConnectionGroup="";
		};
		var Bool = Row.eq(i).find(":checkbox").prop("checked");
		Global_AsciiToMqttJsonVariable[number][SystemVariable]["Alias"] = Alias;
		Global_AsciiToMqttJsonVariable[number][SystemVariable]["ConnectionGroup"] = ConnectionGroup;
		Global_AsciiToMqttJsonVariable[number][SystemVariable]["TransformMqttJson"] = Bool;
	}
}

AsciiToMqttJsonSecondPage.prototype._ConfirmButton_ = function(that)
{
	$(that).closest(".Row").find(".Message").hide();
	var Bool=AsciiToMqttJsonSecondPage.prototype._AllDataIsCorrect_();
	if(Bool==false)
	{
		$(that).closest(".Row").find(".Message").show();
		return 0;
	}
	var ContentSettings = $("#Main_Center-Content").find(".Body").eq(2).find(".Form").eq(0).find(".Row");
	var number = parseInt(ContentSettings.eq(0).find(".Text").val());
	AsciiToMqttJsonSecondPage.prototype._ModifyAsciiToMqttJsonVariableObject_(number);
	$("#Main_Center-Content").find(".Body").eq(2).hide();
	$("#Main_Center-Content").find(".Body").eq(1).show();
	AsciiToMqttJsonFirstPage.prototype._RedisplayUi_();
	var Class = new Path();
	Class.LoadPathHtml($("#Left-List-AsciiToMqttJson").text(), 1, "main_PathAsciiToMqttJson_click(this)");
	
}

AsciiToMqttJsonSecondPage.prototype._NoConfirmButton_ = function()
{
	$("#Main_Center-Content").find(".Body").eq(2).hide();
	$("#Main_Center-Content").find(".Body").eq(1).show();
	var Class = new Path();
	Class.LoadPathHtml($("#Left-List-AsciiToMqttJson").text(), 1, "main_PathAsciiToMqttJson_click(this)");
	
}

AsciiToMqttJsonSecondPage.prototype._ShowColumn_ = function()
{
	$("#VariableTable").find(".Row").find(".TitleColumn").eq(3).show();
	$("#VariableTable").find(".Row").find(".TitleColumn").eq(4).show();
	var DynamicRow = $("#VariableTable").find(".DynamicRow");
	for(var i=0; i<DynamicRow.length; i++)
	{
		DynamicRow.eq(i).find(".Column").eq(3).show();
		DynamicRow.eq(i).find(".Column").eq(4).show();
	}
}

AsciiToMqttJsonSecondPage.prototype._HideColumn_ = function()
{
	$("#VariableTable").find(".Row").find(".TitleColumn").eq(3).hide();
	$("#VariableTable").find(".Row").find(".TitleColumn").eq(4).hide();
	var DynamicRow = $("#VariableTable").find(".DynamicRow");
	for(var i=0; i<DynamicRow.length; i++)
	{
		DynamicRow.eq(i).find(".Column").eq(3).hide();
		DynamicRow.eq(i).find(".Column").eq(4).hide();
	}
}

AsciiToMqttJsonSecondPage.prototype._GetReadWriteType_ = function(string)
{
	var Return;
	if(string == "DO")			{Return = "ReadWrite";}
	else if(string == "DI")		{Return = "Read";}
	else if(string == "AO")		{Return = "ReadWrite";}
	else if(string == "AI")		{Return = "Read";}
	return Return;
}

AsciiToMqttJsonSecondPage.prototype._AllDataIsCorrect_ = function()
{
	var Return = true;
	var length = $("#VariableTable").find(".DynamicRow").length;
	for(var i=0; i<length; i++)
	{
		var ShowMessage = $("#VariableTable").find(".DynamicRow").eq(i).find(".Message").eq(0).is(":visible");
		if(ShowMessage == true)
		{
			Return = false;
		}
	}
	return Return;
}

AsciiToMqttJsonSecondPage.prototype._CheckAlias_ = function(that)
{
	$(that).closest(".Column").find(".Message").hide();
	var Name = $(that).closest(".Column").find(".Text").val();
	var Class = new Type();
	if(Name == "")
	{
		$(that).closest(".Column").find(".Message").show();
	}
	else if(Class.CheckSpecialSymbols(Name) == true)
	{
		$(that).closest(".Column").find(".Message").show();
	}
	else if(Class.CheckChineseLanguage(Name) == true)
	{
		$(that).closest(".Column").find(".Message").show();
	}
	
}