BlockRuleFirstPage.prototype._Initialization_ = function()
{
	BlockRuleFirstPage.prototype._RedisplayUi_();
}

BlockRuleFirstPage.prototype._RedisplayUi_ = function()
{
	var GlobalVariable = Global_BlockRule;
	var DisplayNumber = 10;
	var number = Object.keys(GlobalVariable);
	BlockRuleFirstPage.prototype._UpdateTableToolbar_(number, DisplayNumber);
	BlockRuleFirstPage.prototype._ShowTable_(number, DisplayNumber);
	var Table=$("#Main_Center-Content").find(".Body").eq(1).find(".Table").eq(0);
	Table.find(".Row").eq(0).find(":checkbox").prop("checked",false);
}

BlockRuleFirstPage.prototype._CheckBlockRuleName_ = function()
{
	var Id = "#BlockRuleTable";
	$(Id).find(".Message").hide();
	var Row=$(Id).find(".Row");
	var Name = Row.eq(1).find(".Text").val();
	var Class = new Type();
	if(Class.EnglishDigitalAndBottomline(Name) == false)
	{
		Row.eq(0).find(".Message").eq(0).show();
	}
	
	if(BlockRuleFirstPage.prototype._IsNameRepeat_(Name) == true)
	{
		Row.eq(0).find(".Message").eq(1).show();
	}
}

BlockRuleFirstPage.prototype._BuildBlockRuleObject_ = function(that)
{
	var number = Object.keys(Global_BlockRule);
	if(number.length == 0){
		number=1;
	}
	else if(number.length>0){
		number = Math.max.apply(null,number)+1;
	}
	else if( number.length > 4 )
	{
		return;
	}
	if(typeof(Global_BlockRule[number]) == "undefined")
	{
		Global_BlockRule[number] = new Object();
		Global_BlockRule[number]["Name"] = $(that).closest(".Row").find(".Column").eq(2).find(".Text").val();
		Global_BlockRule[number]["Port"] = "24";
		Global_BlockRule[number]["Established"] = "10";
		Global_BlockRule[number]["Syn_recv"] = "5";
		Global_BlockRule[number]["Close_wait"] = "5";
		Global_BlockRule[number]["Interval_time"] = "60";
	}
}

BlockRuleFirstPage.prototype._UpdateTableToolbar_ = function(number, DisplayNumber)
{
	var NumberOfPages = Math.ceil(number.length/DisplayNumber);
	var Id = "#Toolbar";
	$(Id).find("label").eq(1).text(NumberOfPages);
	var CurrentlyPage = $(Id).find(".Text").val();
	CurrentlyPage = parseInt(CurrentlyPage);
	if(CurrentlyPage>NumberOfPages)
	{
		$(Id).find(".Text").val(NumberOfPages);
	}
	else if(CurrentlyPage<=0 || isNaN(CurrentlyPage)==true)
	{
		$(Id).find(".Text").val(1);
	}
	else
	{
		$(Id).find(".Text").val(CurrentlyPage);
	}
}

BlockRuleFirstPage.prototype._ShowTable_ = function(number, DisplayNumber)
{
	var TableId = "#BlockRuleTable";
	var GlobalVariable = Global_BlockRule;
	$(TableId).find(".DynamicRow").remove();
	var html = $(".Dynamic").html();
	var PageNumber = $("#Toolbar").find(".Text").val();
	var Start = (PageNumber-1)*DisplayNumber;
	if((number.length-Start)>DisplayNumber){
		var End = Start + DisplayNumber;
	}
	else{
		var End = number.length;
	}
	var index = 0;
	for(var i=Start; i<End && End!=0; i++)
	{
		$(TableId).append(html);
		$(TableId).find(".DynamicRow").eq(index).find(".Column").eq(0).text(number[i]);
		$(TableId).find(".DynamicRow").eq(index).find(".Column").eq(2).text(GlobalVariable[number[i]]["Name"]);
		index++;
	}
}

BlockRuleFirstPage.prototype._AutomaticBlockRuleName_ = function()
{
	var TableId = "#BlockRuleTable";
	//var Table = $("#Main_Center-Content").find(".Body").eq(1).find(".Table").eq(0);
	var Index = 1;
	var object = Global_BlockRule;
	var number = Object.keys(object);
	var Name, NameArray=new Array();
	for(var i=0; i<number.length; i++)
	{
		NameArray.push(object[number[i]]["Name"]);
	}
	while(true)
	{
		Name = "BlockRule"+Index;
		if(NameArray.indexOf(Name) == -1)
		{
			break;
		}
		Index++;
	}
	$(TableId).find(".Row").eq(1).find(".Text").val(Name);
}

BlockRuleFirstPage.prototype._IsNameRepeat_ = function(Name)
{
	var GlobalVariable=Global_BlockRule;
	var Return=false;
	var Row = $("#Main_Center-Content").find(".Body").eq(1).find(".Form").eq(0).find(".Row");
	var CurrentlyNumber = Row.eq(0).find(".Text").val();
	var number = Object.keys(GlobalVariable);
	for(var i=0; i<number.length; i++)
	{
		if(Name == GlobalVariable[number[i]]["Name"])
		{
			Return=true;
			break;
		}
	}
	return Return;
}

BlockRuleFirstPage.prototype._IsTickedBlockRule_ = function()
{
	var Return=false;
	var Id = "#BlockRuleTable";
	if($(Id).find(".DynamicRow").find(":checked").length >0)
	{
		Return=true;
	}
	return Return;
}

BlockRuleFirstPage.prototype._RemoveGlobalVariable_ = function(number)
{
	Global_BlockRule[number] = null;	delete Global_BlockRule[number];
}

BlockRuleFirstPage.prototype._RemoveTickedBlockRule_ = function()
{
	var Id = "#BlockRuleTable";
	var element = $(Id).find(".DynamicRow").find(":checked");
	var CheckedLength = element.length;
	for(var i=0; i<CheckedLength; i++)
	{
		var number = element.eq(i).closest(".DynamicRow").find(".Column").eq(0).text();
		BlockRuleFirstPage.prototype._RemoveGlobalVariable_(number);
	}
}

BlockRuleFirstPage.prototype._DeleteBlockRule_ = function()
{
	BlockRuleFirstPage.prototype._RemoveTickedBlockRule_();
	BlockRuleFirstPage.prototype._RedisplayUi_();
	var Id = "#BlockRuleTable";
	$(Id).find(".Row").eq(0).find(":checkbox").prop("checked", false);
}

BlockRuleFirstPage.prototype._SaveBlockRuleSetting_ = function(Result)
{
	var Result_1={"Input":null};
	var Class = new Transmission();
	Class.TransmissionString("SaveBlockRule", JSON.stringify(Global_BlockRule), Result_1);
	var SetInterval = setInterval(function()
	{
		if(Result_1["Input"]==true)
		{
			Result["Input"] = true;
			clearInterval(SetInterval);
		}
	},500);
}

BlockRuleFirstPage.prototype._TransformBlockRuleJson_ = async function() 
{
    const Class = new LoadFile();
    const Return = [];
    
    try {
        const BlockRule = await Class._ReadFile_("./File/Block_List/BlockRule.json", new Object());
        const ObjectKey = Object.keys(BlockRule);

        for (let i = 0; i < ObjectKey.length; i++) {
            const obj = {};
            obj["port"] = parseInt(BlockRule[ObjectKey[i]]["Port"]);
            obj["established"] = parseInt(BlockRule[ObjectKey[i]]["Established"]);
            obj["syn_recv"] = parseInt(BlockRule[ObjectKey[i]]["Syn_recv"]);
            obj["close_wait"] = parseInt(BlockRule[ObjectKey[i]]["Close_wait"]);
            obj["interval_time"] = parseInt(BlockRule[ObjectKey[i]]["Interval_time"]);
            Return.push(obj);
        }
    } catch (error) {
        //console.error("Error reading file:", error);
    }

    return Return;
};

BlockRuleFirstPage.prototype._AddNewRow_ = function(that)
{
	BlockRuleFirstPage.prototype._CheckBlockRuleName_ ();
	var Id = "#BlockRuleTable";
	var ShowErrorMessage = $(Id).find(".Row").eq(0).find(".Message").is(":visible");
	if(ShowErrorMessage == true)	{return 0;}

	if( $(Id).find(".DynamicRow").length > 4 ) {return 0;}    

	BlockRuleFirstPage.prototype._BuildBlockRuleObject_(that);
	BlockRuleFirstPage.prototype._RedisplayUi_();
	BlockRuleFirstPage.prototype._AutomaticBlockRuleName_();
}

BlockRuleFirstPage.prototype._EditButton_ = function(that)
{
	//$("#Main_Center-Content").find(".Body").eq(2).find(".Message").hide();
	var number = $(that).closest(".DynamicRow").find(".Column").eq(0).text();
	$("#Main_Center-Content").find(".Body").eq(0).hide();
	$("#Main_Center-Content").find(".Body").eq(1).show();
	var Name = $("#Main_Center-Content").find(".Body").eq(2).find(".FormTitle").eq(0).text();
	var Class = new Path();
	Class.LoadPathHtml(Name, 2);
	
	BlockRuleSecondPage.prototype._SetInitialValue_(number);
}

BlockRuleFirstPage.prototype._SaveButton_ = function(that)
{
	var Result={"Input":null};
	$(that).closest('.Row').find(".Loading").show();
	$(that).closest('.Row').find(".Message").hide();
	BlockRuleFirstPage.prototype._SaveBlockRuleSetting_(Result);
	var SetInterval = setInterval(function()
	{
		if(Result["Input"] == true)
		{
			clearInterval(SetInterval);

			var BlockRuleArray = BlockRuleFirstPage.prototype._TransformBlockRuleJson_();
			var Result_1={"Input":null};
			Class = new Transmission();
			Class.TransmissionString("SaveBlockRuleJson", JSON.stringify(BlockRuleArray), Result_1);

			var SetInterval_1 = setInterval(function()
			{
				if(Result_1["Input"]==true)
				{
					clearInterval(SetInterval_1);
					$(that).closest('.Row').find(".Loading").hide();
					$(that).closest('.Row').find(".Message").eq(0).show();
				}
			},500);
		}
	},500);
}

BlockRuleSecondPage.prototype._CheckIdentificationName_ = function(that)
{
	var Id = "#BlockRuleTable";
	$(Id).find(".Message").hide();
	var Row = $(Id).find(".Row");
	var Name = Row.eq(1).find(".Text").val();
	if(Name == "")
	{
		Row.eq(0).find(".Message").eq(0).show();
	}
	if(BlockRuleFirstPage.prototype._IsNameRepeat_(Name) == true)
	{
		Row.eq(0).find(".Message").eq(1).show();
	}
}

BlockRuleSecondPage.prototype._CheckPort_ = function(that)
{
	$(that).closest(".Row").find(".Message").hide();
	var TableName = $(that).val();
	var Class = new Type();
	if(Class.CheckPositiveIntegersAndZero(TableName) == false)
	{
		$(that).closest(".Row").find(".Message").eq(0).show();
	}
	
}

BlockRuleSecondPage.prototype._CheckEstablished_ = function(that)
{
	$(that).closest(".Row").find(".Message").hide();
	var TableName = $(that).val();
	var Class = new Type();
	if(Class.CheckPositiveIntegersAndZero(TableName) == false)
	{
		$(that).closest(".Row").find(".Message").eq(0).show();
	}
	
}

BlockRuleSecondPage.prototype._CheckSyncRecv_ = function(that)
{
	$(that).closest(".Row").find(".Message").hide();
	var TableName = $(that).val();
	var Class = new Type();
	if(Class.CheckPositiveIntegersAndZero(TableName) == false)
	{
		$(that).closest(".Row").find(".Message").eq(0).show();
	}
	
}

BlockRuleSecondPage.prototype._CheckCloseWait_ = function(that)
{
	$(that).closest(".Row").find(".Message").hide();
	var TableName = $(that).val();
	var Class = new Type();
	if(Class.CheckPositiveIntegersAndZero(TableName) == false)
	{
		$(that).closest(".Row").find(".Message").eq(0).show();
	}
	
}

BlockRuleSecondPage.prototype._CheckIntervalTime_ = function(that)
{
	$(that).closest(".Row").find(".Message").hide();
	var TableName = $(that).val();
	var Class = new Type();
	if(Class.CheckPositiveIntegersAndZero(TableName) == false)
	{
		$(that).closest(".Row").find(".Message").eq(0).show();
	}
	
}

BlockRuleSecondPage.prototype._SetInitialValue_ = function(number)
{
	var Row = $("#Main_Center-Content").find(".Body").eq(1).find(".Form").eq(0).find(".Row");
	Row.eq(0).find(".Text").val(number);
	Row.eq(1).find(".Text").val(Global_BlockRule[number]["Name"]);
	Row.eq(2).find(".Text").val(Global_BlockRule[number]["Port"]);
	Row.eq(3).find(".Text").val(Global_BlockRule[number]["Established"]);
	Row.eq(4).find(".Text").val(Global_BlockRule[number]["Syn_recv"]);
	Row.eq(5).find(".Text").val(Global_BlockRule[number]["Close_wait"]);
	Row.eq(6).find(".Text").val(Global_BlockRule[number]["Interval_time"]);
}

BlockRuleSecondPage.prototype._GetSettingFormValue_ = function()
{
	var Row = $("#Main_Center-Content").find(".Body").eq(1).find(".Form").eq(0).find(".Row");
	var number = Row.eq(0).find(".Text").val();
	Global_BlockRule[number]["Name"]          = Row.eq(1).find(".RightColumn").find(".Text").val();
	Global_BlockRule[number]["Port"]          = Row.eq(2).find(".RightColumn").find(".Text").val();
	Global_BlockRule[number]["Established"]   = Row.eq(3).find(".RightColumn").find(".Text").val();
	Global_BlockRule[number]["Syn_recv"]      = Row.eq(4).find(".RightColumn").find(".Text").val();
	Global_BlockRule[number]["Close_wait"]    = Row.eq(5).find(".RightColumn").find(".Text").val();
	Global_BlockRule[number]["Interval_time"] = Row.eq(6).find(".RightColumn").find(".Text").val();
}

BlockRuleSecondPage.prototype._ConfirmButton_ = function(that)
{
	var Element = $("#Main_Center-Content").find(".Body").eq(1).find(".Message");
	for(var i=0; i<Element.length; i++)
	{
		if(Element.eq(i).is(":visible") == true && Element.eq(i).css("color") != "rgb(34, 119, 0)"){
			$(that).closest(".Form").find(".Message").eq(1).show();
			return 0;
		}
	}

	BlockRuleSecondPage.prototype._GetSettingFormValue_();

	$("#Main_Center-Content").find(".Body").eq(0).show();
	$("#Main_Center-Content").find(".Body").eq(1).hide();
	BlockRuleFirstPage.prototype._RedisplayUi_();

	var Class = new Path();
	Class.LoadPathHtml($("#Left-List-BlockRule").text(), 1, "main_BlockRule_click(this)");
	
}

BlockRuleSecondPage.prototype._NoConfirmButton_ = function()
{
	$("#Main_Center-Content").find(".Body").eq(0).show();
	$("#Main_Center-Content").find(".Body").eq(1).hide();
	var Class = new Path();
	Class.LoadPathHtml($("#Left-List-BlockRule").text(), 1, "main_BlockRule_click(this)");
	
}