
JsonTransformXml.prototype._GetEipMqttMappingData_ = async function(PrefixWord, ModuleIndex, MqttVariable, Variable, Module, MQTTServiceTask) 
{
    const Index = ModuleIndex.split("_")[1];
    const SystemVariable = Object.keys(MqttVariable[Index]);
    const Class = new LoadFile();

    try {
        const Global_EipSetting = await Class._ReadFile_("./File/EIP_Module/EipSetting.json", new Array());
        const ChannelModeType = parseInt(Global_EipSetting[Index]["ModeType"]);
        for (let j = 0; j < ChannelModeType; j++) {
            if (MqttVariable[Index][SystemVariable[j]]["TransformMqtt"] === true) {
                const MQTTMapping = {};
                MQTTMapping["Name"] = `${PrefixWord}${Index}_${JsonTransformXml.prototype._GetModuleName_(Module, Index)}_${SystemVariable[j].split("-")[0]}.${Variable[Index][SystemVariable[j]]["VariableName"]}`;
                MQTTMapping["PubTopic"] = MqttVariable[Index][SystemVariable[j]]["PublishTopic"];
                MQTTMapping["PubQoS"] = MqttVariable[Index][SystemVariable[j]]["PublishQos"];
                MQTTMapping["SubTopic"] = MqttVariable[Index][SystemVariable[j]]["SubscribeTopic"];
                MQTTMapping["SubQoS"] = MqttVariable[Index][SystemVariable[j]]["SubscribeQos"];
                MQTTMapping["DataType"] = JsonTransformXml.prototype._GetDataType_(SystemVariable[j].split("-")[1]);
                MQTTMapping["Property"] = JsonTransformXml.prototype._GetProperty_(SystemVariable[j].split("-")[0]);
                MQTTMapping["Retain"] = JsonTransformXml.prototype._GetRetainNumber_(MqttVariable[Index][SystemVariable[j]]["Retain"]);
                MQTTServiceTask["MQTTMapping"].push(MQTTMapping);
            }
        }
    } catch (error) {
        //console.error(`Error reading file: ${error}`);
    }
};

Judgment.prototype._IsSaveEipMasterModuleGlobalVariable_ = async function() 
{
	var Return = false;
	var Class = new LoadFile();
	
	try {
		var [Index, Module, Variable, Setting] = await Promise.all([
			Class._ReadFile_("./File/EIP_Module/Index.json", []),
			Class._ReadFile_("./File/EIP_Module/Module.json", {}),
			Class._ReadFile_("./File/EIP_Module/EipVariable.json", {}),
			Class._ReadFile_("./File/EIP_Module/EipSetting.json", {})
		]);
	
		if (JSON.stringify(Index) == JSON.stringify(Global_EipIndex) &&
			JSON.stringify(Module) == JSON.stringify(Global_EipModule) &&
			JSON.stringify(Variable) == JSON.stringify(Global_EipVariable) &&
			JSON.stringify(Setting) == JSON.stringify(Global_EipSetting)) {
			Return = true;
		}
	} catch (error) {
		//console.error("Error reading file:", error);
	}
	
	return Return;
}

Judgment.prototype._IsSaveXVModuleGlobalVariable_ = async function() 
{
    let Return = false;
    const Class = new LoadFile();
    
    try {
        const [Module, Variable] = await Promise.all([
            Class._ReadFile_("./File/XV_Module/Module.json", {}),
            Class._ReadFile_("./File/XV_Module/XVVariable.json", {})
        ]);
        
        if (Module && Variable &&
            JSON.stringify(Module) === JSON.stringify(Global_XVModule) &&
            JSON.stringify(Variable) === JSON.stringify(Global_XVVariable)) {
            Return = true;
        }
    } catch (error) {
        //console.error("Error reading files:", error);
    }
    
    return Return;
}

//Step
StepCommon.prototype._ChangeCurrentDivCss_ = function(that)
{
	$(that).css("border-bottom-color", "rgb(200,200,200)");
	$(that).css("color", "#000000");
};
StepCommon.prototype._ClearAllDivCss_ = function(DivId)
{
	var DivLength = $(DivId).find(".StepText").length;
	
	for(var i=0; i<DivLength; i++)
	{
		$(DivId).find(".StepText").eq(i).css("border-bottom-color", "rgb(251, 251, 251)");
		$(DivId).find(".StepText").eq(i).css("color", "rgb(112, 112, 112)");
	}
};
StepCommon.prototype._ChangeDivCss_ = function(that, DivId)
{
	StepCommon.prototype._ClearAllDivCss_(DivId);
	StepCommon.prototype._ChangeCurrentDivCss_(that);
};

//Menu
MenuCommon.prototype._RestorePageSize_ = function(that)
{
	$("#Main_Center-Content").css("border-left-width", "1px");
	$("#Main_Center-Content").css("width", "795px");
	$("#Main_Left-List").show();
};
MenuCommon.prototype._ChangeMouseoutDivCss_ = function(that)
{
	var color = $(that).css("border-bottom-color"); 
	if(color != "rgb(57, 93, 139)")
	{
		$(that).css("color", "rgb(112, 112, 112)");
		$(that).css("cursor", "default");
	}
};
MenuCommon.prototype._ChangeMouseoutDivCss_ = function(that)
{
	var color = $(that).css("border-bottom-color"); 
	if(color != "rgb(57, 93, 139)")
	{
		$(that).css("color", "rgb(112, 112, 112)");
		$(that).css("cursor", "default");
	}
};
MenuCommon.prototype._ChangeMouseoverDivCss_ = function(that)
{
	$(that).css("color", "#000000");
	$(that).css("cursor", "pointer");
};
MenuCommon.prototype._ChangeCurrentDivCss_ = function(that)
{
	$(that).css("border-bottom-color", "rgb(57, 93, 139)");
	$(that).css("color", "#000000");
};
MenuCommon.prototype._ClearAllDivCss_ = function(DivId)
{
	var DivLength = $(DivId).children("div").length;
	
	for(var i=0; i<DivLength; i++)
	{
		$(DivId).children("div").eq(i).css("border-bottom-color", "rgb(251, 251, 251)");
		$(DivId).children("div").eq(i).css("color", "rgb(112, 112, 112)");
	}
};
MenuCommon.prototype._ChangeDivCss_ = function(that, DivId)
{
	MenuCommon.prototype._ClearAllDivCss_(DivId);
	MenuCommon.prototype._ChangeCurrentDivCss_(that);
};
MenuCommon.prototype._LoadLeftListHtml_ = function(DivId, HtmlPath, Async)
{
	$(DivId).css('pointer-events', "none");
	$(DivId).css('opacity', 0.5);
	$(DivId).empty();
	var Class = new LoadHtml();  var Html;
	if(Async == true)
	{
		Html = {Input:null};
		Class.ReadTranslateAfterOfHtml(HtmlPath, Html);
		var SetInterval = setInterval(function(){
			if(Html["Input"] != null){
				clearInterval(SetInterval);
				$(DivId).append(Html["Input"]);
				$(DivId).css("width", "215px");
				$(DivId).css('opacity', 1);
				$(DivId).css('pointer-events', "visible");
			}
		},500);
	}
	else{
		Html = Class.ReadTranslateAfterOfHtml(HtmlPath);
		$(DivId).append(Html);
		$(DivId).css("width", "215px");
		$(DivId).css('opacity', 1);
		$(DivId).css('pointer-events', "visible");
	}
};

MenuCommon.prototype._LoadContentHtml_ = function(DivId, HtmlPath, Async)
{
	$(DivId).css('pointer-events', "none");
	$(DivId).css('opacity', 0.5);
	$(DivId).empty();
	var Class = new LoadHtml();  var Html;
	if(Async == true){
		Html = {Input:null};
		Class.ReadTranslateAfterOfHtml(HtmlPath, Html);
		var SetInterval = setInterval(function(){
			if(Html["Input"] != null){
				clearInterval(SetInterval);
				$(DivId).append(Html["Input"]);
				$(DivId).css("width", "795px");
				$(DivId).css('opacity', 1);
				$(DivId).css('pointer-events', "visible");
			}
		},500);
	}
	else{
		Html = Class.ReadTranslateAfterOfHtml(HtmlPath);
		$(DivId).append(Html);
		$(DivId).css("width", "795px");
		$(DivId).css("border-left", "1px solid #DBDBDB");
		$(DivId).css('opacity', 1);
		$(DivId).css('pointer-events', "visible");
	}
};

MenuCommon.prototype._LoadHtml_ = function(DivId, Html)
{
	var Class = new LoadHtml();
	$(DivId).css('pointer-events', "none");
	$(DivId).css('opacity', 0.5);
	$(DivId).empty();
	Html = LoadHtml.prototype._TranslateHtml_(Html);
	$(DivId).append(Html);
	if(DivId == "#Main_Left-List")
	{
		$(DivId).css("width", "215px");
		$(DivId).css('opacity', 1);
		$(DivId).css('pointer-events', "visible");		
	}
	else if(DivId == "#Main_Center-Content")
	{
		$(DivId).css("width", "795px");
		$(DivId).css("border-left", "1px solid #DBDBDB");
		$(DivId).css('opacity', 1);
		$(DivId).css('pointer-events', "visible");
	}
};
//List
ListCommon.prototype._ChangeCurrentDivCss_ = function(that)
{
	$(that).css("border-left-color", "rgb(57, 93, 139)");
	$(that).css("color", "#000000");
};
ListCommon.prototype._ClearAllDivCss_ = function(DivId)
{
	var DivLength = $(DivId).children("div").length;
	
	for(var i=0; i<DivLength; i++)
	{
		$(DivId).children("div").eq(i).css("border-left-color", "rgb(251, 251, 251)");
		$(DivId).children("div").eq(i).css("color", "rgb(112, 112, 112)");
	}
};
ListCommon.prototype._ChangeMouseoutDivCss_ = function(that)
{
	var color = $(that).css("border-left-color"); 
	if(color != "rgb(57, 93, 139)")
	{
		$(that).css("color", "rgb(112, 112, 112)");
		$(that).css("cursor", "default");
	}
};
ListCommon.prototype._ChangeMouseoverDivCss_ = function(that)
{
	$(that).css("color", "#000000");
	$(that).css("cursor", "pointer");
};
ListCommon.prototype._ChangeDivCss_ = function(that, DivId)
{
	ListCommon.prototype._ClearAllDivCss_(DivId);
	ListCommon.prototype._ChangeCurrentDivCss_(that);
};

ListCommon.prototype._SaveMasterTcpModule_ = async function() 
{
    const Class = new LoadFile();
    
    try {
        const [Index, Module, Variable, Setting] = await Promise.all([
            Class._ReadFile_("./File/TCP_Module/Index.json", {}),
            Class._ReadFile_("./File/TCP_Module/Module.json", {}),
            Class._ReadFile_("./File/TCP_Module/TcpVariable.json", {}),
            Class._ReadFile_("./File/TCP_Module/TcpSetting.json", {})
        ]);
        
        if (!(JSON.stringify(Index) === JSON.stringify(Global_TcpIndex) &&
              JSON.stringify(Module) === JSON.stringify(Global_TcpModule) &&
              JSON.stringify(Variable) === JSON.stringify(Global_TcpVariable) &&
              JSON.stringify(Setting) === JSON.stringify(Global_TcpSetting))) {
            main_TcpModuleSaveButton_click();
        }
    } catch (error) {
        //console.error(`Error reading files: ${error}`);
    }
};


ListCommon.prototype._SaveMasterRtuModule_ = async function() 
{
    const Class = new LoadFile();
    
    try {
        const [Index, Module, Variable, Setting] = await Promise.all([
            Class._ReadFile_("./File/RTU_Module/Index.json", {}),
            Class._ReadFile_("./File/RTU_Module/Module.json", {}),
            Class._ReadFile_("./File/RTU_Module/RtuVariable.json", {}),
            Class._ReadFile_("./File/RTU_Module/RtuSetting.json", {})
        ]);
        
        if (!(JSON.stringify(Index) === JSON.stringify(Global_RtuIndex) &&
              JSON.stringify(Module) === JSON.stringify(Global_RtuModule) &&
              JSON.stringify(Variable) === JSON.stringify(Global_RtuVariable) &&
              JSON.stringify(Setting) === JSON.stringify(Global_RtuSetting))) {
            main_RtuModuleSaveButton_click();
        }
    } catch (error) {
        //console.error(`Error reading files: ${error}`);
    }
};

ListCommon.prototype._SaveMqttModule_ = async function() 
{
    const Class = new LoadFile();
    
    try {
        const [Index, Module, Variable, Setting] = await Promise.all([
            Class._ReadFile_("./File/MQTT_Module/Index.json", {}),
            Class._ReadFile_("./File/MQTT_Module/Module.json", {}),
            Class._ReadFile_("./File/MQTT_Module/MqttVariable.json", {}),
            Class._ReadFile_("./File/MQTT_Module/MqttSetting.json", {})
        ]);
        
        if (!(JSON.stringify(Index) === JSON.stringify(Global_MqttIndex) &&
              JSON.stringify(Module) === JSON.stringify(Global_MqttModule) &&
              JSON.stringify(Variable) === JSON.stringify(Global_MqttVariable) &&
              JSON.stringify(Setting) === JSON.stringify(Global_MqttSetting))) {
            main_MqttModuleSaveButton_click();
        }
    } catch (error) {
        //console.error(`Error reading files: ${error}`);
    }
};


ListCommon.prototype._SaveRemoteBroker_ = async function() 
{
    const Class = new LoadFile();
    
    try {
        const RemoteBroker = await Class._ReadFile_("./File/IoT_Platform/RemoteBroker.json", {});
        if (JSON.stringify(RemoteBroker) !== JSON.stringify(Global_RemoteBroker)) {
            main_RemoteBrokerSaveButton_click();
        }
    } catch (error) {
        //console.error(`Error reading file: ${error}`);
    }
};

Judgment.prototype._IsSaveAsciiMasterModuleGlobalVariable_ = async function() 
{
    let Return = false;
    const Class = new LoadFile();
    
    try {
        const [Index, Module, Variable, Setting] = await Promise.all([
            Class._ReadFile_("./File/ASCII_Module/Index.json", {}),
            Class._ReadFile_("./File/ASCII_Module/Module.json", {}),
            Class._ReadFile_("./File/ASCII_Module/AsciiVariable.json", {}),
            Class._ReadFile_("./File/ASCII_Module/AsciiSetting.json", {})
        ]);
        
        if (JSON.stringify(Index) === JSON.stringify(Global_AsciiIndex) &&
            JSON.stringify(Module) === JSON.stringify(Global_AsciiModule) &&
            JSON.stringify(Variable) === JSON.stringify(Global_AsciiVariable) &&
            JSON.stringify(Setting) === JSON.stringify(Global_AsciiSetting)) {
            Return = true;
        }
    } catch (error) {
        //console.error(`Error reading files: ${error}`);
        return false;
    }
    
    return Return;
}

//Path
PathCommon.prototype._ChangeMouseoutDivCss_ = function(that)
{
	var color = $(that).css("border-bottom-color"); 
	if(color != "rgb(57, 93, 139)")
	{
		$(that).css("color", "rgb(112, 112, 112)");
		$(that).css("cursor", "default");
	}
};
PathCommon.prototype._ChangeMouseoverDivCss_ = function(that)
{
	$(that).css("color", "#000000");
	$(that).css("cursor", "pointer");
};

//LoadHtml
LoadHtml.prototype._ReadHtml_ = function(HtmlPath, Input)
{
	var Return = "";  var Async = false;
	if(typeof(Input) !== "undefined")  {Async = true;}
	$.ajax({
		url: HtmlPath,
		type:"GET",
		async: Async,
		cache:false,
		success: function(msg)
		{
			Return = msg;
			if(Async == true)
			{
				Input["Input"] = msg;
			}
		},
		error:function(xhr, ajaxOptions, thrownError)
		{
			//console.log("ajax error:["+xhr + ":" + ajaxOptions + ":" + thrownError+"]");
		}
	});
	return Return;
};
LoadHtml.prototype._TranslateHtml_ = function(Html)
{
	var OldIndex=0, NewIndex=0, NewHtml="";
	while((NewIndex = Html.indexOf("[$^", OldIndex)) > 0 && Html.indexOf("^$]", OldIndex) >0)
	{
		ReplaceHtml = Html.substring(Html.indexOf("[$^", OldIndex), Html.indexOf("^$]", OldIndex)+3);
		NewHtml = Html.substring(Html.indexOf("[$^", OldIndex)+3, Html.indexOf("^$]", OldIndex));
		Html = Html.replace(ReplaceHtml, Global_TranslateJson[NewHtml]);
		OldIndex = NewIndex;
	}
	return Html;
};
LoadHtml.prototype._ReadTranslateAfterOfHtml_ = function(HtmlPath, Input)
{
	var Return;
	if(typeof(Input) != "undefined")
	{
		Return = {Input:null};
		LoadHtml.prototype._ReadHtml_(HtmlPath, Return);
		var SetInterval = setInterval(function()
		{
			if(Return["Input"] != null)
			{
				clearInterval(SetInterval);
				var TranslateHtml = LoadHtml.prototype._TranslateHtml_(Return["Input"]);
				Input["Input"] = TranslateHtml;
			}
		},500);
	}
	else
	{
		Return = LoadHtml.prototype._ReadHtml_(HtmlPath);
		Return = LoadHtml.prototype._TranslateHtml_(Return);
	}
	return Return;
};
LoadHtml.prototype._GetVariableTranslationHtml_ = function(VariableHtml)
{
	var Class = new LoadHtml();
	VariableHtml = LoadHtml.prototype._TranslateHtml_(VariableHtml);
	return VariableHtml;
};

//LoadFile
LoadFile.prototype._ReadFile_ = async function (FilePath, NewType, Input) 
{
    return new Promise((resolve, reject) => {
        $.ajax({
            url: FilePath,
            type: "GET",
            async: true,
            cache: false,
            success: function (msg) {
                if (typeof (Input) !== "undefined") {
                    Input["Input"] = msg;
                }
                resolve(msg);
            },
            error: function (xhr, ajaxOptions, thrownError) {
                //console.log("ajax error: [" + xhr + ":" + ajaxOptions + ":" + thrownError + "]");
                if (typeof (Input) !== "undefined") {
                    Input["Input"] = NewType || {};
                }
                resolve(NewType || {});
            }
        });
    });
};


LoadFile.prototype._ReadXmlObject_ = function(FilePath, NewType, Input)
{
	var tree = new XML.ObjTree();
	var Return = "";
	$.ajax({
		url: FilePath,
		type:"GET",
		async: false,
		cache:false,
		dataType:"text",
		success: function(msg){
			Return = msg;
			if(typeof(Input) != "undefined")
			{
				Input["Input"] = tree.parseXML(msg);
			}
		},
		error:function(xhr, ajaxOptions, thrownError){
			//console.log("ajax error:["+xhr + ":" + ajaxOptions + ":" + thrownError+"]");
		}
	});
	Return = tree.parseXML(Return);
	if(Return == "" && typeof(NewType) != "undefined")
	{
		Return = NewType;
	}
	return Return;
};

LoadFile.prototype._ReadTranslateAfterOfFileJson_ = async function(FilePath, NewType) 
{
    let Return = "";
    const Class = new LoadFile();

    try {
        const File = await Class.ReadFile(FilePath, NewType);
        const ObjectString = JSON.stringify(File);
        const LoadHtmlClass = new LoadHtml();
        Return = LoadHtmlClass.TranslateHtml(ObjectString);
        Return = jQuery.parseJSON(Return);
        if (Return === "" && typeof(NewType) !== "undefined") {
            Return = NewType;
        }
    } catch (error) {
        //console.error(`Error reading file: ${error}`);
        if (typeof(NewType) !== "undefined") {
            Return = NewType;
        } else {
            Return = "";
        }
    }

    return Return;
};

LoadFile.prototype._GetWebAllLink_ = function()
{
	var Class = new Cgi();
	Class.RestApi("WebShell", new Array("LeftLisHtml.sh"), true, {"Input":null});
	Class.RestApi("WebShell", new Array("FunctionWizardHtml.sh"), true, {"Input":null});
	Class.RestApi("WebShell", new Array("StepFlowHtml.sh"), true, {"Input":null});
	Class.RestApi("WebShell", new Array("TopMenuHtml.sh"), true, {"Input":null});
	Class.RestApi("WebShell", new Array("Language"), true, {"Input":null});
	LoadFile.prototype._LoadHandmadeCss_();
	LoadFile.prototype._LoadGlobalVariable_();
	LoadFile.prototype._LoadHeadJs_();
	LoadFile.prototype._LoadJppJs_();
	LoadFile.prototype._LoadMainJs_();
};

LoadFile.prototype._LoadHandmadeCss_ = function()
{
	var Class = new Cgi();
	var Value = Class.RestApi("GetWebAllLink", new Array("css"), false);
	LoadFile.prototype._LoadCss_(Value);

	var Bar = new ProgressBar();
	setTimeout(function()
	{
		Bar.SetValue(22);
	},100);
};

LoadFile.prototype._LoadGlobalVariable_ = function()
{
	var Bar = new ProgressBar();
	var Result = {"Input": null};
	var Class = new Cgi();
	var Value = Class.RestApi("GetWebAllLink", new Array("GlobalVariable"), false);
	var SetInterval_1 = setInterval(function(){
		if(Bar.GetValue() == "22%")
		{
			clearInterval(SetInterval_1);
			LoadFile.prototype._LoadJavascript_(Value, Result);
		}
	},100);
	var SetInterval_2 = setInterval(function(){
		if(Result["Input"] == true)
		{
			clearInterval(SetInterval_2);
			Bar.SetValue(45);
		}
	},100);
};

LoadFile.prototype._LoadHeadJs_ = function()
{
	var Bar = new ProgressBar();
	var Result = {"Input": null};
	var Class = new Cgi();
	var Value = Class.RestApi("GetWebAllLink", new Array("head"), false);
	var SetInterval_1 = setInterval(function(){
		if(Bar.GetValue() == "45%")
		{
			clearInterval(SetInterval_1);
			LoadFile.prototype._LoadJavascript_(Value, Result);
		}
	},100);
	var SetInterval_2 = setInterval(function(){
		if(Result["Input"] == true)
		{
			clearInterval(SetInterval_2);
			Bar.SetValue(63);
		}
	},100);
};

LoadFile.prototype._LoadJppJs_ = function()
{
	var Bar = new ProgressBar();
	var Result = {"Input": null};
	var Class = new Cgi();
	var Value = Class.RestApi("GetWebAllLink", new Array("jpp"), false);
	var SetInterval_1 = setInterval(function(){
		if(Bar.GetValue() == "63%")
		{
			clearInterval(SetInterval_1);
			LoadFile.prototype._LoadJavascript_(Value, Result);
		}
	},100);
	var SetInterval_2 = setInterval(function(){
		if(Result["Input"] == true)
		{
			clearInterval(SetInterval_2);
			Bar.SetValue(81);
		}
	},100);
};

LoadFile.prototype._LoadMainJs_ = function()
{
	var Bar = new ProgressBar();
	var Result = {"Input": null};
	var Class = new Cgi();
	var Value = Class.RestApi("GetWebAllLink", new Array("Main"), false);
	var SetInterval_1 = setInterval(function(){
		if(Bar.GetValue() == "81%")
		{
			clearInterval(SetInterval_1);
			LoadFile.prototype._LoadJavascript_(Value, Result);
		}
	},100);
	var SetInterval_2 = setInterval(function(){
		if(Result["Input"] == true)
		{
			clearInterval(SetInterval_2);
			Bar.SetValue(100);
			main_Main_load();
		}
	},100);
};

LoadFile.prototype._LoadJavascript_ = function(LinkArray, Result)
{
	var Size = LinkArray.length;
	var Index = 1;
	var jsFile;
    for(var i=0; i<LinkArray.length; i++)
    {
    	//$.getScript(LinkArray[i]);
        jsFile = document.createElement("script");
        jsFile.setAttribute("type","text/javascript");
        jsFile.setAttribute("src", LinkArray[i]);
        jsFile.setAttribute("async", "false");
        document.getElementsByTagName("head")[0].appendChild(jsFile);
		jsFile.onload = jsFile.onreadystatechange = function(){
		if (!this.readyState || this.readyState === "loaded" || this.readyState === "complete" ){ 
			jsFile.onload = jsFile.onreadystatechange = null;
			Index = Index + 1;
		}};
    }
	var SetInterval = setInterval(function(){
	if(Index == Size)
	{
		Result["Input"] = true;
		clearInterval(SetInterval);
	}},100);
};

LoadFile.prototype._LoadCss_ = function(LinkArray)
{
    var cssFile;
    for(var i=0; i<LinkArray.length; i++)
    {
        cssFile = document.createElement("link");
		cssFile.type = 'text/css';
		cssFile.rel  = "stylesheet";
		cssFile.href = LinkArray[i];
        document.getElementsByTagName("head")[0].appendChild(cssFile);
    }
};

















//Type

Type.prototype.AllowedCharacters = function(input) {
    // 允許英文字母、數字和特定的特殊字符
    var regex = /^[a-zA-Z0-9!@#$%^&*()_+|~=`{} \[\] :";'<>?,.\/-]*$/;
    return regex.test(input);
};

Type.prototype._EnglishDigital_ = function(string)
{
    var Return=false;
	var re = /^.[A-Za-z0-9]+$/;
	if(re.test(string))
	{
		Return = true;
	}
	return Return;
};
Type.prototype._EnglishDigitalAndBottomline_ = function(string)
{
    var Return=false;
	var re = /^\w+$/;
	if(re.test(string))
	{
		Return = true;
	}
	return Return;
};
Type.prototype._CheckDomainIp_ = function(IP)
{
    var Return=false;
    var re = /^((\d)|(([1-9])\d)|(1\d\d)|(2(([0-4]\d)|5([0-5]))))\.((\d)|(([1-9])\d)|(1\d\d)|(2(([0-4]\d)|5([0-5]))))\.((\d)|(([1-9])\d)|(1\d\d)|(2(([0-4]\d)|5([0-5]))))\.((\d)|(([1-9])\d)|(1\d\d)|(2(([0-4]\d)|5([0-5]))))$/;
   	var re2 = /^((?:(?:(?:\w[\.\-\+]?)*)\w)+)((?:(?:(?:\w[\.\-\+]?){0,62})\w)+)\.(\w{2,6})$/;
	if( IP.match(re) || IP.match(re2) )
	{
		Return = true;
	}
	return Return;
};
Type.prototype._CheckIp_ = function(IP)
{
    var Return=false;
    var re = /^((\d)|(([1-9])\d)|(1\d\d)|(2(([0-4]\d)|5([0-5]))))\.((\d)|(([1-9])\d)|(1\d\d)|(2(([0-4]\d)|5([0-5]))))\.((\d)|(([1-9])\d)|(1\d\d)|(2(([0-4]\d)|5([0-5]))))\.((\d)|(([1-9])\d)|(1\d\d)|(2(([0-4]\d)|5([0-5]))))$/;
	if(IP.match(re))
	{
		Return = true;
	}
	return Return;
};
Type.prototype._CheckPositiveIntegersAndZero_ = function(number)
{
    var Return=false;
	var re = /^[1-9]d*|0$/;
	if(re.test(number))
	{
		Return = true;
	}
	return Return;
};
Type.prototype._CheckFloat_ = function(number)
{
    var Return=true;
	number = parseFloat(number);
	if(isNaN(number) == true)
	{
		Return = false;
	}
	return Return;
};
Type.prototype._CheckPositiveIntegers_ = function(number)
{
    var Return=false;
    var re = /^([0-9]*[1-9][0-9]*|0)$/;
	if(re.test(number))
	{
		Return = true;
	}
	return Return;
};
Type.prototype._CheckChineseLanguage_ = function(string)
{
    var Return=false;
    var re = /[\u4e00-\u9fa5]/;
	if(re.test(string))
	{
		Return = true;
	}
	return Return;
};
Type.prototype._CheckSpecialSymbols_ = function(string)
{
    var Return=false;
    var re = /[ !@#$%^&*()+=\{}|;,.\\\/<>?~`:\'\"\[\]]/;
	if(re.test(string))
	{
		Return = true;
	}
	re = /[^\x00-\xff]/;
	if(re.test(string))
	{
		Return = true;
	}
	return Return;
};
Type.prototype._CheckSpecialSymbols_ExcludeBottomLineBrackets_ = function(string)
{
    var Return=false;
    var re = /[ !@#$%^&*+=\{}|;,.\\\/<>?~`:\'\"\[\]]/;
	if(re.test(string))
	{
		Return = true;
	}
	re = /[^\x00-\xff]/;
	if(re.test(string))
	{
		Return = true;
	}
	return Return;
};
Type.prototype._CheckMqttTopic_ = function(string)
{
    var Return=true;
    var re = /[#+]/;
	if(re.test(string))
	{
		Return = false;
	}
	else if(string == "")
	{
		Return = false;
	}
	return Return;
};
Type.prototype._CheckModbusDataModelMaxQuantity_ = function(DataType, Quantity)
{
    var Return=Quantity;
	if((DataType=="CoilStatus" || DataType=="InputStatus") && Quantity > 2000)
	{
		Return=2000;
	}
	else if((DataType=="HoldingRegisters" || DataType=="InputRegisters") && Quantity > 125)
	{
		Return=125;
	}
	return Return;
};

Type.prototype._CheckMqttDataModelMaxQuantity_ = function(Quantity)
{
    var Return = Quantity;
	if(Quantity > 1000)
	{
		Return = 1000;
	}
	return Return;
};

// Type v6
Type.prototype._CheckIp_v6_ = function(IPv6IP)
{
    var regexExp = /(([0-9a-fA-F]{1,4}:){7,7}[0-9a-fA-F]{1,4}|([0-9a-fA-F]{1,4}:){1,7}:|([0-9a-fA-F]{1,4}:){1,6}:[0-9a-fA-F]{1,4}|([0-9a-fA-F]{1,4}:){1,5}(:[0-9a-fA-F]{1,4}){1,2}|([0-9a-fA-F]{1,4}:){1,4}(:[0-9a-fA-F]{1,4}){1,3}|([0-9a-fA-F]{1,4}:){1,3}(:[0-9a-fA-F]{1,4}){1,4}|([0-9a-fA-F]{1,4}:){1,2}(:[0-9a-fA-F]{1,4}){1,5}|[0-9a-fA-F]{1,4}:((:[0-9a-fA-F]{1,4}){1,6})|:((:[0-9a-fA-F]{1,4}){1,7}|:)|fe80:(:[0-9a-fA-F]{0,4}){0,4}%[0-9a-zA-Z]{1,}|::(ffff(:0{1,4}){0,1}:){0,1}((25[0-5]|(2[0-4]|1{0,1}[0-9]){0,1}[0-9])\.){3,3}(25[0-5]|(2[0-4]|1{0,1}[0-9]){0,1}[0-9])|([0-9a-fA-F]{1,4}:){1,4}:((25[0-5]|(2[0-4]|1{0,1}[0-9]){0,1}[0-9])\.){3,3}(25[0-5]|(2[0-4]|1{0,1}[0-9]){0,1}[0-9]))/gi;
	return regexExp.test(IPv6IP);
};






Dialog.prototype._CommonEnabled_ = function()
{
	$("#Main_Top-FunctionWizard").css('pointer-events', "visible");			$("#Main_Top-FunctionWizard").css('opacity', 1);
	$("#Main_Top-StepFlow").css('pointer-events', "visible");		$("#Main_Top-StepFlow").css('opacity', 1);
	$("#Main_Top-Menu").css('pointer-events', "visible");			$("#Main_Top-Menu").css('opacity', 1);
	$("#Main_Top-Path").css('pointer-events', "visible");			$("#Main_Top-Path").css('opacity', 1);
	$("#Main_Left-List").css('pointer-events', "visible");			$("#Main_Left-List").css('opacity', 1);
	$("#Main_Right-List").css('pointer-events', "visible");			$("#Main_Right-List").css('opacity', 1);
	$("#Main_Bottom-Information").css('pointer-events', "visible");	$("#Main_Bottom-Information").css('opacity', 1);
};
Dialog.prototype._CommonDisabled_ = function()
{
	$("#Main_Top-FunctionWizard").css('pointer-events', "none");			$("#Main_Top-FunctionWizard").css('opacity', 0.5);
	$("#Main_Top-StepFlow").css('pointer-events', "none");		$("#Main_Top-StepFlow").css('opacity', 0.5);
	$("#Main_Top-Menu").css('pointer-events', "none");			$("#Main_Top-Menu").css('opacity', 0.5);
	$("#Main_Top-Path").css('pointer-events', "none");			$("#Main_Top-Path").css('opacity', 0.5);
	$("#Main_Left-List").css('pointer-events', "none");			$("#Main_Left-List").css('opacity', 0.5);
	$("#Main_Right-List").css('pointer-events', "none");		$("#Main_Right-List").css('opacity', 0.5);
	$("#Main_Bottom-Information").css('pointer-events', "none");$("#Main_Bottom-Information").css('opacity', 0.5);
};

GetValue.prototype._GetRuntimeVariableName_ = function(ModuleType, ModuleIndex, VariableIndex)
{
	var Return;
	var GlobalModule=GetValue.prototype._GetGlobalModule_(ModuleType);
	var GlobalVariable=GetValue.prototype._GetGlobalVariable_(ModuleType);
	if(ModuleType == "Internal") 
	{
		var ModuleName = GetValue.prototype._GetRegisterModuleName_(GlobalModule, ModuleIndex);
	}
	else if(ModuleType == "EIP")
	{
		var ModuleName = Global_EipSetting[ModuleIndex].NickName;
	}
	else if(ModuleType == "XV")
	{
		var ModuleName = GlobalModule.Name;
	}
	else
	{
		var ModuleName=GetValue.prototype._GetModuleName_(GlobalModule, ModuleIndex);
	}
	var VariabName=GetValue.prototype._GetModuleVariableName_(GlobalVariable, ModuleIndex, VariableIndex);
	if(ModuleType == "Internal")
	{
		Return=ModuleType+"_No."+ModuleIndex+"_"+ModuleName+"."+VariabName;
	}
	else if(ModuleType == "XV")
	{
		Return="XVBoard_"+ModuleName+"."+VariableIndex.split("-")[0]+"."+VariabName;
	}
	else
	{
		Return=ModuleType+"_No."+ModuleIndex+"_"+ModuleName+"_"+VariableIndex.split("-")[0]+"."+VariabName;
	}
	return Return;
};

GetValue.prototype._GetRuntimeScalingVariableName_ = function(ModuleType, ModuleIndex, VariableIndex)
{
	var Return; var GlobalVariable;
	if( ModuleType == "MRTU" ) GlobalVariable = Global_RtuScalingVariable;
	if( ModuleType == "MTCP" ) GlobalVariable = Global_TcpScalingVariable;
	var GlobalModule=GetValue.prototype._GetGlobalModule_(ModuleType);
	var ModuleName=GetValue.prototype._GetModuleName_(GlobalModule, ModuleIndex);
	var VariabName=GetValue.prototype._GetModuleScalingVariableName_(GlobalVariable, ModuleIndex, VariableIndex);
	Return=ModuleType+"_No."+ModuleIndex+"_"+ModuleName+"_"+VariableIndex.split("-")[0]+"_Scale"+"."+VariabName;
	return Return;
};
GetValue.prototype._GetRuntimeBitwiseVariableName_ = function(BitwiseTag, ModuleType, ModuleIndex, VariableIndex)
{
	var Return; var GlobalVariable;
	if( ModuleType == "MRTU" ) GlobalVariable = Global_RtuBitwiseVariable;
	if( ModuleType == "MTCP" ) GlobalVariable = Global_TcpBitwiseVariable;
	var GlobalModule=GetValue.prototype._GetGlobalModule_(ModuleType);
	var ModuleName=GetValue.prototype._GetModuleName_(GlobalModule, ModuleIndex);
	var VariabNameExist=GetValue.prototype._GetModuleBitwiseVariableName_(GlobalVariable, BitwiseTag, ModuleIndex, VariableIndex);
	if(VariabNameExist == true) var VariabName = BitwiseTag;
	else                        return Return;
	Return=ModuleType+"_No."+ModuleIndex+"_"+ModuleName+"_"+VariableIndex.split("-")[0]+"_Bitwise"+"."+VariabName;
	return Return;
};
GetValue.prototype._GetModuleAllDeviceName_ = function(GlobalModule)
{
	var Return=new Array();
	if(typeof(GlobalModule) != "object")	{return 0;}
	var Return=Object.keys(GlobalModule);
	return Return;
};
GetValue.prototype._GetModuleDeviceName_ = function(GlobalModule, ModuleNumber)
{
	var Return;
	if(typeof(GlobalModule) != "object")	{return 0;}
	var DeviceName=Object.keys(GlobalModule);
	for(var i=0; i<DeviceName.length; i++)
	{
		var array=Object.keys(GlobalModule[DeviceName[i]]);
		if(array.indexOf(ModuleNumber) != -1)
		{
			Return=DeviceName[i];
		}
	}
	return Return;
};
GetValue.prototype._GetModuleAllNumber_ = function(GlobalModule)
{
	var Return=new Array();
	if(typeof(GlobalModule) != "object")	{return 0;}
	var AllDevice=Object.keys(GlobalModule);
	for(var i=0; i<AllDevice.length; i++)
	{
		var number=Object.keys(GlobalModule[AllDevice[i]]);
		Return = Return.concat(number);
	}
	return Return;
};
GetValue.prototype._GetModuleName_ = function(GlobalModule, ModuleNumber)
{
	var Return="";
	if(typeof(GlobalModule) != "object")	{return Return;}

	var AllDevice=Object.keys(GlobalModule);
	for(var i=0; i<AllDevice.length; i++)
	{
		var number=Object.keys(GlobalModule[AllDevice[i]]);
		for(var j=0; j<number.length; j++)
		{
			if(number[j].indexOf(ModuleNumber) != -1)
			{
				Return=GlobalModule[AllDevice[i]][number[j]]["ModuleName"];
				return Return;
			}
		}
	}
};
GetValue.prototype._GetRegisterModuleName_ = function(GlobalModule, ModuleNumber)
{
	var Return="";
	if(typeof(GlobalModule) != "object")	{return Return;}

		var number=Object.keys(GlobalModule);
		for(var j=0; j<number.length; j++)
		{
			if(number[j].indexOf(ModuleNumber) != -1)
			{
				Return=GlobalModule[number[j]]["ModuleName"];
				return Return;
			}
		}

};
GetValue.prototype._GetGlobalModule_ = function(ModuleType)
{
	var Return;
	if(ModuleType=="MRTU")			{Return=Global_RtuModule;}
	else if(ModuleType=="MTCP")		{Return=Global_TcpModule;}
	else if(ModuleType=="MASCII")	{Return=Global_AsciiModule;}
	else if(ModuleType=="MQTT")		{Return=Global_MqttModule;}
	else if(ModuleType=="EIP")		{Return=Global_EipModule;}
	else if(ModuleType=="XV")		{Return=Global_XVModule;}
	else if(ModuleType=="Internal")	{Return=Global_RegisterModule;}
	else if(ModuleType=="MRTU Scaling")	{Return=Global_RtuModule;}
	else if(ModuleType=="MTCP Scaling")	{Return=Global_TcpModule;}
	return Return;
};
GetValue.prototype._GetGlobalVariable_ = function(ModuleType)
{
	var Return;
	if(ModuleType=="MRTU")			{Return=Global_RtuVariable;}
	else if(ModuleType=="MTCP")		{Return=Global_TcpVariable;}
	else if(ModuleType=="MASCII")	{Return=Global_AsciiVariable;}
	else if(ModuleType=="MQTT")		{Return=Global_MqttVariable;}
	else if(ModuleType=="EIP")		{Return=Global_EipVariable;}
	else if(ModuleType=="XV")		{Return=Global_XVVariable;}
	else if(ModuleType=="Internal")	{Return=Global_RegisterVariable;}
	else if(ModuleType=="MRTU Scaling")	{Return=Global_RtuScalingVariable;}
	else if(ModuleType=="MTCP Scaling")	{Return=Global_TcpScalingVariable;}
	return Return;
};
GetValue.prototype._GetModuleVariableAttribute_ = function(Attribute, Type)
{
	var Return;
	if(Attribute=="Read" && Type=="Bool")               {Return="DI";}
	else if(Attribute=="ReadWrite" && Type=="Bool")     {Return="DO";}
	else if(Attribute=="Read" && Type!="Bool")          {Return="AI";}
	else if(Attribute=="ReadWrite" && Type!="Bool")     {Return="AO";}
	return Return;
};
GetValue.prototype._GetModuleVariableReadWrite_ = function(Attribute)
{
	var Return;
	if(Attribute=="DI")        {Return="Read";}
	else if(Attribute=="DO")   {Return="ReadWrite";}
	else if(Attribute=="AI")   {Return="Read";}
	else if(Attribute=="AO")   {Return="ReadWrite";}
	return Return;
};
GetValue.prototype._GetModuleVariableIndex_ = function(GlobalVariable, ModuleNumber, PrefixVariableIndex, VariableName)
{
	var Return="";
	if(typeof(GlobalVariable) != "object" || 
	   typeof(GlobalVariable[ModuleNumber]) != "object")
	{
		return Return;
	}
	var VariableList=Object.keys(GlobalVariable[ModuleNumber]);
	for(var i=0; i<VariableList.length; i++)
	{
		var Name=GlobalVariable[ModuleNumber][VariableList[i]]["VariableName"];
		if(Name == VariableName && VariableList[i].indexOf(PrefixVariableIndex)!=-1)
		{
			Return=VariableList[i];
			break;
		}
	}
	return Return;
};
GetValue.prototype._GetModuleAllVariableIndex_ = function(ModuleType, ModuleNumber)
{
	var GlobalVariable=GetValue.prototype._GetGlobalVariable_(ModuleType);
	if(typeof(GlobalVariable[ModuleNumber]) != "object"){return 0;}
	
	var Class=new Algorithm();
	var Return=Object.keys(GlobalVariable[ModuleNumber]).sort(Class.StringNumberMixedSort());
	return Return;
};
GetValue.prototype._GetModuleVariableName_ = function(GlobalVariable, ModuleNumber, VariableIndex)
{
	var Return="";
	var array=VariableIndex.split("-");
	if(array.length != 3)
	{
		return Return;
	}
	var VariableList=Object.keys(GlobalVariable[ModuleNumber]);
	for(var i=0; i<VariableList.length; i++)
	{
		if(VariableList[i].indexOf(VariableIndex) != -1)
		{
			Return=GlobalVariable[ModuleNumber][VariableList[i]]["VariableName"];
			break;
		}
	}
	return Return;
};
GetValue.prototype._GetModulePidScalingVariableName_ = function(GlobalVariable, ModuleNumber, VariableIndex)
{
	var Return="";
	var array=VariableIndex.split(".");
	if(array.length != 2)
	{
		return Return;
	}
	var VariableList=Object.keys(GlobalVariable[ModuleNumber]);
	for(var i=0; i<VariableList.length; i++)
	{
		if(VariableList[i].indexOf(array[0]) != -1)
		{
			Return=GlobalVariable[ModuleNumber][VariableList[i]]["ScaleVariableName"];
			break;
		}
	}
	return Return;
};
GetValue.prototype._GetModuleScalingVariableName_ = function(GlobalVariable, ModuleNumber, VariableIndex)
{
 var Return="";
 var array=VariableIndex.split("-");
 if(array.length != 3)
 {
  return Return;
 }
 var VariableList=Object.keys(GlobalVariable[ModuleNumber]);
 for(var i=0; i<VariableList.length; i++)
 {
  if(VariableList[i].indexOf(VariableIndex) != -1)
  {
   Return=GlobalVariable[ModuleNumber][VariableList[i]]["ScaleVariableName"];
   break;
  }
 }
 return Return;
};


GetValue.prototype._GetBitwiseVariableFromGlobal_ = function(GlobalVariable, BitwiseTag)
{
	var Return=""; var BitNameId="";
	var ObjectKey = Object.keys(GlobalVariable);
	for(var i=0; i<ObjectKey.length; i++)
	{
		if(GlobalVariable[ObjectKey[i]] == BitwiseTag)
		{
			Return = BitwiseTag;
			break;
		}
	}
	return Return;
};
GetValue.prototype._GetModuleBitwiseVariableName_ = function(GlobalVariable, BitwiseTag, ModuleIndex, VariableIndex)
{
	var Return=false; 
	var VariableName; var Index = 0;
	var array=VariableIndex.split("-");
	if(array.length != 3)
	{
		return Return;
	}
	var VariableList=Object.keys(GlobalVariable[ModuleIndex]);
	for(var i=0; i<VariableList.length; i++)
	{
		if(VariableList[i].indexOf(VariableIndex) != -1)
		{
			VariableName = GetValue.prototype._GetBitwiseVariableFromGlobal_(GlobalVariable[ModuleIndex][VariableIndex], BitwiseTag);
			if( (VariableName != null) && (VariableName != '') )
			{
				Return=true;
				break;
			}
		}
	}
	return Return;
};
GetValue.prototype._GetModuleVariableNameArray_ = function(GlobalVariable, ModuleNumber, VariableIndex)
{
	var Return=new Array();
	if(typeof(GlobalVariable) != "object" || 
	   typeof(GlobalVariable[ModuleNumber]) != "object")
	{
		return Return;
	}
	var array=VariableIndex.split("-");
	if(array.length != 3)
	{
		return Return;
	}
	VariableIndex=array[0]+"-"+array[1]+"-";
	var VariableList=Object.keys(GlobalVariable[ModuleNumber]);
	for(var i=0; i<VariableList.length; i++)
	{
		if(VariableList[i].indexOf(VariableIndex) != -1)
		{
			Return.push(GlobalVariable[ModuleNumber][VariableList[i]]["VariableName"]);
		}
	}
	return Return;
};
GetValue.prototype._GetModuleAllVariableName_ = function(ModuleType, ModuleNumber, VariableIndexArray)
{
	var Return=new Array();
	var GlobalVariable=GetValue.prototype._GetGlobalVariable_(ModuleType);
	for(var i=0; i<VariableIndexArray.length; i++)
	{
		var VariableName=GlobalVariable[ModuleNumber][VariableIndexArray[i]]["VariableName"];
		Return.push(VariableName);
	}
	return Return;
};
GetValue.prototype._GetArrayComplement_ = function(FirstArray, SecondArray)
{
	var Return=new Array();
	for(var i=0; i<FirstArray.length; i++){
		if(SecondArray.indexOf(FirstArray[i]) == -1){
			Return.push(FirstArray[i]);
		}
	}
	return Return;
};
GetValue.prototype._GetArrayInteraction_ = function(FirstArray, SecondArray)
{
	var Return=new Array();
	for(var i=0; i<FirstArray.length; i++){
		if(SecondArray.indexOf(FirstArray[i]) != -1){
			Return.push(FirstArray[i]);
		}
	}
	return Return;
};

function sendTransmissionJson(ssocket, Command, string) 
{
    return new Promise((resolve) => {
        const transmission = new Transmission();
        transmission._TransmissionJson_(ssocket, Command, string, function() {
            resolve();
        });
    });
}

GetValue.prototype._ComPortCallback_ = async function(ssocket) 
{
    var JsonString1 = JSON.stringify(Global_ComPort);
    await sendTransmissionJson(ssocket, "SaveComPortSetting", JsonString1);
};

GetValue.prototype._RtuModuleCallback_ = async function(ssocket) 
{
    var JsonString1 = JSON.stringify(Global_RtuIndex);
    var JsonString2 = JSON.stringify(Global_RtuModule);
    var JsonString3 = JSON.stringify(Global_RtuVariable);
    var JsonString4 = JSON.stringify(Global_RtuSetting);

    await sendTransmissionJson(ssocket, "SaveRtuSetting", JsonString4);
    await sendTransmissionJson(ssocket, "SaveRtuVariable", JsonString3);
    await sendTransmissionJson(ssocket, "SaveRtuModule", JsonString2);
    await sendTransmissionJson(ssocket, "SaveRtuIndex", JsonString1);
};

GetValue.prototype._TcpModuleCallback_ = async function(ssocket) 
{
    var JsonString1 = JSON.stringify(Global_TcpIndex);
    var JsonString2 = JSON.stringify(Global_TcpModule);
    var JsonString3 = JSON.stringify(Global_TcpVariable);
    var JsonString4 = JSON.stringify(Global_TcpSetting);

    await sendTransmissionJson(ssocket, "SaveTcpSetting", JsonString4);
    await sendTransmissionJson(ssocket, "SaveTcpVariable", JsonString3);
    await sendTransmissionJson(ssocket, "SaveTcpModule", JsonString2);
    await sendTransmissionJson(ssocket, "SaveTcpIndex", JsonString1);
};

GetValue.prototype._AsciiModuleCallback_ = async function(ssocket) 
{
    var JsonString1 = JSON.stringify(Global_AsciiIndex);
    var JsonString2 = JSON.stringify(Global_AsciiModule);
    var JsonString3 = JSON.stringify(Global_AsciiVariable);
    var JsonString4 = JSON.stringify(Global_AsciiSetting);

    await sendTransmissionJson(ssocket, "SaveAsciiSetting", JsonString4);
    await sendTransmissionJson(ssocket, "SaveAsciiVariable", JsonString3);
    await sendTransmissionJson(ssocket, "SaveAsciiModule", JsonString2);
    await sendTransmissionJson(ssocket, "SaveAsciiIndex", JsonString1);
};

GetValue.prototype._MqttModuleCallback_ = async function(ssocket) 
{
    var JsonString1 = JSON.stringify(Global_MqttIndex);
    var JsonString2 = JSON.stringify(Global_MqttModule);
    var JsonString3 = JSON.stringify(Global_MqttVariable);
    var JsonString4 = JSON.stringify(Global_MqttSetting);

    await sendTransmissionJson(ssocket, "SaveMqttSetting", JsonString4);
    await sendTransmissionJson(ssocket, "SaveMqttVariable", JsonString3);
    await sendTransmissionJson(ssocket, "SaveMqttModule", JsonString2);
    await sendTransmissionJson(ssocket, "SaveMqttIndex", JsonString1);
};

GetValue.prototype._AllModuleToOpcuaCallback_ = async function(ssocket) 
{
    var JsonString1 = JSON.stringify(Global_RtuToOpcuaVariable);
    var JsonString2 = JSON.stringify(Global_TcpToOpcuaVariable);
    var JsonString3 = JSON.stringify(Global_AsciiToOpcuaVariable);

    await sendTransmissionJson(ssocket, "SaveAsciiToOpcuaVariable", JsonString3);
    await sendTransmissionJson(ssocket, "SaveTcpToOpcuaVariable", JsonString2);
    await sendTransmissionJson(ssocket, "SaveRtuToOpcuaVariable", JsonString1);
};

GetValue.prototype._PidOperationCallback_ = async function(ssocket) 
{
    var JsonString1 = JSON.stringify(Global_PidOperation);
    await sendTransmissionJson(ssocket, "SavePidOperationVariable", JsonString1);
};

GetValue.prototype._IftttConditionTriggerCallback_ = async function(ssocket) 
{
    var JsonString1 = JSON.stringify(Global_IftttConditionTriggerSetting);
    var JsonString2 = JSON.stringify(Global_IftttConditionTriggerVariable);

    await sendTransmissionJson(ssocket, "SaveIftttConditionTriggerVariable", JsonString2);
    await sendTransmissionJson(ssocket, "SaveIftttConditionTriggerSetting", JsonString1);
};

GetValue.prototype._VariableTableXmlCallback_ = async function(ssocket) 
{
    var ClassXml = new JsonTransformXml();
    var Xml = await ClassXml.TransformVariableXml();
    await sendTransmissionJson(ssocket, "SaveVariableTableXml", Xml);
};

GetValue.prototype._ModbusDriCallback_ = async function(ssocket) 
{
    var ClassXml = new JsonTransformXml();
    var Xml = await ClassXml.TransformModbusDri();
    await sendTransmissionJson(ssocket, "SaveModbusDri", Xml);
};

GetValue.prototype._UAServerDataXmlCallback_ = async function(ssocket) 
{
    var ClassXml = new JsonTransformXml();
    var Xml = await ClassXml.TransformUAServerDataXml();
    await sendTransmissionJson(ssocket, "SaveUAServerDataXml", Xml);
};

GetValue.prototype._PidDriverDriCallback_ = async function(ssocket) 
{
    var ClassXml = new JsonTransformXml();
    var Xml = await ClassXml.TransformPidDriverDri();
    await sendTransmissionJson(ssocket, "SavePidDriverDri", Xml);
};

GetValue.prototype._MethodTableXmlCallback_ = async function(ssocket) 
{
    var ClassXml = new JsonTransformXml();
    var Xml = await ClassXml.TransformMethodTableXml();
    await sendTransmissionJson(ssocket, "SaveMethodTableXml", Xml);
};

GetValue.prototype._MqttServiceXmlCallback_ = async function(ssocket) 
{
    var ClassXml = new JsonTransformXml();
    var Xml = await ClassXml.TransformMqttServiceXml();
    await sendTransmissionJson(ssocket, "SaveMQTTServiceXml", Xml);
};

GetValue.prototype._MqttDriCallback_ = async function(ssocket) 
{
    var ClassXml = new JsonTransformXml();
    var Xml = await ClassXml.TransformMqttDri();
    await sendTransmissionJson(ssocket, "SaveMqttDri", Xml);
};

GetValue.prototype._CgiUrl_ = function()
{
	var PathName = location.pathname;
	var Return = "";
	if(PathName == "/" || PathName == "/Main.html")
	{
		Return = location.protocol+"//"+location.host+"/";
	}
	else
	{
		Return = location.protocol+"//"+location.hostname+PathName.replace("Main.html","");
	}
	return Return;
};

GetValue.prototype._SocketIo_ = function()
{
	var PathName = location.pathname;
	var Return = "";
	if(PathName == "/" || PathName == "/Main.html")
	{
		Return = io.connect();
	}
	else
	{
		PathName = PathName.replace("Main.html","") + 'socket.io';
		Return = io.connect(location.origin, {"path": PathName.toString(), "transports":['polling', "xhr-polling"]});
	}
	return Return;
};

Judgment.prototype._IsSaveRtuMasterModuleGlobalVariable_ = async function() 
{
    let Return = false;
    const Class = new LoadFile();
    
    try {
        const [Index, Module, Variable, Setting] = await Promise.all([
            Class._ReadFile_("./File/RTU_Module/Index.json", {}),
            Class._ReadFile_("./File/RTU_Module/Module.json", {}),
            Class._ReadFile_("./File/RTU_Module/RtuVariable.json", {}),
            Class._ReadFile_("./File/RTU_Module/RtuSetting.json", {})
        ]);
        
        if (JSON.stringify(Index) === JSON.stringify(Global_RtuIndex) &&
            JSON.stringify(Module) === JSON.stringify(Global_RtuModule) &&
            JSON.stringify(Variable) === JSON.stringify(Global_RtuVariable) &&
            JSON.stringify(Setting) === JSON.stringify(Global_RtuSetting)) {
            Return = true;
        }
    } catch (error) {
        //console.error(`Error reading files: ${error}`);
        return false;
    }
    
    return Return;
}

Judgment.prototype._IsSaveTcpMasterModuleGlobalVariable_ = async function() {
    let Return = false;
    const Class = new LoadFile();
    
    try {
        const [Index, Module, Variable, Setting] = await Promise.all([
            Class._ReadFile_("./File/TCP_Module/Index.json", {}),
            Class._ReadFile_("./File/TCP_Module/Module.json", {}),
            Class._ReadFile_("./File/TCP_Module/TcpVariable.json", {}),
            Class._ReadFile_("./File/TCP_Module/TcpSetting.json", {})
        ]);
        
        if (JSON.stringify(Index) === JSON.stringify(Global_TcpIndex) &&
            JSON.stringify(Module) === JSON.stringify(Global_TcpModule) &&
            JSON.stringify(Variable) === JSON.stringify(Global_TcpVariable) &&
            JSON.stringify(Setting) === JSON.stringify(Global_TcpSetting)) {
            Return = true;
        }
    } catch (error) {
        //console.error(`Error reading files: ${error}`);
        return false;
    }
    
    return Return;
}
Judgment.prototype._IsSaveAsciiMasterModuleGlobalVariable_ = async function() 
{
    let Return = false;
    const Class = new LoadFile();
    
    try {
        const [Index, Module, Variable, Setting] = await Promise.all([
            Class._ReadFile_("./File/ASCII_Module/Index.json", {}),
            Class._ReadFile_("./File/ASCII_Module/Module.json", {}),
            Class._ReadFile_("./File/ASCII_Module/AsciiVariable.json", {}),
            Class._ReadFile_("./File/ASCII_Module/AsciiSetting.json", {})
        ]);
        
        if (JSON.stringify(Index) === JSON.stringify(Global_AsciiIndex) &&
            JSON.stringify(Module) === JSON.stringify(Global_AsciiModule) &&
            JSON.stringify(Variable) === JSON.stringify(Global_AsciiVariable) &&
            JSON.stringify(Setting) === JSON.stringify(Global_AsciiSetting)) {
            Return = true;
        }
    } catch (error) {
        //console.error(`Error reading files: ${error}`);
        return false;
    }
    
    return Return;
}


Judgment.prototype._IsSaveMqttModuleGlobalVariable_ = async function() 
{
    let Return = false;
    const Class = new LoadFile();
    
    try {
        const [Index, Module, Variable, Setting] = await Promise.all([
            Class._ReadFile_("./File/MQTT_Module/Index.json", {}),
            Class._ReadFile_("./File/MQTT_Module/Module.json", {}),
            Class._ReadFile_("./File/MQTT_Module/MqttVariable.json", {}),
            Class._ReadFile_("./File/MQTT_Module/MqttSetting.json", {})
        ]);
        
        if (JSON.stringify(Index) === JSON.stringify(Global_MqttIndex) &&
            JSON.stringify(Module) === JSON.stringify(Global_MqttModule) &&
            JSON.stringify(Variable) === JSON.stringify(Global_MqttVariable) &&
            JSON.stringify(Setting) === JSON.stringify(Global_MqttSetting)) {
            Return = true;
        }
    } catch (error) {
        //console.error(`Error reading files: ${error}`);
        return false;
    }
    
    return Return;
}


Judgment.prototype._IsSaveRemoteBrokerGlobalVariable_ = async function() 
{
    let Return = false;
    const Class = new LoadFile();
    
    try {
        const RemoteBroker = await Class._ReadFile_("./File/IoT_Platform/RemoteBroker.json", {});
        if (JSON.stringify(RemoteBroker) === JSON.stringify(Global_RemoteBroker)) {
            Return = true;
        }
    } catch (error) {
        //console.error(`Error reading file: ${error}`);
        return false;
    }
    
    return Return;
}
Judgment.prototype._IsSaveLocalBrokerGlobalVariable_ = function()
{
	var Return = false;
	var Class = new Cgi();
	var array = Class.RestApi("GetLocalBrokerSetting", new Array(), false);
	if(typeof(array) == "string")
	{
		var LocalBroker = Transform.prototype._ArrayStringToArray_(JSON.stringify(Global_LocalBroker));
		if(JSON.stringify(array) == JSON.stringify(LocalBroker))
		{
			Return = true;
		}
	}
	else
	{
		if(JSON.stringify(array) == JSON.stringify(Global_LocalBroker))  {Return = true;}
	}
	return Return;
};

Judgment.prototype._IsSaveOpcUaLocalServerGlobalVariable_ = async function() 
{	
    var Return = false;
    var Class = new LoadFile();
    //var OpcUaLocalServer = await Class.ReadFile("./File/IoT_Platform/UAServerConfig.xml", new Object());
    var OpcUaLocalServer = await new Promise((resolve) => {
        resolve(Class.ReadXmlObject("./File/IoT_Platform/UAServerConfig.xml", new Object()));
    });
    if (JSON.stringify(OpcUaLocalServer) == JSON.stringify(Global_OpcUaLocalServer)) {
        Return = true;
    }
    return Return;
};

Transmission.prototype._TransmissionArray_ = function(Command, array, Result, callback) 
{
    var GetClass = new GetValue();
    var ssocket = GetClass.SocketIo();
    ssocket.emit(Command, array);
    ssocket.on(Command, function(Return) {
        
        Result["Input"] = Return;
		if (callback) callback(Result); // Call the callback if provided
    });
};

Transmission.prototype._TransmissionString_ = function(Command, string, Result, callback) 
{
    var GetClass = new GetValue();
    var ssocket = GetClass.SocketIo();
    var Length = 20000, index = 0;
    var array = new Array("Start", "");
    ssocket.emit(Command, array);
    ssocket.on(Command, function(Return) {
        if (Return == "Start" || Return == "Send") {
            if (string.length > (index + Length)) {
                array = new Array("Send", string.substring(index, index + Length));
            } else if (string.length <= (index + Length)) {
                array = new Array("End", string.substring(index, string.length));
            }
            index = index + Length;
            ssocket.emit(Command, array);
        } else if (Return == "End") {
			Result["Input"] = true;
			if (callback) callback(Result);
			
        }
    });
};
 


Transmission.prototype._TransmissionJson_ = function(ssocket, Command, string, Callback) 
{
    const chunkSize = 512 * 1024; 
    let index = 0;
    let array = ["Start", ""];
    let fd;

    ssocket.emit(Command, array);
    ssocket.on(Command, function(Return) {
        if (Return === "Start" || Return === "Send") {
            if (string.length > (index + chunkSize)) {
                array = ["Send", string.substring(index, index + chunkSize)];
            } else if (string.length <= (index + chunkSize)) {
                array = ["End", string.substring(index, string.length)];
            }
            index += chunkSize;
            ssocket.emit(Command, array);
        } else if (Return === "End") {
            Callback();
        }
    });

    ssocket.on('error', function(error) {
        //console.error('Transmission error:', error);
    });
};

Transmission.prototype._SaveOpcUaLocalServer_ = function()
{
	var xotree = new XML.ObjTree();
	var xml = xotree.writeXML(Global_OpcUaLocalServer);
	var array = new Array(xml);
	var GetClass = new GetValue();
	var ssocket = GetClass.SocketIo();
	ssocket.emit("SaveOpcUaLocalServer", array);
	ssocket.on('SaveOpcUaLocalServer', function (Return) {
		ssocket.emit("SocketClose");
	});
};

Transmission.prototype._SaveLocalBrokerSetting_ = function()
{
	var array = Global_LocalBroker;
	var GetClass = new GetValue();
	var ssocket = GetClass.SocketIo();
	ssocket.emit("SaveLocalBrokerSetting", array);
	ssocket.on('SaveLocalBrokerSetting', function (Return) {
		ssocket.emit("SocketClose");
	});
};

Transmission.prototype._SaveRemoteBrokerSetting_ = function()
{
	var array = new Array(Global_RemoteBroker);
	var GetClass = new GetValue();
	var ssocket = GetClass.SocketIo();
	ssocket.emit("SaveRemoteBrokerSetting", array);
	ssocket.on('SaveRemoteBrokerSetting', function (Return) {
		ssocket.emit("SocketClose");
	});
};

ClearService.prototype._DeleteModuleClearService_ = function(ModuleType, ModuleIndex)
{
	ClearService.prototype._ClearPidOperation_(ModuleType, ModuleIndex);
	ClearService.prototype._ClearIftttConditionTrigger_(ModuleType, ModuleIndex);
}
ClearService.prototype._ClearPidOperation_ = function(ModuleType, ModuleIndex, VariableIndex)
{
	var InputIndex, OutputIndex, Variable=Global_PidOperation, ModuleClear=null;
	if(typeof(VariableIndex) == "undefined"){
		ModuleClear=ModuleType+"/"+ModuleIndex;
	}
	var VariableClear=new Array();
	if(typeof(VariableIndex) == "object"){
		for(var i=0; i<VariableIndex.length; i++){
			VariableClear.push(ModuleType+"/"+ModuleIndex+"/"+VariableIndex[i]);
		}
	}
	var PidNumber=Object.keys(Variable);
	for(var i=0; i<PidNumber.length; i++){
		InputIndex = Variable[PidNumber[i]]["InputModuleVariableIndex"];
		OutputIndex = Variable[PidNumber[i]]["OutputModuleVariableIndex"];
		if(InputIndex.indexOf(ModuleClear)!=-1 || VariableClear.indexOf(InputIndex)!=-1)
		{
			Variable[PidNumber[i]]["InputModuleVariableIndex"]="//";
		}
		if(OutputIndex.indexOf(ModuleClear)!=-1 || VariableClear.indexOf(OutputIndex)!=-1)
		{
			Variable[PidNumber[i]]["OutputModuleVariableIndex"]="//";
		}
	}
};
ClearService.prototype._ClearIftttConditionTrigger_ = function(ModuleType, ModuleIndex, VariableIndex)
{
	var InputIndex, OutputIndex, Variable=Global_IftttConditionTriggerVariable, ModuleClear=null;
	if(typeof(VariableIndex) == "undefined"){
		ModuleClear=ModuleType+"/"+ModuleIndex
	}
	var VariableClear=new Array();
	if(typeof(VariableIndex) == "object"){
		for(var i=0; i<VariableIndex.length; i++){
			VariableClear.push(ModuleType+"/"+ModuleIndex+"/"+VariableIndex[i]);
		}
	}
	var number=Object.keys(Variable);
	for(var i=0; i<number.length; i++){
		IndexValue = Variable[number[i]]["IndexValue"];
		for(var j=0; j<IndexValue.length; j++)
		{
			if(IndexValue[j].indexOf(ModuleClear)!=-1 || VariableClear.indexOf(IndexValue[j])!=-1)
			{
				Variable[number[i]]["IndexValue"].splice(j,1);
				Variable[number[i]]["Condition"].splice(j,1);
				Variable[number[i]]["DefineMessage"].splice(j,1);
				j--;
			}
		}
	}
};

SynchronizeService.prototype._ChangeVariableSynchronizationService_ = function(ModuleType, OldObject, NewObject, number)
{
	SynchronizeService.prototype._SynchronizePidOperation_(ModuleType, OldObject, NewObject, number);
	SynchronizeService.prototype._SynchronizeIftttConditionTrigger_(ModuleType, OldObject, NewObject, number);
}
SynchronizeService.prototype._SynchronizePidOperation_ = function(ModuleType, OldObject, NewObject, number)
{	
	if(typeof(OldObject[number]) != "object" || typeof(NewObject[number]) != "object")
	{
		return 0;
	}
	var NewArray=Object.keys(NewObject[number]);
	var OldArray=Object.keys(OldObject[number]);
	var array=GetValue.prototype._GetArrayComplement_(OldArray, NewArray);
	var Class=new ClearService();
	Class.ClearPidOperation(ModuleType, number, array);
	//Class=null;
};
SynchronizeService.prototype._SynchronizeIftttConditionTrigger_ = function(ModuleType, OldObject, NewObject, number)
{	
	if(typeof(OldObject[number]) != "object" || typeof(NewObject[number]) != "object")
	{
		return 0;
	}
	var NewArray=Object.keys(NewObject[number]);
	var OldArray=Object.keys(OldObject[number]);
	var array=GetValue.prototype._GetArrayComplement_(OldArray, NewArray);
	var Class=new ClearService();
	Class.ClearIftttConditionTrigger(ModuleType, number, array);
	//Class=null;
};

Algorithm.prototype._StringNumberMixedSort_ = function()
{
	//https://stackoverflow.com/questions/2802341/javascript-natural-sort-of-alphanumerical-strings
	var Callback=function (a,b){return a.localeCompare(b, undefined, {numeric: true, sensitivity: 'base'});};
	return Callback;
};
//CGI
Cgi.prototype._Ajax_ = function(Url, Type, Async, Cache, Input)
{
	var Return = "";
	$.ajax({
		url: Url,
		type:Type,
		async: Async,
		cache: false,
		success: function(msg)
		{
			Return = msg;
			if(Async == true && typeof(Input) != "undefined")
			{
				Input["Input"] = msg;
			}
		},
		error:function(xhr, ajaxOptions, thrownError)
		{
			console.log("ajax error:["+xhr + ":" + ajaxOptions + ":" + thrownError+"]");
		}
	});
	return Return;
}

Cgi.prototype._RestApi_ = function(RestApi, ParameterArray, Async, Input)
{
	var Url = GetValue.prototype._CgiUrl_();
	Url = Url + "CGI?RestApi=" + RestApi + "&ParameterArray=";
	for(var i=0; i<ParameterArray.length; i++)
	{
		if(i == (ParameterArray.length-1))  {Url = Url + ParameterArray[i];}
		else                                {Url = Url + ParameterArray[i] + "$";}
	}
	var Return;
	if(Async == true)
	{
		Return = {Input:null};
		Cgi.prototype._Ajax_(Url, "GET", Async, false, Return);
		var SetInterval = setInterval(function(){
			if(Return["Input"] != null && typeof(Input) != "undefined")
			{
				clearInterval(SetInterval);
				Input["Input"] = Return["Input"];
			}
		},100);
	}
	else
	{
		Return = Cgi.prototype._Ajax_(Url, "GET", false, false);
	}
	return Return;
};
Cgi.prototype._Dbus_ = function(RestApi, ParameterArray, Async, Input)
{
	var Url = GetValue.prototype._CgiUrl_();
	Url = Url + "Dbus?RestApi="+ RestApi + "&ParameterArray=";
	for(var i=0; i<ParameterArray.length; i++)
	{
		if(i == (ParameterArray.length-1))  {Url = Url + ParameterArray[i];}
		else                                {Url = Url + ParameterArray[i] + "$";}
	}
	var Return;
	if(Async == true)
	{
		Return = {Input:null};
		Cgi.prototype._Ajax_(Url, "GET", Async, false, Return);
		var SetInterval = setInterval(function(){
			if(Return["Input"] != null && typeof(Input) != "undefined")
			{
				clearInterval(SetInterval);
				Input["Input"] = Return["Input"];
			}
		},100);
	}
	else
	{
		Return = Cgi.prototype._Ajax_(Url, "GET", false, false);
	}
	return Return;
};
Cgi.prototype._LoginStatus_ = function(LoginStatus, Async)
{
	if(typeof(LoginStatus) == "undefined")
	{
		LoginStatus="";
	}
	var Url = GetValue.prototype._CgiUrl_();
	Url = Url + "LoginStatus?Status="+LoginStatus;
	var Return = Cgi.prototype._Ajax_(Url, "GET", Async, false);
	return Return;
};

Cgi.prototype._TransferJsonString_ = function(RestApi, JsonString)
{
	var Return = "";  var Class = new Cgi();  var MaxLength=20000;  var Index=0;  var ParameterArray=new Array("Start","");
	Class.RestApi(RestApi, ParameterArray, false);
	var ArrayString = new Array();
	for(var i=0; i<JsonString.length; i=i+MaxLength){
		if(JsonString.length < MaxLength || i+MaxLength > JsonString.length)
		{
			ArrayString.push(JsonString.substring(i, JsonString.length));
			break;
		}
		else{
			ArrayString.push(JsonString.substring(i, i+MaxLength));
		}
	}
	for(var i=0; i<ArrayString.length; i++){
		if(i == (ArrayString.length - 1))
		{
			ParameterArray = new Array("End", ArrayString[i]);
		}
		else
		{
			ParameterArray = new Array("Send", ArrayString[i]);
		}
		var ReturnValue = Class.RestApi(RestApi, ParameterArray, false);
	}
	return Return;
};

Communication.prototype._PacketEncryption_ = function(Packet, Key)
{
	var textBytes = aesjs.utils.utf8.toBytes(Packet);
    var aesCtr = new aesjs.ModeOfOperation.ctr(Key, new aesjs.Counter(5));
    var encryptedBytes = aesCtr.encrypt(textBytes);
    var encryptedHex = aesjs.utils.hex.fromBytes(encryptedBytes);
    var encryptedBytes = aesjs.utils.hex.toBytes(encryptedHex);
    return encryptedBytes;
}

Communication.prototype._PacketDecryption_ = function(Packet, Key)
{
	try{
        var aesCtr = new aesjs.ModeOfOperation.ctr(Key, new aesjs.Counter(5));
        var decryptedBytes = aesCtr.decrypt(Packet);
        var decryptedText = aesjs.utils.utf8.fromBytes(decryptedBytes);
    }
    catch(error){
        return false;
    }
    try{
        decryptedText = JSON.parse(decryptedText);
    }
    catch(error){
    }
    return decryptedText;
}

JsonTransformXml.prototype._TransformMethodTableXml_ = async function() 
{
    const Class = new LoadFile();
    
    try {
        const PidOperation = await Class.ReadFile("./File/PID_Operation/PidOperation.json");
        const object = {
            MethodTable: {
                MethodName: []
            }
        };
        const PidNumber = Object.keys(PidOperation);
        for (let i = 0; i < PidNumber.length; i++) {
            if (PidOperation[PidNumber[i]].InputModuleVariableIndex === "//" ||
                PidOperation[PidNumber[i]].OutputModuleVariableIndex === "//") {
                continue;
            }
            const RunMethodName = `PID_${PidOperation[PidNumber[i]].Name}.Run`;
            const StopMethodName = `PID_${PidOperation[PidNumber[i]].Name}.Stop`;
            object.MethodTable.MethodName.push(RunMethodName);
            object.MethodTable.MethodName.push(StopMethodName);
        }
        const xotree = new XML.ObjTree();
        const xml = xotree.writeXML(object);
        return xml;
    } catch (error) {
        //console.error(`Error reading file: ${error}`);
        return "";
    }
};

JsonTransformXml.prototype._TransformPidDriverDri_ = async function() 
{
    const Class = new LoadFile();
    
    try {
        const PidOperation = await Class.ReadFile("./File/PID_Operation/PidOperation.json");
        const object = {
            PIDDriver: {
                PIDTask: []
            }
        };
        const PidNumber = Object.keys(PidOperation);
        
        for (const pid of PidNumber) {
            if (PidOperation[pid].InputModuleVariableIndex === "//" ||
                PidOperation[pid].OutputModuleVariableIndex === "//") {
                continue;
            }
            const obj = {
                TaskID: PidNumber.indexOf(pid),
                InputVariable: {
                    VariableName: JsonTransformXml.prototype._GetPidModuleVariabName_(PidOperation[pid].InputModuleVariableIndex)
                },
                OutputVariable: {
                    VariableName: JsonTransformXml.prototype._GetPidModuleVariabName_(PidOperation[pid].OutputModuleVariableIndex)
                },
                OutputMin: PidOperation[pid].Min,
                OutputMax: PidOperation[pid].Max,
                SetPoint: {
                    VariableName: `PID_${PidOperation[pid].Name}.SetPoint`
                },
                Kp: {
                    VariableName: `PID_${PidOperation[pid].Name}.Kp`
                },
                Ki: {
                    VariableName: `PID_${PidOperation[pid].Name}.Ki`
                },
                Kd: {
                    VariableName: `PID_${PidOperation[pid].Name}.Kd`
                },
                ControllerMode: {
                    VariableName: `PID_${PidOperation[pid].Name}.ControllerMode`
                },
                SampleTime: {
                    VariableName: `PID_${PidOperation[pid].Name}.SampleTime`
                },
                AutoTune: {
                    VariableName: `PID_${PidOperation[pid].Name}.AutoTune`
                },
                Status: {
                    VariableName: `PID_${PidOperation[pid].Name}.Status`
                },
                Method_Run: {
                    MethodName: `PID_${PidOperation[pid].Name}.Run`
                },
                Method_Stop: {
                    MethodName: `PID_${PidOperation[pid].Name}.Stop`
                }
            };
            object.PIDDriver.PIDTask.push(obj);
        }
        
        const xotree = new XML.ObjTree();
        return xotree.writeXML(object);
    } catch (error) {
        //console.error(`Error reading file: ${error}`);
        return "";
    }
};

JsonTransformXml.prototype._GetMqttCustomServiceTaskArray_ = async function()
{
	var object = new Object();
	await JsonTransformXml.prototype._GetMqttJsonGroupData_(object);
	await JsonTransformXml.prototype._GetAzurePlatformData_(object);
	JsonTransformXml.prototype._InitialVariablePropertyDataType_(object);
	//JsonTransformXml.prototype._LinkRtuVariable_(object);
	//JsonTransformXml.prototype._LinkTcpVariable_(object);
	//JsonTransformXml.prototype._LinkAsciiVariable_(object);
	JsonTransformXml.prototype._LinkMqttCustomVariable_(object);
	var Return=JsonTransformXml.prototype._CreateMqttCustomServiceArray_(object);
	return Return;
}


JsonTransformXml.prototype._GetMqttServiceTaskJsonArray_ = async function()
{
	var object = new Object();
	await JsonTransformXml.prototype._GetMqttJsonGroupData_(object);
	await JsonTransformXml.prototype._GetAzurePlatformData_(object);
	JsonTransformXml.prototype._InitialVariablePropertyDataType_(object);
	await JsonTransformXml.prototype._LinkRtuVariable_(object);
	await JsonTransformXml.prototype._LinkTcpVariable_(object);
	await JsonTransformXml.prototype._LinkAsciiVariable_(object);
	var Return=JsonTransformXml.prototype._CreateMqttServiceTaskJsonArray_(object);
	return Return;
}
JsonTransformXml.prototype._CreateMqttCustomServiceArray_ = function(object)
{
	var Name=Object.keys(object);
	var MQTTServiceTask_Custom=new Array();
	for(var i=0; i<Name.length; i++)
	{
		for(var j=0; j<object[Name[i]]["Broker"].length; j++)
		{
			var Task=new Object();
			Task=new Object();
			Task["TaskID"] = 1;
			Task["ScanRate"] = object[Name[i]]["ScanRate"];
			Task["DeadBand"] = object[Name[i]]["DeadBand"];
			Task["WillTopic"] = object[Name[i]]["WillTopic"];
			Task["Will"] = object[Name[i]]["Will"];

			//Broker 
			Task["Broker"]=new Object();
			Task["Broker"]["IP"]        = object[Name[i]]["Broker"][j]["IP"];
			Task["Broker"]["Port"]      = object[Name[i]]["Broker"][j]["Port"];
			Task["Broker"]["ClientID"]  = object[Name[i]]["Broker"][j]["ClientID"];
			Task["Broker"]["Keepalive"] = object[Name[i]]["Broker"][j]["Keepalive"];
			Task["Broker"]["Username"]  = object[Name[i]]["Broker"][j]["Username"];
			Task["Broker"]["Password"]  = object[Name[i]]["Broker"][j]["Password"];
			Task["Broker"]["isSecure"]  = JsonTransformXml.prototype._GetSecureNumber_(object[Name[i]]["Broker"][j]["isSecure"]);
			Task["Broker"]["CACertFile"] = object[Name[i]]["Broker"][j]["CaCertFile"];
			Task["Broker"]["CertFile"]   = object[Name[i]]["Broker"][j]["CertFile"];
			Task["Broker"]["KeyFile"]    = object[Name[i]]["Broker"][j]["KeyFile"];
			
			
			
			Task["PubTopic"] = object[Name[i]]["PubTopic"];
			Task["PubQoS"] = object[Name[i]]["PubQoS"];
			Task["Retain"] = object[Name[i]]["Retain"];

			Task["Context"] = object[Name[i]]["CustomFormat"];
			if(Task["Context"] == null || Task["Context"] == "undefined" || Task["Context"] == "")
			{
				break;
			}
			MQTTServiceTask_Custom.push(Task);
		}
	}
	return MQTTServiceTask_Custom;
}


JsonTransformXml.prototype._CreateMqttServiceTaskJsonArray_ = function(object)
{
	var Name=Object.keys(object);
	var MQTTServiceTask_JSON=new Array();
	for(var i=0; i<Name.length; i++)
	{
		for(var j=0; j<object[Name[i]]["Broker"].length; j++)
		{
			var Task=new Object();
			Task=new Object();
			Task["Broker"]=new Object();
			Task["Broker"]["IP"]        = object[Name[i]]["Broker"][j]["IP"];
			Task["Broker"]["Port"]      = object[Name[i]]["Broker"][j]["Port"];
			Task["Broker"]["ClientID"]  = object[Name[i]]["Broker"][j]["ClientID"];
			Task["Broker"]["Keepalive"] = object[Name[i]]["Broker"][j]["Keepalive"];
			Task["Broker"]["Username"]  = object[Name[i]]["Broker"][j]["Username"];
			Task["Broker"]["Password"]  = object[Name[i]]["Broker"][j]["Password"];
			Task["Broker"]["isSecure"]  = JsonTransformXml.prototype._GetSecureNumber_(object[Name[i]]["Broker"][j]["isSecure"]);
			Task["Broker"]["CACertFile"] = object[Name[i]]["Broker"][j]["CaCertFile"];
			Task["Broker"]["CertFile"]   = object[Name[i]]["Broker"][j]["CertFile"];
			Task["Broker"]["KeyFile"]    = object[Name[i]]["Broker"][j]["KeyFile"];
			Task["TaskID"] = object[Name[i]]["TaskID"];
			Task["SubTopic"] = object[Name[i]]["SubTopic"];
			Task["SubQoS"] = object[Name[i]]["SubQoS"];
			Task["PubTopic"] = object[Name[i]]["PubTopic"];
			Task["PubQoS"] = object[Name[i]]["PubQoS"];
			Task["Retain"] = object[Name[i]]["Retain"];
			Task["ScanRate"] = object[Name[i]]["ScanRate"];
			Task["DeadBand"] = object[Name[i]]["DeadBand"];
			Task["WillTopic"] = object[Name[i]]["WillTopic"];
			Task["Will"] = object[Name[i]]["Will"];
			if(object[Name[i]]["Timestamp"] == true) Task["Timestamp"] = 1;
			else                                     Task["Timestamp"] = 0;

			if(object[Name[i]]["CustomFormatter"] == 101)
			{
				Task["CustomFormatter"]=object[Name[i]]["CustomFormatter"];
				Task["CDSData"]=new Object();
				Task["CDSData"]["CompanyId"]=object[Name[i]]["CDSData"]["CompanyId"];
				Task["CDSData"]["EquipmentId"]=object[Name[i]]["CDSData"]["EquipmentId"];
				Task["CDSData"]["MessageCatalogId"]=object[Name[i]]["CDSData"]["MessageCatalogId"];
			}
			
			Task["MQTTMapping"]=new Array();
			if(object[Name[i]]["VariableName"].length == 0)	{continue;}
			for(var k=0; k<object[Name[i]]["VariableName"].length; k++)
			{
				var MQTTMapping=new Object();
				MQTTMapping["Name"]     = object[Name[i]]["VariableName"][k];
				MQTTMapping["DataType"] = object[Name[i]]["DataType"][k];
				MQTTMapping["Property"] = object[Name[i]]["Property"][k];
				MQTTMapping["Alias"]    = object[Name[i]]["Alias"][k];
				Task["MQTTMapping"].push(MQTTMapping);
			}
			MQTTServiceTask_JSON.push(Task);
		}
	}
	return MQTTServiceTask_JSON;
}

JsonTransformXml.prototype._InitialVariablePropertyDataType_ = function(object)
{
	var Name=Object.keys(object);
	for(var i=0; i<Name.length; i++)
	{
		object[Name[i]]["VariableName"]=new Array();
		object[Name[i]]["Alias"]=new Array();
		object[Name[i]]["Property"]=new Array();
		object[Name[i]]["DataType"]=new Array();
	}
}

JsonTransformXml.prototype._LinkRtuVariable_ = async function(object) 
{
    const Name = Object.keys(object);
    const Class = new LoadFile();
    
    try {
        const [JsonVariable, Module, ModuleVariable] = await Promise.all([
            Class._ReadFile_("./File/RTU_Module/RtuToMqttJsonVariable.json", {}),
            Class._ReadFile_("./File/RTU_Module/Module.json", {}),
            Class._ReadFile_("./File/RTU_Module/RtuVariable.json", {})
        ]);

        const number = Object.keys(JsonVariable);
        number.forEach(i => {
            const SystemVariable = Object.keys(JsonVariable[i]);
            SystemVariable.forEach(j => {
                Name.forEach(k => {
                    if (JsonVariable[i][j].TransformMqttJson === true && 
                        JsonVariable[i][j].ConnectionGroup === k) {
                        const ModuleName = JsonTransformXml.prototype._GetModuleName_(Module, i);
                        object[k].VariableName.push(`MRTU_No.${i}_${ModuleName}_${j.split("-")[0]}.${ModuleVariable[i][j].VariableName}`);
                        object[k].Alias.push(JsonVariable[i][j].Alias);
                        object[k].Property.push(JsonTransformXml.prototype._GetProperty_(j.split("-")[0]));
                        object[k].DataType.push(JsonTransformXml.prototype._GetDataType_(j.split("-")[1]));
                    }
                });
            });
        });
    } catch (error) {
        //console.error(`Error reading files: ${error}`);
    }
};

JsonTransformXml.prototype._LinkTcpVariable_ = async function(object) 
{
	const Name = Object.keys(object);
	const Class = new LoadFile();

	try {
		const [JsonVariable, Module, ModuleVariable] = await Promise.all([
			Class._ReadFile_("./File/TCP_Module/TcpToMqttJsonVariable.json", {}),
			Class._ReadFile_("./File/TCP_Module/Module.json", {}),
			Class._ReadFile_("./File/TCP_Module/TcpVariable.json", {})
		]);

		const number = Object.keys(JsonVariable);
		number.forEach(i => {
			const SystemVariable = Object.keys(JsonVariable[i]);
			SystemVariable.forEach(j => {
				Name.forEach(k => {
					if (JsonVariable[i][j].TransformMqttJson === true &&
						JsonVariable[i][j].ConnectionGroup === k) {
						const ModuleName = JsonTransformXml.prototype._GetModuleName_(Module, i);
						object[k].VariableName.push(`MTCP_No.${i}_${ModuleName}_${j.split("-")[0]}.${ModuleVariable[i][j].VariableName}`);
						object[k].Alias.push(JsonVariable[i][j].Alias);
						object[k].Property.push(JsonTransformXml.prototype._GetProperty_(j.split("-")[0]));
						object[k].DataType.push(JsonTransformXml.prototype._GetDataType_(j.split("-")[1]));
					}
				});
			});
		});
	} catch (error) {
		//console.error(`Error reading files: ${error}`);
	}
};
	
JsonTransformXml.prototype._LinkMqttCustomVariable_ = async function(object) 
{
	const Name = Object.keys(object);
	const Class = new LoadFile();

	try {
		const CustomVariable = await Class.ReadFile("./File/RemoteMQTTGroup/RemoteMqttGroup.json");
		const number = Object.keys(CustomVariable);
		Name.forEach(i => {
			number.forEach(k => {
				if (CustomVariable[k].TransformMqttCustom === true &&
					CustomVariable[k].ConnectionGroup === i) {
					object[i].CustomFormat = [];
					object[i].CustomFormat.push(CustomVariable[k].DataMessage);
				}
			});
		});
	} catch (error) {
		//console.error(`Error reading file: ${error}`);
	}
};

JsonTransformXml.prototype._LinkAsciiVariable_ = async function(object) 
{
    const Name = Object.keys(object);
    const Class = new LoadFile();
    
    try {
        const [JsonVariable, Module, ModuleVariable] = await Promise.all([
            Class.ReadFile("./File/ASCII_Module/AsciiToMqttJsonVariable.json"),
            Class.ReadFile("./File/ASCII_Module/Module.json"),
            Class.ReadFile("./File/ASCII_Module/AsciiVariable.json")
        ]);

        const number = Object.keys(JsonVariable);
        number.forEach(i => {
            const SystemVariable = Object.keys(JsonVariable[i]);
            SystemVariable.forEach(j => {
                Name.forEach(k => {
                    if (JsonVariable[i][j].TransformMqttJson === true && 
                        JsonVariable[i][j].ConnectionGroup === k) {
                        const ModuleName = JsonTransformXml.prototype._GetModuleName_(Module, i);
                        object[k].VariableName.push(`MASCII_No.${i}_${ModuleName}_${j.split("-")[0]}.${ModuleVariable[i][j].VariableName}`);
                        object[k].Alias.push(JsonVariable[i][j].Alias);
                        object[k].Property.push(JsonTransformXml.prototype._GetProperty_(j.split("-")[0]));
                        object[k].DataType.push(JsonTransformXml.prototype._GetDataType_(j.split("-")[1]));
                    }
                });
            });
        });
    } catch (error) {
        //console.error(`Error reading files: ${error}`);
    }
};


JsonTransformXml.prototype._SetMqttJsonGroupClient_ = function(object, MqttJsonGroup)
{
	object["Broker"] = new Array();
	object["TaskID"]   = -1;
	object["SubTopic"] = MqttJsonGroup["SubscribeTopic"];
	object["SubQoS"]   = MqttJsonGroup["SubscribeQos"];
	object["PubTopic"] = MqttJsonGroup["PublishTopic"];
	object["PubQoS"]   = MqttJsonGroup["PublishQos"];
	object["Retain"]   = MqttJsonGroup["Retain"];
	object["ScanRate"] = MqttJsonGroup["ScanRate"];
	object["DeadBand"] = MqttJsonGroup["DeadBand"];
	object["WillTopic"]= MqttJsonGroup["WillTopic"];
	object["Will"]     = MqttJsonGroup["Will"];
	object["Timestamp"]= MqttJsonGroup["Timestamp"];
}

JsonTransformXml.prototype._SetMqttJsonGroupLocalBroker_ = function(object, LocalBroker)
{
	var BrokerObject=new Object();
	BrokerObject["IP"]        = document.location.hostname;
	BrokerObject["Port"]      = LocalBroker["port"];
	BrokerObject["Username"]  = LocalBroker["account"];
	BrokerObject["Password"]  = LocalBroker["password"];
	BrokerObject["Keepalive"] = 60;
	BrokerObject["isSecure"]  = JsonTransformXml.prototype._GetSecureNumber_(LocalBroker["isSecure"]);
	object["Broker"].push(BrokerObject);
}

JsonTransformXml.prototype._SetMqttJsonGroupRemoteBroker_ = function(object, RemoteBroker)
{
	var BrokerObject=new Object();
	BrokerObject["IP"]        = RemoteBroker["IP"];
	BrokerObject["Port"]      = RemoteBroker["Port"];
	BrokerObject["ClientID"] = RemoteBroker["ClientID"];
	BrokerObject["Keepalive"] = RemoteBroker["Keepalive"];
	BrokerObject["isSecure"]  = JsonTransformXml.prototype._GetSecureNumber_(RemoteBroker["isSecure"]);
	BrokerObject["CaCertFile"]  = RemoteBroker["CaCertFile"];
	BrokerObject["CertFile"]  = RemoteBroker["CertFile"];
	BrokerObject["KeyFile"]  = RemoteBroker["KeyFile"];
	BrokerObject["Username"]  = RemoteBroker["Username"];
	BrokerObject["Password"]  = RemoteBroker["Password"];
	object["Broker"].push(BrokerObject);
}

JsonTransformXml.prototype._LinkMqttCustomVariable_ = async function(object) 
{
	const Name = Object.keys(object);
	const Class = new LoadFile();

	try {
		const CustomVariable = await Class.ReadFile("./File/RemoteMQTTGroup/RemoteMqttGroup.json");
		const number = Object.keys(CustomVariable);
		Name.forEach(i => {
			number.forEach(k => {
				if (CustomVariable[k].TransformMqttCustom === true &&
					CustomVariable[k].ConnectionGroup === i) {
					object[i].CustomFormat = [];
					object[i].CustomFormat.push(CustomVariable[k].DataMessage);
				}
			});
		});
	} catch (error) {
		//console.error(`Error reading file: ${error}`);
	}
};

JsonTransformXml.prototype._GetMqttJsonGroupData_ = async function(object) 
{
    const LocalBroker  = await JsonTransformXml.prototype._GetLocalBrokerData_();
    const RemoteBroker = await JsonTransformXml.prototype._GetRemoteBroker_();
    const Class = new LoadFile();

    try {
        const MqttJsonGroup = await Class.ReadFile("./File/IoT_Platform/MqttJsonGroup.json", new Object());
        const array = Object.keys(MqttJsonGroup);
        for (let i = 0; i < array.length; i++) {
            const Name = MqttJsonGroup[array[i]]["Name"];
            object[Name] = new Object();
            JsonTransformXml.prototype._SetMqttJsonGroupClient_(object[Name], MqttJsonGroup[array[i]]);
            const MqttConnection = MqttJsonGroup[array[i]]["MqttConnection"];
            for (let j = 0; j < MqttConnection.length; j++) {
                if (MqttConnection[j].indexOf("(Local)") !== -1) {
                    JsonTransformXml.prototype._SetMqttJsonGroupLocalBroker_(object[Name], LocalBroker);
                }
                const BrokerName = Object.keys(RemoteBroker);
                for (let k = 0; k < BrokerName.length; k++) {
                    if (MqttConnection[j] === BrokerName[k]) {
                        JsonTransformXml.prototype._SetMqttJsonGroupRemoteBroker_(object[Name], RemoteBroker[BrokerName[k]]);
                    }
                }
            }
        }
    } catch (error) {
        //console.error("Error reading file:", error);
    }
};

JsonTransformXml.prototype._GetAzurePlatformData_ = async function(object) {
	const AzureBroker = await JsonTransformXml.prototype._GetAzureBroker_();
	const Class = new LoadFile();
	
	try {
		const AzurePlatform = await Class.ReadFile("./File/IoT_Platform/Microsoft_Azure_Platform.json");
		const array = Object.keys(AzurePlatform);
		array.forEach(i => {
			const Name = `${AzurePlatform[i].Name} (Azure)`;
			object[Name] = {};
			const BrokerObject = {};
			object[Name].Broker = [];
			object[Name].TaskID = -1;
			object[Name].SubTopic = `devices/${AzureBroker[Name].ClientId}/messages/devicebound/`;
			object[Name].SubQoS = 1;
			object[Name].PubTopic = `devices/${AzureBroker[Name].ClientId}/messages/events/`;
			object[Name].PubQoS = 1;
			object[Name].Retain = 0;
			object[Name].ScanRate = AzurePlatform[i].ScanRate;
			object[Name].DeadBand = AzurePlatform[i].DeadBand;
			object[Name].WillTopic = "";
			object[Name].Will = "";
			BrokerObject.IP = AzureBroker[Name].IP;
			BrokerObject.Port = AzureBroker[Name].Port;
			BrokerObject.CaCertFile = AzurePlatform[i].CaCertFile;
			BrokerObject.ClientID = AzureBroker[Name].ClientId;
			BrokerObject.Keepalive = AzureBroker[Name].Keepalive;
			BrokerObject.isSecure = JsonTransformXml.prototype._GetSecureNumber_(AzureBroker[Name].isSecure);
			BrokerObject.Username = AzureBroker[Name].Username;
			BrokerObject.Password = AzureBroker[Name].Password;
			object[Name].Broker.push(BrokerObject);
			if (AzurePlatform[i].CdsEnabled === true) {
				object[Name].CustomFormatter = 101;
				object[Name].CDSData = {
					CompanyId: AzurePlatform[i].CompanyId,
					EquipmentId: AzurePlatform[i].EquipmentId,
					MessageCatalogId: AzurePlatform[i].MessageId
				};
			}
		});
	} catch (error) {
		//console.error(`Error reading file: ${error}`);
	}
};
	
JsonTransformXml.prototype._GetRemoteBroker_ = async function() 
{
	const Class = new LoadFile();
	
	try {
		const RemoteBroker = await Class.ReadFile("./File/IoT_Platform/RemoteBroker.json");
		const number = Object.keys(RemoteBroker);
		const Return = {};
		number.forEach(i => {
			const Name = `${RemoteBroker[i].Name} (Remote)`;
			Return[Name] = {
				IP: RemoteBroker[i].IP,
				Port: RemoteBroker[i].Port,
				ClientID: RemoteBroker[i].ClientID,
				Keepalive: RemoteBroker[i].Keepalive,
				Username: RemoteBroker[i].Account,
				Password: RemoteBroker[i].Password,
				isSecure: JsonTransformXml.prototype._GetSecureNumber_(RemoteBroker[i]["SSL/TLS"]),
				CaCertFile: RemoteBroker[i].CaCertFile,
				CertFile: RemoteBroker[i].CertFile,
				KeyFile: RemoteBroker[i].KeyFile
			};
		});
		return Return;
	} catch (error) {
		//console.error(`Error reading file: ${error}`);
		return {};
	}
};

JsonTransformXml.prototype._GetAzureBroker_ = async function() 
{
	const Class = new LoadFile();
	
	try {
		const AzurePlatform = await Class.ReadFile("./File/IoT_Platform/Microsoft_Azure_Platform.json");
		const number = Object.keys(AzurePlatform);
		const Return = {};
		number.forEach(i => {
			const Name = `${AzurePlatform[i].Name} (Azure)`;
			Return[Name] = {
				IP: "",
				Port: "",
				ClientId: "",
				Keepalive: "",
				Username: "",
				Password: "",
				isSecure: ""
			};
			let SasToken = AzurePlatform[i].SasToken;
			SasToken = SasToken.split(";");
			if (SasToken.length !== 3) {
				return;
			}
			Return[Name].IP = SasToken[0].replace("HostName=", "");
			Return[Name].Port = 8883;
			Return[Name].ClientId = SasToken[1].replace("DeviceId=", "");
			Return[Name].Keepalive = AzurePlatform[i].Keepalive;
			Return[Name].Username = `${Return[Name].IP}/${Return[Name].ClientId}/?api-version=2021-04-12`;
			Return[Name].Password = SasToken[2].replace("SharedAccessSignature=", "");
			Return[Name].isSecure = 1;
		});
		return Return;
	} catch (error) {
		//console.error(`Error reading file: ${error}`);
		return {};
	}
};


JsonTransformXml.prototype._ArrangeConnection_ = function(Index, ObjArray, ToMqttSetting)
{
	for(var i=0; i<Index.length; i++)
	{
		var array = ToMqttSetting[Index[i]]["MqttConnection"];
		for(var j=0; j<array.length; j++)
		{
			var object=new Object;
			object["ScanRate"]      =ToMqttSetting[Index[i]]["ScanRate"];
			object["DeadBand"]      =ToMqttSetting[Index[i]]["DeadBand"];
			object["WillTopic"]     =ToMqttSetting[Index[i]]["WillTopic"];
			object["Will"]          =ToMqttSetting[Index[i]]["Will"];
			object["MqttConnection"]=array[j];
			ObjArray.push(object);
		}
	}
}

JsonTransformXml.prototype._RemoveDuplicateConnection_ = function(ObjArray)
{
	for(var i=0; i<ObjArray.length; i++)
	{
		for(var j=i+1; j<ObjArray.length; j++)
		{
			if(JSON.stringify(ObjArray[i])==JSON.stringify(ObjArray[j]))
			{
				ObjArray.splice(j,1);
				j--;
				continue;
			}
		}
	}
}

JsonTransformXml.prototype._RemoveUnusedConnection_ = function(object)
{
	var i=0;
	while(i < object["MQTTService"]["MQTTServiceTask"].length)
	{
		if(object["MQTTService"]["MQTTServiceTask"].length == 0)		{break;}
		if(object["MQTTService"]["MQTTServiceTask"][i]["MQTTMapping"].length == 0)
		{
			object["MQTTService"]["MQTTServiceTask"].splice(i,1);
			i--;
		}
		i++;
	}
}

JsonTransformXml.prototype._InitializeModuleIndex_ = function(ObjectArray)
{
	for(var i=0; i<ObjectArray.length; i++)
	{
		ObjectArray[i]["ModuleIndex"]=new Array();
	}
}

JsonTransformXml.prototype._RecordModuleIndex_ = function(ObjArray, ObjectArray, Index, ToMqttSetting, PrefixWord)
{
	for(var i=0; i<ObjArray.length; i++)
	{
		for(var j=0; j<Index.length; j++)
		{
			var array = ToMqttSetting[Index[j]]["MqttConnection"];
			for(var k=0; k<array.length; k++)
			{
				object=new Object;
				object["ScanRate"]      =ToMqttSetting[Index[j]]["ScanRate"];
				object["DeadBand"]      =ToMqttSetting[Index[j]]["DeadBand"];
				object["WillTopic"]     =ToMqttSetting[Index[j]]["WillTopic"];
				object["Will"]          =ToMqttSetting[Index[j]]["Will"];
				object["MqttConnection"]=array[k];
				if(JSON.stringify(ObjArray[i])==JSON.stringify(object))
				{
					ObjectArray[i]["ModuleIndex"].push(PrefixWord+"_"+Index[j]);
				}
			}
		}
	}
}

JsonTransformXml.prototype._ArrangeMqttServices_ = async function() {
    var obj = await JsonTransformXml.prototype._GetMqttServiceTransformObject_();
    var ObjArray = new Array();
    var settings = [
        { index: Object.keys(obj["RtuToMqttSetting"]), setting: obj["RtuToMqttSetting"], type: "Rtu" },
        { index: Object.keys(obj["TcpToMqttSetting"]), setting: obj["TcpToMqttSetting"], type: "Tcp" },
        { index: Object.keys(obj["AsciiToMqttSetting"]), setting: obj["AsciiToMqttSetting"], type: "Ascii" },
        { index: Object.keys(obj["EipToMqttSetting"]), setting: obj["EipToMqttSetting"], type: "Eip" },
    ];

    settings.forEach(function(setting) {
        JsonTransformXml.prototype._ArrangeConnection_(setting.index, ObjArray, setting.setting);
    });

    JsonTransformXml.prototype._RemoveDuplicateConnection_(ObjArray);
    var ObjectArray = jQuery.parseJSON(JSON.stringify(ObjArray));
    JsonTransformXml.prototype._InitializeModuleIndex_(ObjectArray);

    settings.forEach(function(setting) {
        JsonTransformXml.prototype._RecordModuleIndex_(ObjArray, ObjectArray, setting.index, setting.setting, setting.type);
    });

    return ObjectArray;
}

JsonTransformXml.prototype._GetMqttConnectionData_ = async function(ObjectArray, MQTTServiceTask, LocalBroker, RemoteBroker)
{
	if(ObjectArray["MqttConnection"].indexOf(" (Local)") != -1){
		MQTTServiceTask["Broker"]["IP"]        = document.location.hostname;
		MQTTServiceTask["Broker"]["Port"]      = LocalBroker["port"];
		MQTTServiceTask["Broker"]["Keepalive"] = 60;
		MQTTServiceTask["Broker"]["Username"]  = LocalBroker["account"];
		MQTTServiceTask["Broker"]["Password"]  = LocalBroker["password"];
		MQTTServiceTask["Broker"]["isSecure"]  = JsonTransformXml.prototype._GetSecureNumber_(LocalBroker["isSecure"]);
		await JsonTransformXml.prototype._GetMqttMappingObject_(ObjectArray, MQTTServiceTask);
	}
	else if(ObjectArray["MqttConnection"].indexOf(" (Remote)") != -1){
		var Index = Object.keys(RemoteBroker);
		for(var j=0; j<Index.length; j++)
		{
			if((RemoteBroker[Index[j]]["Name"]+" (Remote)") == ObjectArray["MqttConnection"])
			{
				MQTTServiceTask["Broker"]["IP"]        = RemoteBroker[Index[j]]["IP"];
				MQTTServiceTask["Broker"]["Port"]      = RemoteBroker[Index[j]]["Port"];
				MQTTServiceTask["Broker"]["ClientID"] = RemoteBroker[Index[j]]["ClientID"]
				MQTTServiceTask["Broker"]["Keepalive"] = RemoteBroker[Index[j]]["Keepalive"];
				MQTTServiceTask["Broker"]["Username"]  = RemoteBroker[Index[j]]["Account"];
				MQTTServiceTask["Broker"]["Password"]  = RemoteBroker[Index[j]]["Password"];
				MQTTServiceTask["Broker"]["isSecure"]  = JsonTransformXml.prototype._GetSecureNumber_(RemoteBroker[Index[j]]["SSL/TLS"]);
				MQTTServiceTask["Broker"]["CACertFile"] = RemoteBroker[Index[j]]["CaCertFile"];
				MQTTServiceTask["Broker"]["CertFile"] = RemoteBroker[Index[j]]["CertFile"];
				MQTTServiceTask["Broker"]["KeyFile"] = RemoteBroker[Index[j]]["KeyFile"];
				await JsonTransformXml.prototype._GetMqttMappingObject_(ObjectArray, MQTTServiceTask);
			}
		}
	}
}

JsonTransformXml.prototype._GetLocalBrokerData_ = async function() 
{
    const Return = {};
    const Class = new LoadFile();
    
    try {
        let MosquittoConf = await Class.ReadFile("./File/IoT_Platform/mosquitto.conf");
        MosquittoConf = MosquittoConf.split("\n");
        MosquittoConf.forEach(line => {
            if (line.indexOf("port") !== -1) {
                Return.port = parseInt(line.split(" ")[1]);
            } else if (line.indexOf("allow_anonymous") !== -1) {
                Return.isSecure = line.split(" ")[1] !== "true";
            }
        });
        Return.account = "";
        Return.password = "";
        if (Return.isSecure) {
            const [Acl, LocalBroker] = await Promise.all([
                Class.ReadFile("./File/IoT_Platform/acl"),
                Class.ReadFile("./File/IoT_Platform/LocalBroker.txt")
            ]);
            if (Acl && LocalBroker) {
                Return.account = Acl.split("\n")[0].split(" ")[1];
                Return.password = LocalBroker.split(" ")[1];
            }
        }
    } catch (error) {
        //console.error(`Error reading file: ${error}`);
    }
    
    return Return;
};

JsonTransformXml.prototype._GetMqttMappingData_ = function(PrefixWord, ModuleIndex, MqttVariable, Variable, Module, MQTTServiceTask, isScaling) 
{
	var Index = ModuleIndex.split("_")[1];
	if (typeof(MqttVariable[Index]) == "undefined") { return; }
	var SystemVariable = Object.keys(MqttVariable[Index]);
	for (var j = 0; j < SystemVariable.length; j++) {
		if (MqttVariable[Index][SystemVariable[j]]["TransformMqtt"] == true) {
			if (isScaling && Variable[Index][SystemVariable[j]]["TransformScaling"] == false) {
				continue; // Skip this iteration if isScaling is true and TransformScaling is false
			}
			var MQTTMapping = {};
			var variableNameKey = isScaling ? "ScaleVariableName" : "VariableName";
			MQTTMapping["Name"] = PrefixWord + Index + "_" + JsonTransformXml.prototype._GetModuleName_(Module, Index) + "_" + SystemVariable[j].split("-")[0] + (isScaling ? "_Scale." : ".") + Variable[Index][SystemVariable[j]][variableNameKey];
			MQTTMapping["PubTopic"] = MqttVariable[Index][SystemVariable[j]]["PublishTopic"];
			MQTTMapping["PubQoS"] = MqttVariable[Index][SystemVariable[j]]["PublishQos"];
			MQTTMapping["SubTopic"] = MqttVariable[Index][SystemVariable[j]]["SubscribeTopic"];
			MQTTMapping["SubQoS"] = MqttVariable[Index][SystemVariable[j]]["SubscribeQos"];
			MQTTMapping["DataType"] = JsonTransformXml.prototype._GetDataType_(SystemVariable[j].split("-")[1]);
			MQTTMapping["Property"] = JsonTransformXml.prototype._GetProperty_(SystemVariable[j].split("-")[0]);
			MQTTMapping["Retain"] = JsonTransformXml.prototype._GetRetainNumber_(MqttVariable[Index][SystemVariable[j]]["Retain"]);
			MQTTServiceTask["MQTTMapping"].push(MQTTMapping);
		}
	}
};


JsonTransformXml.prototype._GetMqttMappingObject_ = async function(ObjectArray, MQTTServiceTask) {
    const Class = new LoadFile();
    const ModuleIndex = ObjectArray["ModuleIndex"];
    const filePaths = {
        "Rtu_": ["./File/RTU_Module/RtuToMqttVariable.json", "./File/RTU_Module/RtuVariable.json", "./File/RTU_Module/Module.json", "./File/RTU_Module/RtuScalingToMqttVariable.json", "./File/RTU_Module/RtuScalingVariable.json"],
        "Tcp_": ["./File/TCP_Module/TcpToMqttVariable.json", "./File/TCP_Module/TcpVariable.json", "./File/TCP_Module/Module.json", "./File/TCP_Module/TcpScalingToMqttVariable.json", "./File/TCP_Module/TcpScalingVariable.json"],
        "Ascii_": ["./File/ASCII_Module/AsciiToMqttVariable.json", "./File/ASCII_Module/AsciiVariable.json", "./File/ASCII_Module/Module.json"],
        "Eip_": ["./File/EIP_Module/EipToMqttVariable.json", "./File/EIP_Module/EipVariable.json", "./File/EIP_Module/Module.json"]
    };

    for (let module of ModuleIndex) {
        for (let key in filePaths) {
            if (module.includes(key)) {
                const files = await Promise.all(filePaths[key].map(path => Class._ReadFile_(path, {})));

                switch (key) {
                    case "Rtu_":
                        JsonTransformXml.prototype._GetMqttMappingData_("MRTU_No.", module, files[0], files[1], files[2], MQTTServiceTask);
                        JsonTransformXml.prototype._GetMqttMappingData_("MRTU_No.", module, files[3], files[4], files[2], MQTTServiceTask, true);
                        break;
                    case "Tcp_":
                        JsonTransformXml.prototype._GetMqttMappingData_("MTCP_No.", module, files[0], files[1], files[2], MQTTServiceTask);
                        JsonTransformXml.prototype._GetMqttMappingData_("MTCP_No.", module, files[3], files[4], files[2], MQTTServiceTask, true);
                        break;
                    case "Ascii_":
                        JsonTransformXml.prototype._GetMqttMappingData_("MASCII_No.", module, files[0], files[1], files[2], MQTTServiceTask);
                        break;
                    case "Eip_":
                        JsonTransformXml.prototype._GetEipMqttMappingData_("EIP_No.", module, files[0], files[1], files[2], MQTTServiceTask);
                        break;
                }
                break;
            }
        }
    }
};

 
JsonTransformXml.prototype._GetMqttServiceTaskObject_ = async function() 
{
    const LocalBroker = await JsonTransformXml.prototype._GetLocalBrokerData_();
    const Class = new LoadFile();
    
    try {
        const RemoteBroker = await Class.ReadFile("./File/IoT_Platform/RemoteBroker.json");
        const MQTTServiceTaskArray = [];
        const ObjectArray = await JsonTransformXml.prototype._ArrangeMqttServices_();
        
        for (const obj of ObjectArray) {
            const MQTTServiceTask = {
                TaskID: -1,
                ScanRate: obj.ScanRate,
                DeadBand: obj.DeadBand,
                WillTopic: obj.WillTopic,
                Will: obj.Will,
                MQTTMapping: [],
                Broker: {}
            };
            await JsonTransformXml.prototype._GetMqttConnectionData_(obj, MQTTServiceTask, LocalBroker, RemoteBroker);
            MQTTServiceTaskArray.push(MQTTServiceTask);
        }
        
        return MQTTServiceTaskArray;
    } catch (error) {
        //console.error(`Error reading file: ${error}`);
        return [];
    }
};

JsonTransformXml.prototype._InitializeTaskId_ = function(MQTTService)
{
	var Index=1;
	var Length=MQTTService["MQTTService"]["MQTTServiceTask"].length;
	for(var i=0; i<Length; i++)
	{
		MQTTService["MQTTService"]["MQTTServiceTask"][i]["TaskID"]=Index;
		Index++;
	}
	Length=MQTTService["MQTTService"]["MQTTServiceTask_JSON"].length;
	for(var i=0; i<Length; i++)
	{
		MQTTService["MQTTService"]["MQTTServiceTask_JSON"][i]["TaskID"]=Index;
		Index++;
	}
	Length=MQTTService["MQTTService"]["MQTTCustomServiceTask"].length;
	for(var i=0; i<Length; i++)
	{
		MQTTService["MQTTService"]["MQTTCustomServiceTask"][i]["TaskID"]=Index;
		Index++;
	}
}

JsonTransformXml.prototype._GetMqttServiceTransformObject_ = async function() 
{
    const Class = new LoadFile();
    
    try {
        const [
            RtuToMqttSetting, RtuToMqttVariable, TcpToMqttSetting, TcpToMqttVariable,
            AsciiToMqttSetting, AsciiToMqttVariable, EipToMqttSetting, EipToMqttVariable,
            TcpScalingToMqttVariable, RtuScalingToMqttVariable
        ] = await Promise.all([
            Class.ReadFile("./File/RTU_Module/RtuToMqttSetting.json"),
            Class.ReadFile("./File/RTU_Module/RtuToMqttVariable.json"),
            Class.ReadFile("./File/TCP_Module/TcpToMqttSetting.json"),
            Class.ReadFile("./File/TCP_Module/TcpToMqttVariable.json"),
            Class.ReadFile("./File/ASCII_Module/AsciiToMqttSetting.json"),
            Class.ReadFile("./File/ASCII_Module/AsciiToMqttVariable.json"),
            Class.ReadFile("./File/EIP_Module/EipToMqttSetting.json"),
            Class.ReadFile("./File/EIP_Module/EipToMqttVariable.json"),
            Class.ReadFile("./File/TCP_Module/TcpScalingToMqttVariable.json"),
            Class.ReadFile("./File/RTU_Module/RtuScalingToMqttVariable.json")
        ]);

        return {
            RtuToMqttSetting,
            RtuToMqttVariable,
            TcpToMqttSetting,
            TcpToMqttVariable,
            AsciiToMqttSetting,
            AsciiToMqttVariable,
            EipToMqttSetting,
            EipToMqttVariable,
            TcpScalingToMqttVariable,
            RtuScalingToMqttVariable
        };
    } catch (error) {
        //console.error(`Error reading files: ${error}`);
        return {};
    }
};


JsonTransformXml.prototype._TransformMqttServiceXml_ = async function()
{	
	var obj = new Object();
	obj["MQTTService"] = new Object();
	obj["MQTTService"]["MQTTServiceTask"] = new Array();
	obj["MQTTService"]["MQTTServiceTask"] = await JsonTransformXml.prototype._GetMqttServiceTaskObject_();
	JsonTransformXml.prototype._RemoveUnusedConnection_(obj);
	
	obj["MQTTService"]["MQTTServiceTask_JSON"] = new Array();
	obj["MQTTService"]["MQTTServiceTask_JSON"] = await JsonTransformXml.prototype._GetMqttServiceTaskJsonArray_();

	obj["MQTTService"]["MQTTCustomServiceTask"] = new Array();
	obj["MQTTService"]["MQTTCustomServiceTask"] = await JsonTransformXml.prototype._GetMqttCustomServiceTaskArray_();

	JsonTransformXml.prototype._InitializeTaskId_(obj);
	var xotree = new XML.ObjTree();
	var xml = xotree.writeXML(obj);
	return xml;
}

JsonTransformXml.prototype._GetUAServerDataXmlTransformObject_ = async function() {
    const Class = new LoadFile();
    
    try {
        const files = await Promise.all([
            Class.ReadFile("./File/RTU_Module/RtuVariable.json"),
            Class.ReadFile("./File/RTU_Module/RtuScalingVariable.json"),
            Class.ReadFile("./File/RTU_Module/RtuBitwiseVariable.json"),
            Class.ReadFile("./File/RTU_Module/RtuToOpcuaVariable.json"),
            Class.ReadFile("./File/RTU_Module/RtuScalingToOpcuaVariable.json"),
            Class.ReadFile("./File/RTU_Module/RtuBitwiseToOpcuaVariable.json"),
            Class.ReadFile("./File/RTU_Module/Module.json"),
            Class.ReadFile("./File/ASCII_Module/AsciiVariable.json"),
            Class.ReadFile("./File/ASCII_Module/AsciiToOpcuaVariable.json"),
            Class.ReadFile("./File/ASCII_Module/Module.json"),
            Class.ReadFile("./File/TCP_Module/TcpVariable.json"),
            Class.ReadFile("./File/TCP_Module/TcpScalingVariable.json"),
            Class.ReadFile("./File/TCP_Module/TcpBitwiseVariable.json"),
            Class.ReadFile("./File/TCP_Module/TcpToOpcuaVariable.json"),
            Class.ReadFile("./File/TCP_Module/TcpScalingToOpcuaVariable.json"),
            Class.ReadFile("./File/TCP_Module/TcpBitwiseToOpcuaVariable.json"),
            Class.ReadFile("./File/TCP_Module/Module.json"),
            Class.ReadFile("./File/MQTT_Module/MqttVariable.json"),
            Class.ReadFile("./File/MQTT_Module/MqttToOpcuaVariable.json"),
            Class.ReadFile("./File/MQTT_Module/Module.json"),
            Class.ReadFile("./File/EIP_Module/EipVariable.json"),
            Class.ReadFile("./File/EIP_Module/EipToOpcuaVariable.json"),
            Class.ReadFile("./File/EIP_Module/Module.json"),
            Class.ReadFile("./File/XV_Module/XVVariable.json"),
            Class.ReadFile("./File/XV_Module/XVToOpcuaVariable.json"),
            Class.ReadFile("./File/XV_Module/Module.json"),
            Class.ReadFile("./File/Register_Module/RegisterVariable.json"),
            Class.ReadFile("./File/Register_Module/RegisterToOpcuaVariable.json"),
            Class.ReadFile("./File/Register_Module/Module.json")
        ]);

        const [
            RtuVariable, RtuScalingVariable, RtuBitwiseVariable, RtuToOpcuaVariable, RtuScalingToOpcuaVariable, RtuBitwiseToOpcuaVariable, RtuModule,
            AsciiVariable, AsciiToOpcuaVariable, AsciiModule,
            TcpVariable, TcpScalingVariable, TcpBitwiseVariable, TcpToOpcuaVariable, TcpScalingToOpcuaVariable, TcpBitwiseToOpcuaVariable, TcpModule,
            MqttVariable, MqttToOpcuaVariable, MqttModule,
            EipVariable, EipToOpcuaVariable, EipModule,
            XVVariable, XVToOpcuaVariable, XVModule,
            RegisterVariable, RegisterToOpcuaVariable, RegisterModule
        ] = files;
        
        return {
            RtuVariable,
            RtuScalingVariable,
            RtuBitwiseVariable,
            RtuToOpcuaVariable,
            RtuScalingToOpcuaVariable,
            RtuBitwiseToOpcuaVariable,
            RtuModule,
            AsciiVariable,
            AsciiToOpcuaVariable,
            AsciiModule,
            TcpVariable,
            TcpScalingVariable,
            TcpBitwiseVariable,
            TcpToOpcuaVariable,
            TcpScalingToOpcuaVariable,
            TcpBitwiseToOpcuaVariable,
            TcpModule,
            MqttVariable,
            MqttToOpcuaVariable,
            MqttModule,
            EipVariable,
            EipToOpcuaVariable,
            EipModule,
            XVVariable,
            XVToOpcuaVariable,
            XVModule,
            RegisterVariable,
            RegisterToOpcuaVariable,
            RegisterModule
        };
    } catch (error) {
        //console.error(`Error reading files: ${error}`);
        return {};
    }
};

JsonTransformXml.prototype._GetBaseVariableData_ = function(ModuleType, Variable, SystemVariable, number, ModuleName, ToOpcuaVariable)
{
	var Return = new Array();
	var BaseVariableData, Name, MapVariable;
	for(var i=0; i<SystemVariable.length; i++)
	{
		if(ToOpcuaVariable[number][SystemVariable[i]]["TransformOpcUa"] == false)
		{
			continue;
		}
		BaseVariableData = new Object();
		BaseVariableData["UATypeId"] = JsonTransformXml.prototype._GetInputOutputData_(SystemVariable[i].split("-")[0])+SystemVariable[i].split("-")[1];
		Name = JsonTransformXml.prototype._GetClientVariablePrefixWords_(ModuleType, SystemVariable[i].split("-")[0])+"."+Variable[number][SystemVariable[i]]["VariableName"];
		BaseVariableData["Name"] = Name;
		
		if(ModuleType==="XV")
			MapVariable="XVBoard_"+ModuleName+"."+SystemVariable[i].split("-")[0]+"."+Variable[number][SystemVariable[i]]["VariableName"];
		else
			MapVariable = ModuleType+"_No."+number+"_"+ModuleName+"_"+SystemVariable[i].split("-")[0]+"."+Variable[number][SystemVariable[i]]["VariableName"];

		BaseVariableData["MapVariable"] = MapVariable;
		BaseVariableData["StatusCode"] = 0;
		BaseVariableData["DefaultValue"] = 0;
		BaseVariableData["Description"] = Variable[number][SystemVariable[i]]["Description"];
		Return.push(BaseVariableData);
	}
	return Return;
}

JsonTransformXml.prototype._GetBaseEipVariableData_ = function(ModuleType, Variable, SystemVariable, number, ModuleName, ToOpcuaVariable)
{
	var Return = new Array();
	var BaseVariableData, Name, MapVariable;
	var ChannelModeType = parseInt(Global_EipSetting[number]["ModeType"]);
	for(var i=0; i<ChannelModeType; i++)
	{
		if(ToOpcuaVariable[number][SystemVariable[i]]["TransformOpcUa"] == false)
		{
			continue;
		}
		BaseVariableData = new Object();
		BaseVariableData["UATypeId"] = JsonTransformXml.prototype._GetInputOutputData_(SystemVariable[i].split("-")[0])+SystemVariable[i].split("-")[1];
		//Name = JsonTransformXml.prototype._GetClientVariablePrefixWords_(ModuleType, SystemVariable[i].split("-")[0])+"."+Variable[number][SystemVariable[i]]["VariableName"];
		Name = SystemVariable[i].split("-")[0] + "." + Variable[number][SystemVariable[i]]["VariableName"];
		
		BaseVariableData["Name"] = Name;
		MapVariable = ModuleType+"_No."+number+"_"+ModuleName+"_"+SystemVariable[i].split("-")[0]+"."+Variable[number][SystemVariable[i]]["VariableName"];
		BaseVariableData["MapVariable"] = MapVariable;
		BaseVariableData["StatusCode"] = 0;
		BaseVariableData["DefaultValue"] = 0;
		BaseVariableData["Description"] = Variable[number][SystemVariable[i]]["Description"];
		Return.push(BaseVariableData);
	}
	return Return;
}
JsonTransformXml.prototype._GetBaseRegisterVariableData_ = function(ModuleType, Variable, SystemVariable, number, ModuleName, ToOpcuaVariable)
{
	var Return = new Array();
	var BaseVariableData, Name, MapVariable;
	//var ChannelModeType = parseInt(Global_EipSetting[number]["ModeType"]);
	for(var i=0; i<SystemVariable.length; i++)
	{
		if(ToOpcuaVariable[number][SystemVariable[i]]["TransformOpcUa"] == false)
		{
			continue;
		}
		BaseVariableData = new Object();
		BaseVariableData["UATypeId"] = JsonTransformXml.prototype._GetInputOutputData_(SystemVariable[i].split("-")[0])+SystemVariable[i].split("-")[1];
		//Name = JsonTransformXml.prototype._GetClientVariablePrefixWords_(ModuleType, SystemVariable[i].split("-")[0])+"."+Variable[number][SystemVariable[i]]["VariableName"];
		Name = SystemVariable[i].split("-")[0] + "." + Variable[number][SystemVariable[i]]["VariableName"];
		
		BaseVariableData["Name"] = Name.split(".")[1];
		MapVariable = "Internal" + "_No."+number+"_"+ModuleName+"."+Variable[number][SystemVariable[i]]["VariableName"];
		BaseVariableData["MapVariable"] = MapVariable;
		BaseVariableData["StatusCode"] = 0;
		BaseVariableData["DefaultValue"] = 0;
		BaseVariableData["Description"] = Variable[number][SystemVariable[i]]["Description"];
		Return.push(BaseVariableData);
	}
	return Return;
}

JsonTransformXml.prototype._GetUA_MethodData_ = function(PidName)
{
	var Return=new Array();
	var UA_MethodData=new Object();
	UA_MethodData["Name"]="Run";
	UA_MethodData["Method"]="PID_"+PidName+".Run";
	Return.push(UA_MethodData);
	UA_MethodData=new Object();
	UA_MethodData["Name"]="Stop";
	UA_MethodData["Method"]="PID_"+PidName+".Stop";
	Return.push(UA_MethodData);
	return Return;
}

JsonTransformXml.prototype._GetAnalogItemData_ = function(ModuleVariableIndex, PidNumber, PidOperationVariable)
{
	var Return = new Array();
	var OutputArray = ModuleVariableIndex.split("/");
	var ModuleType = OutputArray[0];
	var ModuleIndex = OutputArray[1];
	var VariableIndex = OutputArray[2];
	var AnalogItemData = new Object();
	var GlobalModule = GetValue.prototype._GetGlobalModule_(ModuleType);
	var ModuleName = GetValue.prototype._GetModuleName_(GlobalModule, ModuleIndex);
	var GlobalVariable=GetValue.prototype._GetGlobalVariable_(ModuleType);
	if(ModuleType=="MRTU Scaling" || ModuleType=="MTCP Scaling")
	{
		ModuleType = ModuleType.split(" ")[0];
		var VariableName=GetValue.prototype._GetModulePidScalingVariableName_(GlobalVariable, ModuleIndex, VariableIndex);
	}
	else
	{
		var VariableName=GetValue.prototype._GetModuleVariableName_(GlobalVariable, ModuleIndex, VariableIndex);
	}
	ModuleType = OutputArray[0];;
	AnalogItemData["UATypeId"]=JsonTransformXml.prototype._GetInputOutputData_(VariableIndex.split("-")[0])+VariableIndex.split("-")[1];
	AnalogItemData["Name"]=JsonTransformXml.prototype._GetClientVariablePrefixWords_(ModuleType, VariableIndex.split("-")[0])+"."+VariableName;
	if(ModuleType=="MRTU Scaling" || ModuleType=="MTCP Scaling")
	{
		ModuleType = ModuleType.split(" ")[0];
		AnalogItemData["MapVariable"]=ModuleType+"_No."+ModuleIndex+"_"+ModuleName+"_"+VariableIndex.split("-")[0]+"_Scale."+VariableName;
	}
	else
	{
		AnalogItemData["MapVariable"]=ModuleType+"_No."+ModuleIndex+"_"+ModuleName+"_"+VariableIndex.split("-")[0]+"."+VariableName;
	}
	AnalogItemData["StatusCode"]=0;
	AnalogItemData["DefaultValue"]=0;
	AnalogItemData["Range"]=new Object();
	AnalogItemData["Range"]["LowLimit"]=PidOperationVariable[PidNumber]["Min"];
	AnalogItemData["Range"]["HighLimit"]=PidOperationVariable[PidNumber]["Max"];
	Return.push(AnalogItemData);
	return Return;
}

JsonTransformXml.prototype._GetPidOperationBaseVariableData_ = function(Module, ModuleVariableIndex, PidName)
{
	var Return = new Array();
	var ModuleType=ModuleVariableIndex.split("/")[0];
	var ModuleIndex=ModuleVariableIndex.split("/")[1];
	var SystemVariable=ModuleVariableIndex.split("/")[2];
	var VirtualPoint = new Array("SetPoint", "Kp", "Ki", "Kd", "ControllerMode", "SampleTime", "AutoTune", "Status");
	var ComparisonValue = new Array("SetValue", "Kp", "Ki", "Kd", "ControllerMode", "SampleTime", "AutoTune", "Status");
	var InputOutputData = new Array("OutputData_Double", "OutputData_Double", "OutputData_Double", "OutputData_Double", "OutputData_Bool", "OutputData_Double", "OutputData_Bool", "InputData_Bool");
	var BaseVariableData, Name, MapVariable;
	BaseVariableData = new Object();
	BaseVariableData["UATypeId"] = JsonTransformXml.prototype._GetInputOutputData_(SystemVariable.split("-")[0])+SystemVariable.split("-")[1];
	var GlobalVariable=GetValue.prototype._GetGlobalVariable_(ModuleType);
	if(ModuleType=="MRTU Scaling" || ModuleType=="MTCP Scaling")
	{
		var ModuleVariableName=GetValue.prototype._GetModulePidScalingVariableName_(GlobalVariable, ModuleIndex, SystemVariable);
	}
	else
	{
		var ModuleVariableName=GetValue.prototype._GetModuleVariableName_(GlobalVariable, ModuleIndex, SystemVariable);
	}
	Name = JsonTransformXml.prototype._GetClientVariablePrefixWords_(ModuleType, SystemVariable.split("-")[0])+"."+ModuleVariableName;
	BaseVariableData["Name"] = Name;
	var ModuleName = JsonTransformXml.prototype._GetModuleName_(Module, ModuleIndex);

	if(ModuleType=="MRTU Scaling" || ModuleType=="MTCP Scaling")
	{
		ModuleType = ModuleType.split(" ")[0];
		MapVariable = ModuleType+"_No."+ModuleIndex+"_"+ModuleName+"_"+SystemVariable.split("-")[0]+"_Scale."+ModuleVariableName;
	}
	else
	{
		MapVariable = ModuleType+"_No."+ModuleIndex+"_"+ModuleName+"_"+SystemVariable.split("-")[0]+"."+ModuleVariableName;

	}
		BaseVariableData["MapVariable"] = MapVariable;
	BaseVariableData["StatusCode"] = 0;
	BaseVariableData["DefaultValue"] = 0;
	Return.push(BaseVariableData);
	for(var i=0; i<VirtualPoint.length; i++)
	{
		BaseVariableData = new Object();
		BaseVariableData["UATypeId"] = InputOutputData[i];
		BaseVariableData["Name"] = ComparisonValue[i];
		MapVariable = "PID_"+PidName+"."+VirtualPoint[i];
		BaseVariableData["MapVariable"] = MapVariable;
		BaseVariableData["StatusCode"] = 0;
		BaseVariableData["DefaultValue"] = 0;
		Return.push(BaseVariableData);
	}
	return Return;
}

JsonTransformXml.prototype._CheckBitwiseGlobalVariableExist_ = function(GlobalVariable, SystemVariable, VariableName)
{
	var Return; 

	if(typeof(GlobalVariable[SystemVariable][VariableName]) != "undefined")
	{
		Return = true;
	}
	return Return;
}

JsonTransformXml.prototype._BitwiseVariablePretreatment_ = function(number, Variable, ToOpcuaVariable)
{
	var Return=new Array(); var BitTotalNumber = 0; var BitNameId = ""; var VariableExist;
	var SystemVariable = Object.keys(ToOpcuaVariable[number]);
	for(var i=0; i<SystemVariable.length; i++)
	{
		if(Variable[number][SystemVariable[i]]["DataType"] == "Short" || Variable[number][SystemVariable[i]]["DataType"]== "Unsigned Short") BitTotalNumber = 16;
		else if(Variable[number][SystemVariable[i]]["DataType"] == "Long" || Variable[number][SystemVariable[i]]["DataType"] == "Unsigned Long")  BitTotalNumber = 32;
		for(var j=0; j<BitTotalNumber; j++)
		{
			BitNameId = "BitTagName-" + j.toString();
			VariableExist = JsonTransformXml.prototype._CheckBitwiseGlobalVariableExist_(ToOpcuaVariable[number], SystemVariable[i], BitNameId);
			if(VariableExist == true)
			{
				Obj = new Object();
				Obj["SystemVariable"]=SystemVariable[i];
				Obj["VariableName"]=Variable[number][SystemVariable[i]][BitNameId];
				Obj["GlobalIndexName"]=BitNameId;
				Obj["TransformOpcUa"]=ToOpcuaVariable[number][SystemVariable[i]][BitNameId];
				Obj["Description"]=Variable[number][SystemVariable[i]]["Description"];
				Return.push(Obj);
			}
		}
	}
	return Return;
}

JsonTransformXml.prototype._GetBitwiseVariableData_ = function(ModuleType, Variable, SystemVariable, number, ModuleName, ToOpcuaVariable)
{
	var Return = new Array();
	var BaseVariableData, Name, MapVariable;
	var BitwiseTotalTag = JsonTransformXml.prototype._BitwiseVariablePretreatment_(number, Variable, ToOpcuaVariable);
	for(var i=0; i<BitwiseTotalTag.length; i++)
	{
		if(BitwiseTotalTag[i]["TransformOpcUa"] == false)
		{
			continue;
		}
		BaseVariableData = new Object();
		BaseVariableData["UATypeId"] = JsonTransformXml.prototype._GetInputOutputData_(BitwiseTotalTag[i]["SystemVariable"].split("-")[0])+"Bool";
		Name = JsonTransformXml.prototype._GetClientVariablePrefixWords_(ModuleType, BitwiseTotalTag[i]["SystemVariable"].split("-")[0])+"."+BitwiseTotalTag[i]["VariableName"];
		Name = Name.split(".")[0] + "_Bitwise." + Name.split(".")[1];
		BaseVariableData["Name"] = Name;
		MapVariable = ModuleType+"_No."+number+"_"+ModuleName+"_"+BitwiseTotalTag[i]["SystemVariable"].split("-")[0]+"_Bitwise"+"."+BitwiseTotalTag[i]["VariableName"];
		BaseVariableData["MapVariable"] = MapVariable;
		BaseVariableData["StatusCode"] = 0;
		BaseVariableData["DefaultValue"] = 0;
		BaseVariableData["Description"] = BitwiseTotalTag[i]["Description"];
		Return.push(BaseVariableData);
	}
	return Return;
}
JsonTransformXml.prototype._GetBitwiseVariable_ = function(ModuleType, Obj)
{
	var Return;

	if(ModuleType=="MRTU")
	{
		Return = Obj["RtuBitwiseVariable"];
	}
	else if(ModuleType=="MTCP")
	{
		Return = Obj["TcpBitwiseVariable"];
	}

	return Return;
}
JsonTransformXml.prototype._GetBitwiseToOpcuaVariable_ = function(ModuleType, Obj)
{
	var Return;

	if(ModuleType=="MRTU")
	{
		Return = Obj["RtuBitwiseToOpcuaVariable"];
	}
	else if(ModuleType=="MTCP")
	{
		Return = Obj["TcpBitwiseToOpcuaVariable"];
	}

	return Return;
}
JsonTransformXml.prototype._GetBitwise_Objectdata_ = function(ModuleType, Obj, number, ModuleName)
{
	var Return;

	var Variable = JsonTransformXml.prototype._GetBitwiseVariable_(ModuleType, Obj);
	var ToOpcuaVariable = JsonTransformXml.prototype._GetBitwiseToOpcuaVariable_(ModuleType, Obj);
	if(typeof(ToOpcuaVariable[number]) != "object") {return 0;}
	var SystemVariable = Object.keys(ToOpcuaVariable[number]);

	Return = JsonTransformXml.prototype._GetBitwiseVariableData_(ModuleType, Variable, SystemVariable, number, ModuleName, ToOpcuaVariable);

	return Return;
}

JsonTransformXml.prototype._GetScalingVariableData_ = function(ModuleType, Variable, SystemVariable, number, ModuleName, ToOpcuaVariable)
{
	var Return = new Array();
	var BaseVariableData, Name, MapVariable;
	for(var i=0; i<SystemVariable.length; i++)
	{
		if(ToOpcuaVariable[number][SystemVariable[i]]["TransformOpcUa"] == false)
		{
			continue;
		}
		BaseVariableData = new Object();
		BaseVariableData["UATypeId"] = JsonTransformXml.prototype._GetInputOutputData_(SystemVariable[i].split("-")[0])+"Float";
		Name = JsonTransformXml.prototype._GetClientVariablePrefixWords_(ModuleType, SystemVariable[i].split("-")[0])+"."+Variable[number][SystemVariable[i]]["ScaleVariableName"];
		Name = Name.split(".")[0] + "_Scale." + Name.split(".")[1];
		BaseVariableData["Name"] = Name;
		MapVariable = ModuleType+"_No."+number+"_"+ModuleName+"_"+SystemVariable[i].split("-")[0]+"_Scale"+"."+Variable[number][SystemVariable[i]]["ScaleVariableName"];
		BaseVariableData["MapVariable"] = MapVariable;
		BaseVariableData["StatusCode"] = 0;
		BaseVariableData["DefaultValue"] = 0;
		BaseVariableData["Description"] = Variable[number][SystemVariable[i]]["Description"];
		Return.push(BaseVariableData);
	}
	return Return;
}

JsonTransformXml.prototype._GetScalingVariable_ = function(ModuleType, Obj)
{
	var Return;

	if(ModuleType=="MRTU")
	{
		Return = Obj["RtuScalingVariable"];
	}
	else if(ModuleType=="MTCP")
	{
		Return = Obj["TcpScalingVariable"];
	}

	return Return;
}
JsonTransformXml.prototype._GetScalingToOpcuaVariable_ = function(ModuleType, Obj)
{
	var Return;

	if(ModuleType=="MRTU")
	{
		Return = Obj["RtuScalingToOpcuaVariable"];
	}
	else if(ModuleType=="MTCP")
	{
		Return = Obj["TcpScalingToOpcuaVariable"];
	}

	return Return;
}
JsonTransformXml.prototype._GetScaling_Objectdata_ = function(ModuleType, Obj, number, ModuleName)
{
	var Return;

	var Variable = JsonTransformXml.prototype._GetScalingVariable_(ModuleType, Obj);
	var ToOpcuaVariable = JsonTransformXml.prototype._GetScalingToOpcuaVariable_(ModuleType, Obj);
	if(typeof(ToOpcuaVariable[number]) != "object") {return 0;}
	var SystemVariable = Object.keys(ToOpcuaVariable[number]);

	Return = JsonTransformXml.prototype._GetScalingVariableData_(ModuleType, Variable, SystemVariable, number, ModuleName, ToOpcuaVariable);

	return Return;
}
JsonTransformXml.prototype._GetPidScaling_Objectdata_ = function(ModuleType, Obj, number, ModuleName)
{
	var Return;

	var Variable = JsonTransformXml.prototype._GetScalingVariable_(ModuleType, Obj);
	var ToOpcuaVariable = JsonTransformXml.prototype._GetScalingToOpcuaVariable_(ModuleType, Obj);
	if(typeof(ToOpcuaVariable[number]) != "object") {return 0;}
	var SystemVariable = Object.keys(ToOpcuaVariable[number]);

	Return = JsonTransformXml.prototype._GetScalingVariableData_(ModuleType, Variable, SystemVariable, number, ModuleName, ToOpcuaVariable);

	return Return;
}

JsonTransformXml.prototype._GetVariable_ = function(ModuleType, Obj)
{
	var Return;

	if(ModuleType=="MRTU")
	{
		Return = Obj["RtuVariable"];
	}
	else if(ModuleType=="MASCII")
	{
		Return = Obj["AsciiVariable"];
	}
	else if(ModuleType=="MTCP")
	{
		Return = Obj["TcpVariable"];
	}
	else if(ModuleType=="MQTT")
	{
		Return = Obj["MqttVariable"];
	}
	else if(ModuleType=="XV")
	{
		Return = Obj["XVVariable"];
	}
	return Return;
}
JsonTransformXml.prototype._GetToOpcuaVariable_ = function(ModuleType, Obj)
{
	var Return;

	if(ModuleType=="MRTU")
	{
		Return = Obj["RtuToOpcuaVariable"];
	}
	else if(ModuleType=="MASCII")
	{
		Return = Obj["AsciiToOpcuaVariable"];
	}
	else if(ModuleType=="MTCP")
	{
		Return = Obj["TcpToOpcuaVariable"];
	}
	else if(ModuleType=="MQTT")
	{
		Return = Obj["MqttToOpcuaVariable"];
	}
	else if(ModuleType=="XV")
	{
		Return = Obj["XVToOpcuaVariable"];
	}
	return Return;
}
JsonTransformXml.prototype._GetModule_ = function(ModuleType, Obj)
{
	var Return;

	if(ModuleType=="MRTU")
	{
		Return = Obj["RtuModule"];
	}
	else if(ModuleType=="MASCII")
	{
		Return = Obj["AsciiModule"];
	}
	else if(ModuleType=="MTCP")
	{
		Return = Obj["TcpModule"];
	}
	else if(ModuleType=="MQTT")
	{
		Return = Obj["MqttModule"];
	}else if(ModuleType=="XV")
	{
		Return = Obj["XVModule"];
	}

	return Return;
}
JsonTransformXml.prototype._GetUA_Objectdata_ = function(ModuleType, Obj)
{
	var Return = new Array();
	ToOpcuaVariable = JsonTransformXml.prototype._GetToOpcuaVariable_(ModuleType, Obj);
	Module = JsonTransformXml.prototype._GetModule_(ModuleType, Obj);
	Variable = JsonTransformXml.prototype._GetVariable_(ModuleType, Obj);
	var number = Object.keys(ToOpcuaVariable);
	for(var i=0; i<number.length; i++)
	{
		var ModuleName;
		var UA_Objectdata = new Object();
		if(ModuleType==="XV")
		{
			ModuleName=Module.Name;
			UA_Objectdata["Name"]="XVBoard_"+ModuleName;
		}
		else
		{
			ModuleName = JsonTransformXml.prototype._GetModuleName_(Module, number[i]);
			UA_Objectdata["Name"]=ModuleType+"_No."+number[i]+"_"+ModuleName;
		}
			
		UA_Objectdata["ObjectType"] = 1;
		UA_Objectdata["LocalId"] = "en";
		UA_Objectdata["BaseVariableData"] = new Array();
		var SystemVariable = Object.keys(ToOpcuaVariable[number[i]]);
		UA_Objectdata["BaseVariableData"] = JsonTransformXml.prototype._GetBaseVariableData_(ModuleType, Variable, SystemVariable, number[i], ModuleName, ToOpcuaVariable);
		if( (ModuleType=="MTCP") || (ModuleType=="MRTU") )
		{
			UA_Objectdata["BaseVariableData"].push(JsonTransformXml.prototype._GetScaling_Objectdata_(ModuleType, Obj, number[i], ModuleName));
			UA_Objectdata["BaseVariableData"].push(JsonTransformXml.prototype._GetBitwise_Objectdata_(ModuleType, Obj, number[i], ModuleName));
			//UA_Objectdata["BaseVariableData"].push(JsonTransformXml.prototype._GetPidScaling_Objectdata_(ModuleType, Obj, number[i], ModuleName));
		}



		if(UA_Objectdata["BaseVariableData"].length > 0)
		{
			Return.push(UA_Objectdata);
		}
	}
	return Return;
}

JsonTransformXml.prototype._GetEipUA_Objectdata_ = async function(ModuleType, Module, Variable, ToOpcuaVariable) {
    const Return = [];
    const number = Object.keys(ToOpcuaVariable);
    const Class = new LoadFile();
    
    try {
        const EipSetting = await Class.ReadFile("./File/EIP_Module/EipSetting.json");
        number.forEach(i => {
            const ModuleName = EipSetting[i].NickName;
            const UA_Objectdata = {
                Name: `${ModuleType}_No.${i}_${ModuleName}`,
                ObjectType: 1,
                LocalId: "en",
                BaseVariableData: []
            };
            const SystemVariable = Object.keys(ToOpcuaVariable[i]);
            UA_Objectdata.BaseVariableData = JsonTransformXml.prototype._GetBaseEipVariableData_(ModuleType, Variable, SystemVariable, i, ModuleName, ToOpcuaVariable);
            if (UA_Objectdata.BaseVariableData.length > 0) {
                Return.push(UA_Objectdata);
            }
        });
        return Return;
    } catch (error) {
        //console.error(`Error reading file: ${error}`);
        return [];
    }
};

JsonTransformXml.prototype._GetRegisterUA_Objectdata_ = async function(ModuleType, Module, Variable, ToOpcuaVariable) {
    const Return = [];
    const number = Object.keys(ToOpcuaVariable);
    const Class = new LoadFile();
    
    try {
        const RegisterModule = await Class.ReadFile("./File/Register_Module/Module.json");
        for (let i = 0; i < number.length; i++) {
            const ModuleName = RegisterModule[number[i]]["ModuleName"];
            const UA_Objectdata = {
                Name: `Internal_No.${number[i]}_${ModuleName}`,
                ObjectType: 1,
                LocalId: "en",
                BaseVariableData: []
            };
            
            const SystemVariable = Object.keys(ToOpcuaVariable[number[i]]);
            UA_Objectdata.BaseVariableData = JsonTransformXml.prototype._GetBaseRegisterVariableData_(ModuleType, Variable, SystemVariable, number[i], ModuleName, ToOpcuaVariable);
            
            if (UA_Objectdata.BaseVariableData.length > 0) {
                Return.push(UA_Objectdata);
            }
        }
        return Return;
    } catch (error) {
        //console.error(`Error reading file: ${error}`);
        return [];
    }
};

JsonTransformXml.prototype._GetPidUA_Objectdata_ = async function() {
    const Return = [];
    const Class = new LoadFile();
    const VirtualPoint = ["Min", "Max", "SetPoint", "Kp", "Ki", "Kd", "ControllerMode", "SampleTime", "AutoTune", "Status"];
    const ComparisonValue = ["Min", "Max", "SetValue", "Kp", "Ki", "Kd", "ControllerMode", "SampleTime", "AutoTune", "Status"];
    
    try {
        const PidOperation = await Class.ReadFile("./File/PID_Operation/PidOperation.json");
        const PidNumber = Object.keys(PidOperation);
        let PidName, ModuleType, ModuleName, ModuleIndex, ModuleVariableIndex;
        
        for (let i = 0; i < PidNumber.length; i++) {
            if (PidOperation[PidNumber[i]]["InputModuleVariableIndex"] === "//" ||
                PidOperation[PidNumber[i]]["OutputModuleVariableIndex"] === "//") {
                continue;
            }
            
            PidName = PidOperation[PidNumber[i]]["Name"];
            ModuleVariableIndex = PidOperation[PidNumber[i]]["InputModuleVariableIndex"];
            const InputArray = ModuleVariableIndex.split("/");
            ModuleType = InputArray[0];
            ModuleIndex = InputArray[1];
            const Module = GetValue.prototype._GetGlobalModule_(ModuleType);
            ModuleName = JsonTransformXml.prototype._GetModuleName_(Module, ModuleIndex);
            
            const UA_Objectdata = {
                Name: `PID_${PidName}`,
                ObjectType: 1,
                LocalId: "en",
                BaseVariableData: [],
                AnalogItemData: [],
                UA_MethodData: []
            };
            
            UA_Objectdata.BaseVariableData = JsonTransformXml.prototype._GetPidOperationBaseVariableData_(Module, ModuleVariableIndex, PidName);
            ModuleVariableIndex = PidOperation[PidNumber[i]]["OutputModuleVariableIndex"];
            UA_Objectdata.AnalogItemData = JsonTransformXml.prototype._GetAnalogItemData_(ModuleVariableIndex, PidNumber[i], PidOperation);
            UA_Objectdata.UA_MethodData = JsonTransformXml.prototype._GetUA_MethodData_(PidName);
            
            if (UA_Objectdata.BaseVariableData.length > 0) {
                Return.push(UA_Objectdata);
            }
        }
        return Return;
    } catch (error) {
        //console.error(`Error reading file: ${error}`);
        return [];
    }
};

JsonTransformXml.prototype._GetUA_ServiceData_ = function(UA_Objectdata)
{
	var UA_ServiceData = new Object();
	UA_ServiceData["UA_ServiceData"] = new Object();
	UA_ServiceData["UA_ServiceData"]["UA_NodeManagerData"] = new Object();
	UA_ServiceData["UA_ServiceData"]["UA_NodeManagerData"]["NameSpaceUri"] = "UAServer/IOmodule";
	UA_ServiceData["UA_ServiceData"]["UA_NodeManagerData"]["ManagerTypeId"] = 0;
	UA_ServiceData["UA_ServiceData"]["UA_NodeManagerData"]["FiresEvents"] = 0;
	UA_ServiceData["UA_ServiceData"]["UA_NodeManagerData"]["TableSize"] = 20000;
	UA_ServiceData["UA_ServiceData"]["UA_NodeManagerData"]["UA_Objectdata"] = new Array();
	UA_ServiceData["UA_ServiceData"]["UA_NodeManagerData"]["UA_Objectdata"] = UA_Objectdata;
	return UA_ServiceData;
}

JsonTransformXml.prototype._TransformUAServerConfigXml_ = async function() 
{
	var Class = new LoadFile();
	
	// Wrap ReadXmlObject in a promise
	var XmlObject = await new Promise((resolve, reject) => {
		try {
			var result = Class.ReadXmlObject("./File/IoT_Platform/UAServerConfig.xml", new Object());
			resolve(result);
		} catch (error) {
			reject(error);
		}
	});

	// Ensure nested properties exist and assign the value
	if (!XmlObject.OpcServerConfig) XmlObject.OpcServerConfig = {};
	if (!XmlObject.OpcServerConfig.UaServerConfig) XmlObject.OpcServerConfig.UaServerConfig = {};
	if (!XmlObject.OpcServerConfig.UaServerConfig.UaEndpoint) XmlObject.OpcServerConfig.UaServerConfig.UaEndpoint = {};
	if (!XmlObject.OpcServerConfig.UaServerConfig.UaEndpoint.CertificateStore) XmlObject.OpcServerConfig.UaServerConfig.UaEndpoint.CertificateStore = {};
	if (!XmlObject.OpcServerConfig.UaServerConfig.UaEndpoint.CertificateStore.OpenSSLStore) XmlObject.OpcServerConfig.UaServerConfig.UaEndpoint.CertificateStore.OpenSSLStore = {};

	XmlObject.OpcServerConfig.UaServerConfig.UaEndpoint.CertificateStore.OpenSSLStore.CertificateTrustListLocation = "/app/Certificates/OPCUA/trusted/";

	var xotree = new XML.ObjTree();
	var xml = xotree.writeXML(XmlObject);
	var array = new Array(xml);
	return array;
}

	

JsonTransformXml.prototype._TransformUAServerDataXml_ = async function()
{
	var UA_Objectdata = new Array();

	var Obj = await JsonTransformXml.prototype._GetUAServerDataXmlTransformObject_();

	UA_Objectdata = UA_Objectdata.concat(JsonTransformXml.prototype._GetUA_Objectdata_("MRTU", Obj));
	UA_Objectdata = UA_Objectdata.concat(JsonTransformXml.prototype._GetUA_Objectdata_("MASCII", Obj));
	UA_Objectdata = UA_Objectdata.concat(JsonTransformXml.prototype._GetUA_Objectdata_("MTCP", Obj));
	UA_Objectdata = UA_Objectdata.concat(JsonTransformXml.prototype._GetUA_Objectdata_("MQTT", Obj));

	UA_Objectdata = UA_Objectdata.concat(await JsonTransformXml.prototype._GetPidUA_Objectdata_());
	UA_Objectdata = UA_Objectdata.concat(await JsonTransformXml.prototype._GetEipUA_Objectdata_("EIP", Obj["EipModule"], Obj["EipVariable"], Obj["EipToOpcuaVariable"]));
	UA_Objectdata = UA_Objectdata.concat(JsonTransformXml.prototype._GetUA_Objectdata_("XV", Obj));

	UA_Objectdata = UA_Objectdata.concat(await JsonTransformXml.prototype._GetRegisterUA_Objectdata_("Register", Obj["RegisterModule"], Obj["RegisterVariable"], Obj["RegisterToOpcuaVariable"]));


	//UA_Objectdata = UA_Objectdata.concat(JsonTransformXml.prototype._GetUA_Objectdata_("MRTU Scaling", Obj));
	//UA_Objectdata = UA_Objectdata.concat(JsonTransformXml.prototype._GetUA_Objectdata_("MTCP Scaling", Obj));

	var UA_ServiceData = JsonTransformXml.prototype._GetUA_ServiceData_(UA_Objectdata);
	
	var xotree = new XML.ObjTree();
	var xml = xotree.writeXML(UA_ServiceData);
	return xml;
}

JsonTransformXml.prototype._TransformModbusDri_ = async function() {
    var ModbusTask = new Array();
    var ModbusDriver = new Object();
    ModbusDriver["ModbusDriver"] = new Object();
    ModbusDriver["ModbusDriver"]["ModbusTask"] = new Array();

    var Obj = await JsonTransformXml.prototype._GetModbusDriTransformObject_();
    ModbusTask = await JsonTransformXml.prototype._GetModbusRtuTask_(Obj["RtuModule"], Obj["RtuVariable"], Obj["RtuSetting"]);
    ModbusTask = ModbusTask.concat(await JsonTransformXml.prototype._GetModbusAsciiTask_(Obj["AsciiModule"], Obj["AsciiVariable"], Obj["AsciiSetting"]));
    ModbusTask = ModbusTask.concat(JsonTransformXml.prototype._GetModbusTcpTask_(Obj["TcpModule"], Obj["TcpVariable"], Obj["TcpSetting"]));
    ModbusDriver["ModbusDriver"]["ModbusTask"] = ModbusTask;
    
    ModbusDriver = JsonTransformXml.prototype._SortTaskId_(ModbusDriver);
    
    var xotree = new XML.ObjTree();
    var xml = xotree.writeXML(ModbusDriver);
    return xml;
}

var generateXVGroup = async function() 
{
	const Class = new LoadFile();
	try {
		const XVModule = await Class.ReadFile("./File/XV_Module/Module.json", {});
		const XVGropus = [];
		if (Object.keys(XVModule).length === 0) return XVGropus;

		if (XVModule.DI.length > 0) {
			let XVDIGroup = {
				Name: "1",
				DataModel: 0,
				ResponseTimeout: 20,
				SlaveId: 1,
				StartAddress: 0,
				Length: XVModule.DI.length * 1,
				MBItem: []
			};

			switch (XVModule.Model) {
				case "XV-303":
				case "XV-306":
				case "XV-307":
				case "XV-308":
				case "XV-310":
					XVDIGroup.StartAddress = 32;
					break;
			}

			for (let index = 0; index < XVModule.DI.length; index++) {
				let XVItem = {
					Address: XVDIGroup.StartAddress + index,
					DataType: 1,
					Swap: 0,
					Name: `XVBoard_${XVModule.Name}.DI.${XVModule.DI[index].Name}`
				};
				XVDIGroup.MBItem.push(XVItem);
			}
			XVGropus.push(XVDIGroup);
		}

		if (XVModule.Counter.length > 0) {
			let XVCounterGroup = {
				Name: "1",
				DataModel: 2,
				ResponseTimeout: 20,
				SlaveId: 1,
				StartAddress: 0,
				Length: XVModule.Counter.length * 2,
				MBItem: []
			};

			switch (XVModule.Model) {
				case "XV-303":
				case "XV-306":
				case "XV-307":
				case "XV-308":
				case "XV-310":
					XVCounterGroup.StartAddress = 128;
					break;
			}

			for (let index = 0; index < XVModule.Counter.length; index++) {
				let XVItem = {
					Address: XVCounterGroup.StartAddress + index * 2,
					DataType: 7,
					Swap: 0,
					Name: `XVBoard_${XVModule.Name}.Counter.${XVModule.Counter[index].Name}`
				};
				XVCounterGroup.MBItem.push(XVItem);
			}
			XVGropus.push(XVCounterGroup);
		}

		if (XVModule.DO.length > 0) {
			let XVDOGroup = {
				Name: "1",
				DataModel: 1,
				ResponseTimeout: 20,
				SlaveId: 1,
				StartAddress: 0,
				Length: XVModule.DO.length * 1,
				MBItem: []
			};

			for (let index = 0; index < XVModule.DO.length; index++) {
				let XVItem = {
					Address: XVDOGroup.StartAddress + index,
					DataType: 1,
					Swap: 0,
					Name: `XVBoard_${XVModule.Name}.DO.${XVModule.DO[index].Name}`
				};
				XVDOGroup.MBItem.push(XVItem);
			}
			XVGropus.push(XVDOGroup);
		}

		if (XVModule.AI.length > 0) {
			let XVAIGroup = {
				Name: "1",
				DataModel: 2,
				ResponseTimeout: 20,
				SlaveId: 1,
				StartAddress: 0,
				Length: XVModule.AI.length * 1,
				MBItem: []
			};

			for (let index = 0; index < XVModule.AI.length; index++) {
				let XVItem = {
					Address: XVAIGroup.StartAddress + index,
					DataType: 4,
					Swap: 0,
					Name: `XVBoard_${XVModule.Name}.AI.${XVModule.AI[index].Name}`
				};
				XVAIGroup.MBItem.push(XVItem);
			}
			XVGropus.push(XVAIGroup);
		}

		if (XVModule.AO.length > 0) {
			let XVAOGroup = {
				Name: "1",
				DataModel: 3,
				ResponseTimeout: 20,
				SlaveId: 1,
				StartAddress: 32,
				Length: XVModule.AO.length * 1,
				MBItem: []
			};

			for (let index = 0; index < XVModule.AO.length; index++) {
				let XVItem = {
					Address: XVAOGroup.StartAddress + index,
					DataType: 4,
					Swap: 0,
					Name: `XVBoard_${XVModule.Name}.AO.${XVModule.AO[index].Name}`
				};
				XVAOGroup.MBItem.push(XVItem);
			}
			XVGropus.push(XVAOGroup);
		}

		return XVGropus;
	} catch (error) {
		//console.error(`Error reading file: ${error}`);
		return [];
	}
}

var generateXVInitConfig = async function() {
	const Class = new LoadFile();
	try {
		const XVModule = await Class.ReadFile("./File/XV_Module/Module.json", {});
		const Config = {};

		if (XVModule.AI.length > 0) {
			Config["AIChConfig"] = [];

			for (let index = 0; index < XVModule.AI.length; index++) {
				let channel = {
					ChNumber: index,
					Type: XVModule.AI[index].TypeCode
				};
				Config["AIChConfig"].push(channel);
			}
		}

		if (XVModule.AO.length > 0) {
			Config["AOChConfig"] = [];

			for (let index = 0; index < XVModule.AO.length; index++) {
				let channel = {
					ChNumber: index,
					Type: XVModule.AO[index].TypeCode,
					PowerOnValue: XVModule.AO[index].PowerOn
				};
				Config["AOChConfig"].push(channel);
			}
		}

		if (XVModule.DO.length > 0) {
			Config["DOChConfig"] = [];

			for (let index = 0; index < XVModule.DO.length; index++) {
				let channel = {
					ChNumber: index,
					PowerOnValue: XVModule.DO[index].PowerOn
				};
				Config["DOChConfig"].push(channel);
			}
		}

		if (XVModule.Counter.length > 0) {
			Config["CounterChConfig"] = [];

			for (let index = 0; index < XVModule.Counter.length; index++) {
				let channel = {
					ChNumber: index,
					Mode: XVModule.Counter[index].Mode
				};
				Config["CounterChConfig"].push(channel);
			}
		}

		return Config;
	} catch (error) {
		//console.error(`Error reading file: ${error}`);
		return {};
	}
}

JsonTransformXml.prototype._TransformXVBoardDri_ = async function()
{
	
	let XVBoardDriver ={};
	XVBoardDriver["XVBoardDriver"] ={};
	
    let XVItemGroup=[];
	XVItemGroup=XVItemGroup.concat(await generateXVGroup());
	
	if(XVItemGroup.length >0)
	{	
		XVBoardDriver["XVBoardDriver"]["XVBoardTask"]=[];
		let XVTask = {};
		XVTask["TaskName"]="XVTask";
    	XVTask["TaskId"]=0;
   	 	XVTask["PollingRate"]=3;
		XVTask["Connecter"]={};
		XVTask["Connecter"]["ProtocolType"]=0;
		XVTask["Connecter"]["Serial"]={};
		XVTask["Connecter"]["Serial"]["DeviceName"]="/dev/ttyO1";
		XVTask["Connecter"]["Serial"]["Baud"]=115200;
		XVTask["Connecter"]["Serial"]["Parity"]="N";
		XVTask["Connecter"]["Serial"]["DataBit"]=8;
		XVTask["Connecter"]["Serial"]["StopBit"]=1;
		XVTask["ModuleConfig"]=await generateXVInitConfig();
    	XVTask["MbGroup"]=[];
    	XVTask["MbGroup"]=XVTask["MbGroup"].concat(XVItemGroup);
		XVBoardDriver["XVBoardDriver"]["XVBoardTask"].push(XVTask);
	}

	var xotree = new XML.ObjTree();
	var xml = xotree.writeXML(XVBoardDriver);
	return xml;
}

JsonTransformXml.prototype._SortTaskId_ = function(object)
{
	var length = object["ModbusDriver"]["ModbusTask"].length;
	for(var i=0; i<length; i++)
	{
		object["ModbusDriver"]["ModbusTask"][i]["TaskId"] = i;
	}
	return object;
}
JsonTransformXml.prototype._GetModbusDriTransformObject_ = async function() {
    const Return = {};
    const Class = new LoadFile();

    const results = await Promise.all([
        Class.ReadFile("./File/RTU_Module/Module.json", {}),
        Class.ReadFile("./File/RTU_Module/RtuVariable.json", {}),
        Class.ReadFile("./File/RTU_Module/RtuSetting.json", {}),
        Class.ReadFile("./File/ASCII_Module/Module.json", {}),
        Class.ReadFile("./File/ASCII_Module/AsciiVariable.json", {}),
        Class.ReadFile("./File/ASCII_Module/AsciiSetting.json", {}),
        Class.ReadFile("./File/TCP_Module/Module.json", {}),
        Class.ReadFile("./File/TCP_Module/TcpVariable.json", {}),
        Class.ReadFile("./File/TCP_Module/TcpSetting.json", {})
    ]);

    Return["RtuModule"] = results[0];
    Return["RtuVariable"] = results[1];
    Return["RtuSetting"] = results[2];
    Return["AsciiModule"] = results[3];
    Return["AsciiVariable"] = results[4];
    Return["AsciiSetting"] = results[5];
    Return["TcpModule"] = results[6];
    Return["TcpVariable"] = results[7];
    Return["TcpSetting"] = results[8];
    return Return;
}

JsonTransformXml.prototype._GetThereAreVariablesInTheModuleIndex_ = function(Module, Variable, ComPort)
{
	var number = Object.keys(Module[ComPort]);
	var NeedNumber = new Array();
	for(var i=0; i<number.length; i++)
	{
		if(typeof(Variable[number[i]]) == "object")
		{
			NeedNumber.push(number[i]);
		}
	}
	return NeedNumber;
}

JsonTransformXml.prototype._GetTheVariableGroupNumberInTheSingleModule_ = function(Variable, NeedNumber)
{
	var GroupNumber=new Object();
	var SystemVariable = Object.keys(Variable[NeedNumber]);
	for(var j=0; j<SystemVariable.length; j++)
	{
		var ModbusGroupNumber = Variable[NeedNumber][SystemVariable[j]]["ModbusGroupNumber"];
		GroupNumber[ModbusGroupNumber]=new Object();
	}
	GroupNumber = Object.keys(GroupNumber);
	return GroupNumber;
}

JsonTransformXml.prototype._GetRetryCount_ = function(Container, Setting)
{
	if( typeof(Setting["Retry"]) == "undefined" ) return;
	if( Setting["Retry"] == true )
	{
		if( (Container["DataModel"] == 1) || (Container["DataModel"] == 3) )
		{
			Container["ReWriteCount"] = Setting["RetryCount"];
		}
	}
	return;
}

JsonTransformXml.prototype._GetRetryInterval_ = function(Container, Setting)
{
	if( typeof(Setting["RetryInterval"]) == "undefined" ) return;
	
	Container["RetryInterval"] = Setting["RetryInterval"];
	
	return;
}

JsonTransformXml.prototype._GetMbItem_ = function(GroupNumber, ModuleType, Module, Variable, NeedNumber)
{
	var Return=new Object();
	var MbItemArray=new Array();
	var DataModel;
	var SystemVariable = Object.keys(Variable[NeedNumber]);
	for(var k=0; k<SystemVariable.length; k++)
	{
		if(GroupNumber == Variable[NeedNumber][SystemVariable[k]]["ModbusGroupNumber"])
		{
			var obj = new Object();
			DataModel = SystemVariable[k].split("-")[0];
			obj["Address"]=Variable[NeedNumber][SystemVariable[k]]["Address"];
			obj["DataType"]=JsonTransformXml.prototype._GetDataType_(SystemVariable[k].split("-")[1]);
			obj["Swap"]=JsonTransformXml.prototype._GetSwap_(Variable[NeedNumber][SystemVariable[k]]["Swap"]);
			obj["Name"]=ModuleType+"_No."+NeedNumber+"_"+Module[NeedNumber]["ModuleName"]+"_"+DataModel+"."+Variable[NeedNumber][SystemVariable[k]]["VariableName"];
			MbItemArray.push(obj);
		}
	}
	Return["MbItem"] = MbItemArray;  Return["DataModel"] = DataModel;
	return Return;
}

JsonTransformXml.prototype._GetMbGroup_ = function(NeedNumber, ModuleType, Module, Setting, Variable)
{
	var MbGroup = new Object();
	MbGroup["MbGroup"] = new Array();
	for(var i=0; i<NeedNumber.length; i++){
		//var SystemVariable = Object.keys(Variable[NeedNumber[i]]);
		var GroupNumber = JsonTransformXml.prototype._GetTheVariableGroupNumberInTheSingleModule_(Variable, NeedNumber[i]);
		for(var j=0; j<GroupNumber.length; j++)
		{
			var Container=new Object();
			Container["MbItem"]=new Array();
			var obj = JsonTransformXml.prototype._GetMbItem_(GroupNumber[j], ModuleType, Module, Variable, NeedNumber[i]);
			var MbItemArray = obj["MbItem"];
			Container["Name"] = NeedNumber[i];
			Container["DataModel"] = JsonTransformXml.prototype._GetDataModel_(obj["DataModel"]);
			JsonTransformXml.prototype._GetRetryCount_(Container,Setting[NeedNumber[i]]);
			JsonTransformXml.prototype._GetRetryInterval_(Container,Setting[NeedNumber[i]]);
			Container["MbItem"].push(MbItemArray);
			Container["ResponseTimeout"] = Setting[NeedNumber[i]]["Timeout"];
			Container["SlaveId"] = Setting[NeedNumber[i]]["SlaveId"];
			JsonTransformXml.prototype._GetDataType_(Container, Setting[NeedNumber[i]]);
			Container["StartAddress"] = MbItemArray[0]["Address"];
			var DataTypeNumber=JsonTransformXml.prototype._GetModbusAddressInterval_(MbItemArray[0]["DataType"]);
			Container["Length"] = DataTypeNumber*MbItemArray.length;
			MbGroup["MbGroup"].push(Container);
		}
	}
	return MbGroup["MbGroup"];
}

JsonTransformXml.prototype._GetModbusLanTask_=function(ModuleType, Setting, MbGroupArray, NeedNumber)
{
	if(MbGroupArray.length == 0) {return;}
	var ModbusTask=new Object();
	ModbusTask["TaskName"] = "Task";
	ModbusTask["TaskId"] = -1;
	ModbusTask["PollingRate"] = Setting[NeedNumber]["PollingRate"];
	ModbusTask["Connecter"] = new Object();
	ModbusTask["Connecter"]["ProtocolType"] = JsonTransformXml.prototype._GetModbusProtocolType_(ModuleType);
	ModbusTask["Connecter"]["Ethernet"] = new Object();
	ModbusTask["Connecter"]["Ethernet"]["IP"] = Setting[NeedNumber]["IP"];
	ModbusTask["Connecter"]["Ethernet"]["Port"] = Setting[NeedNumber]["Port"];
	ModbusTask["MbGroup"] = new Array();
	ModbusTask["MbGroup"] = MbGroupArray;
	return ModbusTask;
}

JsonTransformXml.prototype._GetModbusComPortTask_ = async function(ModuleType, MbGroupArray, ComPort) {
    if (MbGroupArray.length === 0) {
        return;
    }

    const Class = new LoadFile();
    try {
        const ComPortSetting = await Class.ReadFile("./File/ComPortInterfaceSetting.json", {});
        if (!ComPortSetting.hasOwnProperty(ComPort)) {
            return;
        }

        const ModbusTask = {
            TaskName: "Task",
            TaskId: -1,
            PollingRate: ComPortSetting[ComPort]["PollingRate"],
            Connecter: {
                ProtocolType: JsonTransformXml.prototype._GetModbusProtocolType_(ModuleType),
                Serial: {
                    DeviceName: ComPortSetting[ComPort]["DevicePath"],
                    Baud: ComPortSetting[ComPort]["BaudRate"],
                    Parity: JsonTransformXml.prototype._GetModbusParity_(ComPortSetting[ComPort]["Parity"]),
                    DataBit: ComPortSetting[ComPort]["DataBits"],
                    StopBit: ComPortSetting[ComPort]["StopBits"]
                }
            },
            MbGroup: MbGroupArray
        };

        return ModbusTask;
    } catch (error) {
        //console.error(`Error reading file: ${error}`);
    }
};

JsonTransformXml.prototype._GetMqttDetailData_ = async function(PreliminaryData, VariableObject) {
    const Return = [];
    const LocalBroker = await JsonTransformXml.prototype._GetLocalBrokerData_();
    let Class = new LoadFile();

    try {
        const RemoteBroker = await Class.ReadFile("./File/IoT_Platform/RemoteBroker.json", {});
        Class = new GetValue();
        const Broker = Object.keys(PreliminaryData);
        for (let i = 0; i < Broker.length; i++) {
            const obj = {};
            if (Broker[i] === "Broker (Local)") {
                obj["IP"] = document.location.hostname;
                obj["Port"] = LocalBroker["port"];
                obj["Keepalive"] = 60;
                obj["Username"] = LocalBroker["account"];
                obj["Password"] = LocalBroker["password"];
                obj["isSecure"] = JsonTransformXml.prototype._GetSecureNumber_(LocalBroker["isSecure"]);
            } else if (Broker[i].indexOf(" (Remote)") !== -1) {
                const Index = Object.keys(RemoteBroker);
                for (let j = 0; j < Index.length; j++) {
                    if ((RemoteBroker[Index[j]]["Name"] + " (Remote)") === Broker[i]) {
                        obj["IP"] = RemoteBroker[Index[j]]["IP"];
                        obj["Port"] = RemoteBroker[Index[j]]["Port"];
                        obj["ClientID"] = RemoteBroker[Index[j]]["ClientID"];
                        obj["Keepalive"] = RemoteBroker[Index[j]]["Keepalive"];
                        obj["Username"] = RemoteBroker[Index[j]]["Account"];
                        obj["Password"] = RemoteBroker[Index[j]]["Password"];
                        obj["isSecure"] = JsonTransformXml.prototype._GetSecureNumber_(RemoteBroker[Index[j]]["SSL/TLS"]);
                        obj["CaCertFile"] = RemoteBroker[Index[j]]["CaCertFile"];
                        obj["CertFile"] = RemoteBroker[Index[j]]["CertFile"];
                        obj["KeyFile"] = RemoteBroker[Index[j]]["KeyFile"];
                    }
                }
            }
            obj["VariableName"] = [];
            obj["SubscribeTopic"] = [];
            obj["SubscribeQoS"] = [];
            obj["PublishTopic"] = [];
            obj["PublishQoS"] = [];
            obj["Retain"] = [];
            obj["VariableIndex"] = [];
            const ModuleIndex = PreliminaryData[Broker[i]]["ModuleIndex"];
            for (let j = 0; j < ModuleIndex.length; j++) {
                const VariableIndex = Object.keys(VariableObject[ModuleIndex[j]]);
                for (let z = 0; z < VariableIndex.length; z++) {
                    const RuntimeVariableName = Class.GetRuntimeVariableName("MQTT", ModuleIndex[j], VariableIndex[z]);
                    obj["VariableName"].push(RuntimeVariableName);
                    obj["SubscribeTopic"].push(VariableObject[ModuleIndex[j]][VariableIndex[z]]["SubscribeTopic"]);
                    obj["SubscribeQoS"].push(VariableObject[ModuleIndex[j]][VariableIndex[z]]["SubscribeQoS"]);
                    obj["PublishTopic"].push(VariableObject[ModuleIndex[j]][VariableIndex[z]]["PublishTopic"]);
                    obj["PublishQoS"].push(VariableObject[ModuleIndex[j]][VariableIndex[z]]["PublishQoS"]);
                    obj["Retain"].push(JsonTransformXml.prototype._GetRetainNumber_(VariableObject[ModuleIndex[j]][VariableIndex[z]]["Retain"]));
                    obj["VariableIndex"].push(VariableIndex[z]);
                }
            }
            Return.push(jQuery.parseJSON(JSON.stringify(obj)));
        }
        return Return;
    } catch (error) {
        //console.error(`Error reading file: ${error}`);
        return [];
    }
};


JsonTransformXml.prototype._GetMqttModuleJsonObject_ = async function() {
    const Return = {};
    const Class = new LoadFile();

    try {
        const results = await Promise.all([
            Class.ReadFile("./File/MQTT_Module/Module.json", {}),
            Class.ReadFile("./File/MQTT_Module/MqttVariable.json", {}),
            Class.ReadFile("./File/MQTT_Module/MqttSetting.json", {})
        ]);
        Return["Module"] = results[0];
        Return["Variable"] = results[1];
        Return["Setting"] = results[2];
        return Return;
    } catch (error) {
        //console.error(`Error reading files: ${error}`);
        return {};
    }
};

JsonTransformXml.prototype._TransformVariableXml_ = async function() {
    const Variable = {
        DataTable: {
            Data: []
        }
    };
    const Class = new LoadFile();

    try {
        const results = await Promise.all([
            Class.ReadFile("./File/ASCII_Module/Module.json", {}),
            Class.ReadFile("./File/ASCII_Module/AsciiVariable.json", {}),
            Class.ReadFile("./File/RTU_Module/Module.json", {}),
            Class.ReadFile("./File/RTU_Module/RtuVariable.json", {}),
            Class.ReadFile("./File/TCP_Module/Module.json", {}),
            Class.ReadFile("./File/TCP_Module/TcpVariable.json", {}),
            Class.ReadFile("./File/MQTT_Module/Module.json", {}),
            Class.ReadFile("./File/MQTT_Module/MqttVariable.json", {}),
            Class.ReadFile("./File/EIP_Module/Module.json", {}),
            Class.ReadFile("./File/EIP_Module/EipVariable.json", {}),
            Class.ReadFile("./File/XV_Module/Module.json", {}),
            Class.ReadFile("./File/XV_Module/XVVariable.json", {}),
            Class.ReadFile("./File/Register_Module/Module.json", {}),
            Class.ReadFile("./File/Register_Module/RegisterVariable.json", {})
        ]);

        let array = [];
        array = array.concat(JsonTransformXml.prototype._GetVariableXmlItem_("MASCII", results[0], results[1]));
        array = array.concat(JsonTransformXml.prototype._GetVariableXmlItem_("MRTU", results[2], results[3]));
        array = array.concat(JsonTransformXml.prototype._GetVariableXmlItem_("MTCP", results[4], results[5]));
        array = array.concat(JsonTransformXml.prototype._GetVariableXmlItem_("MQTT", results[6], results[7]));
        array = array.concat(await JsonTransformXml.prototype._GetEipVariableXmlItem_("EIP", results[8], results[9]));
        array = array.concat(JsonTransformXml.prototype._GetXVVariableXmlItem_("XV", results[10], results[11]));
        array = array.concat(await JsonTransformXml.prototype._GetRegisterVariableXmlItem_("Register", results[12], results[13]));
        array = array.concat(await JsonTransformXml.prototype._GetVirtualVariableXmlItem_());

        Variable.DataTable.Data = array;
        const xotree = new XML.ObjTree();
        const xml = xotree.writeXML(Variable);
        return xml;
    } catch (error) {
        //console.error(`Error reading files: ${error}`);
        return "";
    }
};

JsonTransformXml.prototype._GetRegisterVariableXmlItem_ = async function(ModuleType, Module, Variable) {
    const Return = [];
    const Class = new LoadFile();

    try {
        const RegisterModule = await Class.ReadFile("./File/Register_Module/Module.json", {});
        const number = Object.keys(Variable);
        for (let i = 0; i < number.length; i++) {
            const ModuleName = RegisterModule[number[i]]["ModuleName"];
            const Information = JsonTransformXml.prototype._CollectRegisterVariableInformation_(Variable, number[i]);
            Return.push(...JsonTransformXml.prototype._RegisterCombinationData_(ModuleType, number[i], ModuleName, Information));
        }
        return Return;
    } catch (error) {
        //console.error(`Error reading file: ${error}`);
        return [];
    }
};

JsonTransformXml.prototype._GetEipVariableXmlItem_ = async function(ModuleType, Module, Variable) {
    const Return = [];
    const Class = new LoadFile();

    try {
        const EipSetting = await Class.ReadFile("./File/EIP_Module/EipSetting.json", {});
        const number = Object.keys(Variable);
        for (let i = 0; i < number.length; i++) {
            const ModuleName = EipSetting[number[i]]["NickName"];
            const Information = JsonTransformXml.prototype._CollectEipVariableInformation_(Variable, number[i]);
            Return.push(...JsonTransformXml.prototype._CombinationData_(ModuleType, number[i], ModuleName, Information));
        }
        return Return;
    } catch (error) {
        //console.error(`Error reading file: ${error}`);
        return [];
    }
};

JsonTransformXml.prototype._GetVirtualVariableXmlItem_ = async function() {
    const Return = [];
    const Class = new LoadFile();

    try {
        const PidOperation = await Class.ReadFile("./File/PID_Operation/PidOperation.json", {});
        const VirtualPoint = ["Min", "Max", "SetPoint", "Kp", "Ki", "Kd", "ControllerMode", "SampleTime", "AutoTune", "Status"];
        const ComparisonValue = ["Min", "Max", "SetValue", "Kp", "Ki", "Kd", "ControllerMode", "SampleTime", "AutoTune", "Status"];
        const Access = [0, 0, 2, 2, 2, 2, 2, 2, 2, 0];
        const Type = [11, 11, 11, 11, 11, 11, 1, 6, 1, 1];
        const PidNumber = Object.keys(PidOperation);

        for (let i = 0; i < PidNumber.length; i++) {
            if (PidOperation[PidNumber[i]]["InputModuleVariableIndex"] === "//" ||
                PidOperation[PidNumber[i]]["OutputModuleVariableIndex"] === "//") {
                continue;
            }
            for (let j = 0; j < VirtualPoint.length; j++) {
                let DefaultValue = PidOperation[PidNumber[i]][ComparisonValue[j]];
                if (ComparisonValue[j] === "AutoTune") {
                    DefaultValue = JsonTransformXml.prototype._GetPidAutoTune_(DefaultValue);
                } else if (ComparisonValue[j] === "ControllerMode") {
                    DefaultValue = JsonTransformXml.prototype._GetPidControllerMode_(DefaultValue);
                }
                const obj = {
                    Identifier: 1,
                    NameId: `PID_${PidOperation[PidNumber[i]]["Name"]}.${VirtualPoint[j]}`,
                    Access: Access[j],
                    Type: Type[j],
                    Size: 1,
                    DefaultValue: DefaultValue
                };
                Return.push(obj);
            }
        }
        return Return;
    } catch (error) {
        //console.error(`Error reading file: ${error}`);
        return [];
    }
};

JsonTransformXml.prototype._TransformScaleVariableTableXml_ = async function() {
    const Variable = {
        ScaleDataTable: {
            ScaleData: []
        }
    };
    const Class = new LoadFile();

    try {
        const results = await Promise.all([
            Class.ReadFile("./File/TCP_Module/Module.json", {}),
            Class.ReadFile("./File/TCP_Module/TcpScalingVariable.json", {}),
            Class.ReadFile("./File/RTU_Module/Module.json", {}),
            Class.ReadFile("./File/RTU_Module/RtuScalingVariable.json", {})
        ]);

        let array = [];
        array = array.concat(JsonTransformXml.prototype._GetScaleVariableXmlItem_("MTCP", results[0], results[1]));
        array = array.concat(JsonTransformXml.prototype._GetScaleVariableXmlItem_("MRTU", results[2], results[3]));

        Variable.ScaleDataTable.ScaleData = array;
        const xotree = new XML.ObjTree();
        const xml = xotree.writeXML(Variable);
        return xml;
    } catch (error) {
        //console.error(`Error reading files: ${error}`);
        return "";
    }
};

JsonTransformXml.prototype._TransformBitwiseVariableTableXml_ = async function() {
    const Variable = {
        BitwiseDataTable: {
            BitwiseData: []
        }
    };
    const Class = new LoadFile();

    try {
        const results = await Promise.all([
            Class.ReadFile("./File/TCP_Module/Module.json", {}),
            Class.ReadFile("./File/TCP_Module/TcpBitwiseVariable.json", {}),
            Class.ReadFile("./File/RTU_Module/Module.json", {}),
            Class.ReadFile("./File/RTU_Module/RtuBitwiseVariable.json", {})
        ]);

        let array = [];
        array = array.concat(JsonTransformXml.prototype._GetBitwiseVariableXmlItem_("MTCP", results[0], results[1]));
        array = array.concat(JsonTransformXml.prototype._GetBitwiseVariableXmlItem_("MRTU", results[2], results[3]));

        Variable.BitwiseDataTable.BitwiseData = array;
        const xotree = new XML.ObjTree();
        const xml = xotree.writeXML(Variable);
        return xml;
    } catch (error) {
        //console.error(`Error reading files: ${error}`);
        return "";
    }
};

JsonTransformXml.prototype._GetModbusTcpTask_ = function(Module, Variable, Setting)
{
	var LAN = Object.keys(Module);
	var ModbusTaskArray = new Array();
	var NeedNumber = new Array();
	var ModbusGroupNumber=new Object();
	var ModuleType="MTCP";
	for(var i=0; i<LAN.length; i++)
	{
		var NeedNumber = JsonTransformXml.prototype._GetThereAreVariablesInTheModuleIndex_(Module, Variable, LAN[i]);
		for(var j=0; j<NeedNumber.length; j++)
		{
			var NumberArray = new Array(NeedNumber[j]);
			var MbGroupArray = JsonTransformXml.prototype._GetMbGroup_(NumberArray, ModuleType, Module[LAN[i]], Setting, Variable);
			var ModbusTask = JsonTransformXml.prototype._GetModbusLanTask_(ModuleType, Setting, MbGroupArray, NeedNumber[j]);
			if(ModbusTask != null)
			{
				ModbusTaskArray.push(ModbusTask);
			}
		}
	}
	return ModbusTaskArray;
}

JsonTransformXml.prototype._GetModbusAsciiTask_ = async function(Module, Variable, Setting)
{
	var ComPort = Object.keys(Module);
	var ModbusTaskArray = new Array();
	var NeedNumber = new Array();
	var ModbusGroupNumber=new Object();
	var ModuleType="MASCII";
	for(var i=0; i<ComPort.length; i++)
	{
		var NeedNumber = JsonTransformXml.prototype._GetThereAreVariablesInTheModuleIndex_(Module, Variable, ComPort[i]);
		var MbGroupArray = JsonTransformXml.prototype._GetMbGroup_(NeedNumber, ModuleType, Module[ComPort[i]], Setting, Variable);
		var ModbusTask = await JsonTransformXml.prototype._GetModbusComPortTask_(ModuleType, MbGroupArray, ComPort[i]);
		if(ModbusTask != null)
		{
			ModbusTaskArray.push(ModbusTask);
		}
	}
	return ModbusTaskArray;
}

JsonTransformXml.prototype._GetModbusRtuTask_ = async function(Module, Variable, Setting)
{
	var ComPort = Object.keys(Module);
	var ModbusTaskArray = new Array();
	var NeedNumber = new Array();
	//var ModbusGroupNumber=new Object();
	var ModuleType="MRTU";
	for(var i=0; i<ComPort.length; i++)
	{
		var NeedNumber = JsonTransformXml.prototype._GetThereAreVariablesInTheModuleIndex_(Module, Variable, ComPort[i]);
		var MbGroupArray = JsonTransformXml.prototype._GetMbGroup_(NeedNumber, ModuleType, Module[ComPort[i]], Setting, Variable);
		var ModbusTask = await JsonTransformXml.prototype._GetModbusComPortTask_(ModuleType, MbGroupArray, ComPort[i]);
		if(ModbusTask != null)
		{
			ModbusTaskArray.push(ModbusTask);
		}
	}
	return ModbusTaskArray;
}

JsonTransformXml.prototype._TransformMqttDri_ = async function(Protocol)
{
	var Obj  = await JsonTransformXml.prototype._GetMqttModuleJsonObject_();
	var LAN = Object.keys(Obj["Module"]); //LAN1,LAN2,LAN3
	var NeedNumber=new Array();
	for(var i=0; i<LAN.length; i++)
	{
		var ModuleIndex=JsonTransformXml.prototype._GetThereAreVariablesInTheModuleIndex_(Obj["Module"], Obj["Variable"], LAN[i]);
		NeedNumber = NeedNumber.concat(ModuleIndex);
	}
	var PreliminaryData=JsonTransformXml.prototype._GetMqttPreliminaryData_(NeedNumber, Obj["Setting"]);
	var DetailData=await JsonTransformXml.prototype._GetMqttDetailData_(PreliminaryData, Obj["Variable"]);
	
	var MQTTTask 	= new Array();
	var MQTTDriver 	= new Object();
	MQTTDriver["MQTTDriver"] = new Object();
	MQTTDriver["MQTTDriver"]["MQTTTask"] = new Array();
	
	MQTTTask = JsonTransformXml.prototype._GetMqttTask_(DetailData);
	MQTTDriver["MQTTDriver"]["MQTTTask"] = MQTTTask;

	var xotree = new XML.ObjTree();
	var xml = xotree.writeXML(MQTTDriver);
	return xml;
}

JsonTransformXml.prototype._GetMqttPreliminaryData_ = function(ModuleIndexArray, SettingObject)
{
	var Return=new Object();
	for(var i=0; i<ModuleIndexArray.length; i++)
	{
		var MqttConnection = SettingObject[ModuleIndexArray[i]]["MqttConnection"];
		for(var j=0;j<MqttConnection.length; j++)
		{
			if(typeof(Return[MqttConnection[j]]) == "undefined")
			{
				Return[MqttConnection[j]]=new Object();
				Return[MqttConnection[j]]["ModuleIndex"]=new Array();
			}
			Return[MqttConnection[j]]["ModuleIndex"].push(ModuleIndexArray[i]);
		}
	}
	return Return;
}

JsonTransformXml.prototype._GetMqttTask_ = function(DetailData)
{
	var Index=Object.keys(DetailData);
	var MQTTTask = new Array();
	for(var i=0; i<Index.length; i++)
	{
		var Obj=new Object();
		Obj["TaskID"]=i;
		Obj["Connecter"]=new Object();
		Obj["Connecter"]["IP"]       =DetailData[Index[i]]["IP"];
		Obj["Connecter"]["Port"]     =DetailData[Index[i]]["Port"];
		Obj["Connecter"]["ClientID"] =DetailData[Index[i]]["ClientID"];
		Obj["Connecter"]["Keepalive"]=DetailData[Index[i]]["Keepalive"];
		Obj["Connecter"]["Username"] =DetailData[Index[i]]["Username"];
		Obj["Connecter"]["Password"] =DetailData[Index[i]]["Password"];
		Obj["Connecter"]["isSecure"] =DetailData[Index[i]]["isSecure"];
		if(typeof(DetailData[Index[i]]["CaCertFile"]) != "undefined")
		{
			Obj["Connecter"]["CACertFile"] =DetailData[Index[i]]["CaCertFile"];
			Obj["Connecter"]["CertFile"] =DetailData[Index[i]]["CertFile"];
			Obj["Connecter"]["KeyFile"] =DetailData[Index[i]]["KeyFile"];
		}
		Obj["MQItem"]=new Array();
		for(var j=0; j<DetailData[Index[i]]["VariableName"].length; j++)
		{
			var object=new Object();
			object["Name"]    =DetailData[Index[i]]["VariableName"][j];
			object["SubTopic"]=DetailData[Index[i]]["SubscribeTopic"][j];
			object["SubQoS"]  =DetailData[Index[i]]["SubscribeQoS"][j];
			object["PubTopic"]=DetailData[Index[i]]["PublishTopic"][j];
			object["PubQoS"]  =DetailData[Index[i]]["PublishQoS"][j];
			object["Property"]=JsonTransformXml.prototype._GetProperty_(DetailData[Index[i]]["VariableIndex"][j].split("-")[0]);
			object["DataType"]=JsonTransformXml.prototype._GetDataType_(DetailData[Index[i]]["VariableIndex"][j].split("-")[1]);
			object["Retain"]  =DetailData[Index[i]]["Retain"][j];
			Obj["MQItem"].push(jQuery.parseJSON(JSON.stringify(object)));
		}
		MQTTTask.push(jQuery.parseJSON(JSON.stringify(Obj)));
	}	
	return MQTTTask;
}

JsonTransformXml.prototype._CollectRegisterVariableInformation_ = function(Variable, number)
{
	var Return=new Array();
	var Information=new Array();
	var SystemVariable = Object.keys(Variable[number]);
	var length = SystemVariable.length;
	for(var j=0; j<length; j++)
	{
		if(typeof(Variable[number][SystemVariable[j]]) == "object" && 
		   typeof(Variable[number][SystemVariable[j]]["VariableName"]) == "string" &&
		   Variable[number][SystemVariable[j]]["VariableName"] != "")
		{
			Information=new Array();
			Information.push(Variable[number][SystemVariable[j]]["VariableName"]);
			Information.push(SystemVariable[j].split("-")[0]);
			Information.push(JsonTransformXml.prototype._GetDataType_(SystemVariable[j].split("-")[1]));
			Information.push(Variable[number][SystemVariable[j]]["Description"]);
			Information.push(Variable[number][SystemVariable[j]]["Number"]);
			Return.push(Information);
		}
	}
	return Return;
}

JsonTransformXml.prototype._GetXVVariableXmlItem_ = function(ModuleType, Module, Variable)
{
	var Return = new Array();
	var Information = new Array();
	var number = Object.keys(Variable);
	var ModuleName=Module.Name;
	var Class = new LoadFile();	
	//var XVModule = Class.ReadFile("./File/XV_Module/Module.json", new Object());
	for(var i=0; i<number.length; i++)
	{
		Information = JsonTransformXml.prototype._CollectVariableInformation_(Variable, number[i]);
		Return = Return.concat(JsonTransformXml.prototype._CombinationData_(ModuleType, number[i], ModuleName, Information));
	}
	return Return;
}

JsonTransformXml.prototype._GetVariableXmlItem_ = function(ModuleType, Module, Variable)
{
	var Return = new Array();
	var Information = new Array();
	var ComPort = Object.keys(Module);
	var number = Object.keys(Variable);
	var ModuleName;
	for(var i=0; i<number.length; i++)
	{
		ModuleName = JsonTransformXml.prototype._CollectModuleName_(Module, ComPort, number[i]);
		Information = JsonTransformXml.prototype._CollectVariableInformation_(Variable, number[i]);
		Return = Return.concat(JsonTransformXml.prototype._CombinationData_(ModuleType, number[i], ModuleName, Information));
	}
	return Return;
}


JsonTransformXml.prototype._CombinationScaleVariableData_ = function(ModuleType, number, ModuleName, Information)
{
	var Return=new Array();
	for(var j=0; j<Information.length; j++)
	{
		if( Information[j][8] == true )
		{
			var obj = new Object();
			obj["NameId"]            = ModuleType+"_No."+number+"_"+ModuleName+"_"+Information[j][0]+"_Scale"+"."+Information[j][4];
			obj["Access"]            = JsonTransformXml.prototype._GetReadWriteType_(Information[j][0]);
			obj["ReferenceVariable"] = ModuleType+"_No."+number+"_"+ModuleName+"_"+Information[j][0]+"."+Information[j][1];
			obj["OriginalMin"]       = Information[j][2];
			obj["OriginalMax"]       = Information[j][3];
			obj["TargetMin"]         = Information[j][5];
			obj["TargetMax"]         = Information[j][6];
			obj["OffsetValue"]       = Information[j][7];
			obj["Description"]       = Information[j][9];
			Return.push(obj);
		}
	}
	return Return;
}

JsonTransformXml.prototype._CollectScaleVariableInformation_ = function(Variable, number)
{
	var Return=new Array();
	var Information=new Array();
	var SystemVariable = Object.keys(Variable[number]);
	for(var j=0; j<SystemVariable.length; j++)
	{
		if(typeof(Variable[number][SystemVariable[j]]) == "object" && 
		   typeof(Variable[number][SystemVariable[j]]["VariableName"]) == "string" &&
		   Variable[number][SystemVariable[j]]["VariableName"] != "")
		{
			Information=new Array();
			Information.push(SystemVariable[j].split("-")[0]);
			Information.push(Variable[number][SystemVariable[j]]["VariableName"]);
			Information.push(Variable[number][SystemVariable[j]]["InputDataMin"]);
			Information.push(Variable[number][SystemVariable[j]]["InputDataMax"]);
			Information.push(Variable[number][SystemVariable[j]]["ScaleVariableName"]);
			Information.push(Variable[number][SystemVariable[j]]["OutputDataMin"]);
			Information.push(Variable[number][SystemVariable[j]]["OutputDataMax"]);
			Information.push(Variable[number][SystemVariable[j]]["Offset"]);
			Information.push(Variable[number][SystemVariable[j]]["TransformScaling"]);
			Information.push(Variable[number][SystemVariable[j]]["Description"]);
			Return.push(Information);
		}
	}
	return Return;
}

JsonTransformXml.prototype._GetScaleVariableXmlItem_ = function(ModuleType, Module, Variable)
{
	var Return = new Array();
	var Information = new Array();
	var ComPort = Object.keys(Module);
	var number = Object.keys(Variable);
	var ModuleName;
	for(var i=0; i<number.length; i++)
	{
		ModuleName = JsonTransformXml.prototype._CollectModuleName_(Module, ComPort, number[i]);
		Information = JsonTransformXml.prototype._CollectScaleVariableInformation_(Variable, number[i]);
		Return = Return.concat(JsonTransformXml.prototype._CombinationScaleVariableData_(ModuleType, number[i], ModuleName, Information));
	}
	return Return;
}

JsonTransformXml.prototype._CombinationBitwiseVariableData_ = function(ModuleType, number, ModuleName, Information)
{
	var Return=new Array();
	for(var i=0; i<Information.length; i++)
	{
		for(var j=3; j<Information[i].length; j=j+2)
		{
			if(Information[i][j] != null && Information[i][j] != '')
			{
				var obj = new Object();
				obj["NameId"]            = ModuleType+"_No."+number+"_"+ModuleName+"_"+Information[i][0]+"_Bitwise"+"."+Information[i][j];
				obj["ReferenceVariable"] = ModuleType+"_No."+number+"_"+ModuleName+"_"+Information[i][0]+"."+Information[i][1];
				obj["BitShift"]          = Information[i][j+1];
				obj["Description"]       = Information[i][2];
				Return.push(obj);
			}
		}
	}
	return Return;
}

JsonTransformXml.prototype._CollectBitNameTagInformation_ = function(Information, Variable)
{
	var Return=new Array();
	var BitNameId = "";
	var BitTotalNumber = 0;

	if(Variable["DataType"] == "Short" || Variable["DataType"] == "Unsigned Short") BitTotalNumber = 16;
	else if(Variable["DataType"] == "Long" || Variable["DataType"] == "Unsigned Long")  BitTotalNumber = 32;
	for(var i=0; i<BitTotalNumber; i++)
	{
		BitNameId = "BitTagName-" + i.toString();
		if(Variable[BitNameId] != null && Variable[BitNameId] != '')
		{
			Information.push(Variable[BitNameId]);
			Information.push(i);
		}
	}
}

JsonTransformXml.prototype._CollectBitwiseVariableInformation_ = function(Variable, number)
{
	var Return=new Array();
	var Information=new Array();
	var SystemVariable = Object.keys(Variable[number]);
	for(var j=0; j<SystemVariable.length; j++)
	{
		if(typeof(Variable[number][SystemVariable[j]]) == "object" && 
		   typeof(Variable[number][SystemVariable[j]]["VariableName"]) == "string" &&
		   Variable[number][SystemVariable[j]]["VariableName"] != "")
		{
			Information=new Array();
			Information.push(SystemVariable[j].split("-")[0]);
			Information.push(Variable[number][SystemVariable[j]]["VariableName"]);
			Information.push(Variable[number][SystemVariable[j]]["Description"]);
			JsonTransformXml.prototype._CollectBitNameTagInformation_(Information, Variable[number][SystemVariable[j]]);
			Return.push(Information);
		}
	}
	return Return;
}

JsonTransformXml.prototype._GetBitwiseVariableXmlItem_ = function(ModuleType, Module, Variable)
{
	var Return = new Array();
	var Information = new Array();
	var ComPort = Object.keys(Module);
	var number = Object.keys(Variable);
	var ModuleName;
	for(var i=0; i<number.length; i++)
	{
		ModuleName = JsonTransformXml.prototype._CollectModuleName_(Module, ComPort, number[i]);
		Information = JsonTransformXml.prototype._CollectBitwiseVariableInformation_(Variable, number[i]);
		Return = Return.concat(JsonTransformXml.prototype._CombinationBitwiseVariableData_(ModuleType, number[i], ModuleName, Information));
	}
	return Return;
}

JsonTransformXml.prototype._CollectModuleName_ = function(Module, ComPort, number)
{
	for(var j=0; j<ComPort.length; j++)
	{
		if(typeof(Module[ComPort[j]][number]) == "object" && 
		   typeof(Module[ComPort[j]][number]["ModuleName"]) == "string")
		{
			ModuleName = Module[ComPort[j]][number]["ModuleName"];
		}
	}
	return ModuleName;
}

JsonTransformXml.prototype._CollectEipVariableInformation_ = function(Variable, number)
{
	var Return=new Array();
	var Information=new Array();
	var SystemVariable = Object.keys(Variable[number]);
	var length = parseInt(Global_EipSetting[number]["ModeType"].split("-")[0]);
	for(var j=0; j<length; j++)
	{
		if(typeof(Variable[number][SystemVariable[j]]) == "object" && 
		   typeof(Variable[number][SystemVariable[j]]["VariableName"]) == "string" &&
		   Variable[number][SystemVariable[j]]["VariableName"] != "")
		{
			Information=new Array();
			Information.push(Variable[number][SystemVariable[j]]["VariableName"]);
			Information.push(SystemVariable[j].split("-")[0]);
			Information.push(JsonTransformXml.prototype._GetDataType_(SystemVariable[j].split("-")[1]));
			Information.push(Variable[number][SystemVariable[j]]["Description"]);
			Return.push(Information);
		}
	}
	return Return;
}

JsonTransformXml.prototype._CollectVariableInformation_ = function(Variable, number)
{
	var Return=new Array();
	var Information=new Array();
	var SystemVariable = Object.keys(Variable[number]);
	for(var j=0; j<SystemVariable.length; j++)
	{
		if(typeof(Variable[number][SystemVariable[j]]) == "object" && 
		   typeof(Variable[number][SystemVariable[j]]["VariableName"]) == "string" &&
		   Variable[number][SystemVariable[j]]["VariableName"] != "")
		{
			Information=new Array();
			Information.push(Variable[number][SystemVariable[j]]["VariableName"]);
			Information.push(SystemVariable[j].split("-")[0]);
			Information.push(JsonTransformXml.prototype._GetDataType_(SystemVariable[j].split("-")[1]));
			Information.push(Variable[number][SystemVariable[j]]["Description"]);
			Return.push(Information);
		}
	}
	return Return;
}

JsonTransformXml.prototype._CombinationData_ = function(ModuleType, number, ModuleName, Information)
{
	var Return=new Array();
	for(var j=0; j<Information.length; j++)
	{
		var obj = new Object();
		obj["Identifier"] = 0;
		if(ModuleType==="XV")
			obj["NameId"] = "XVBoard_"+ModuleName+"."+Information[j][1]+"."+Information[j][0];
		else
			obj["NameId"] = ModuleType+"_No."+number+"_"+ModuleName+"_"+Information[j][1]+"."+Information[j][0];
		
		obj["Access"] = JsonTransformXml.prototype._GetReadWriteType_(Information[j][1]);
		obj["Type"] = Information[j][2];
		obj["Size"] = 1;
		obj["DefaultValue"] = 0;
		if(Information[j][3] != "")
		{
			obj["Description"] = Information[j][3];
		}
		Return.push(obj);
	}
	return Return;
}
JsonTransformXml.prototype._RegisterCombinationData_ = function(ModuleType, number, ModuleName, Information)
{
	var Return=new Array();
	for(var j=0; j<Information.length; j++)
	{
		var obj = new Object();
		obj["Identifier"] = 1;
		obj["NameId"] = "Internal" + "_No." + number + "_" + ModuleName + "." + Information[j][0];
		obj["Access"] = JsonTransformXml.prototype._GetReadWriteType_(Information[j][1]);
		obj["Type"] = Information[j][2];
		obj["Size"] = 1;
		obj["DefaultValue"] = 0;
		if(Information[j][3] != "")
		{
			obj["Description"] = Information[j][3];
		}
		Return.push(obj);
	}
	return Return;
}


JsonTransformXml.prototype._GetModuleName_ = function(Module, number)
{
	var Return;
	var DeviceName = Object.keys(Module);
	for(var i=0; i<DeviceName.length; i++)
	{
		if(typeof(Module[DeviceName[i]][number])=="object")
		{
			Return = Module[DeviceName[i]][number]["ModuleName"];
		}
	}
	return Return;
}

JsonTransformXml.prototype._GetModbusAddressInterval_ = function(DataTypeNumber)
{
	var Return;
	switch(parseInt(DataTypeNumber))
	{
		case 6:
		case 7:
		case 10:
			Return = 2;
		break;
		case 11:
			Return = 4;
		break;
		default:
			Return = 1;
	}
	return Return;
}

JsonTransformXml.prototype._GetInputOutputData_ = function(string)
{
	var Return;
	if(string == "DO")				{Return = "OutputData_";}
	else if(string == "DI")	 		{Return = "InputData_";}
	else if(string == "Counter")	{Return = "InputData_";}
	else if(string == "AO")			{Return = "OutputData_";}
	else if(string == "AI")			{Return = "InputData_";}
	return Return;
}

JsonTransformXml.prototype._GetModbusParity_ = function(string)
{
	var Return;
	if(string == "None")		{Return = "N";}
	else if(string == "Odd")	{Return = "O";}
	else if(string == "Even")	{Return = "E";}
	return Return;
}

JsonTransformXml.prototype._GetModbusProtocolType_ = function(string)
{
	var Return;
	if(string == "MRTU")		{Return = 0;}
	else if(string == "MTCP")	{Return = 1;}
	else if(string == "MASCII")	{Return = 2;}
	return Return;
}

JsonTransformXml.prototype._GetSwap_ = function(bool)
{
	var Return;
	if(bool == false)			{Return = 0;}
	else if(bool == true)		{Return = 1;}
	return Return;
}

JsonTransformXml.prototype._GetDataModel_ = function(string)
{
	var Return;
	if(string == "DO")		{Return = 1;}
	else if(string == "DI")	{Return = 0;}
	else if(string == "AO")	{Return = 3;}
	else if(string == "AI")	{Return = 2;}
	return Return;
}

JsonTransformXml.prototype._GetReadWriteType_ = function(string)
{
	var Return;
	if(string == "DO")			{Return = 2;}
	else if(string == "DI")		{Return = 0;}
	else if(string == "Counter"){Return = 0;}
	else if(string == "AO")		{Return = 2;}
	else if(string == "AI")		{Return = 0;}
	return Return;
}

JsonTransformXml.prototype._GetDataType_ = function(string)
{
	var Return;
	if(string == "Bool")				{Return = 1;}
	else if(string == "SByte")			{Return = 2;}
	else if(string == "Byte")			{Return = 3;}
	else if(string == "Short")			{Return = 4;}
	else if(string == "Unsigned Short")	{Return = 5;}
	else if(string == "Long")			{Return = 6;}
	else if(string == "Unsigned Long")	{Return = 7;}
	else if(string == "Int64")			{Return = 8;}
	else if(string == "Unsigned Int64")	{Return = 9;}
	else if(string == "Float")			{Return = 10;}
	else if(string == "Double")			{Return = 11;}
	else if(string == "String")			{Return = 12;}
	else if(string == "Unknow_Type")	{Return = 999;}
	return Return;
}

JsonTransformXml.prototype._GetClientVariablePrefixWords_ = function(ModuleType, string)
{
	var Return;
	if(ModuleType=="MRTU" || ModuleType=="MTCP" || ModuleType=="MASCII" || ModuleType=="EIP" || ModuleType=="MRTU Scaling" || ModuleType=="MTCP Scaling")
	{
		if(string == "DO")			{Return = "Coil_Status";}
		else if(string == "DI")		{Return = "Input_Status";}
		else if(string == "AO")		{Return = "Holding_Registers";}
		else if(string == "AI")		{Return = "Input_Registers";}
	}
	else if(ModuleType=="MQTT" ||ModuleType=="XV")
	{
		if(string == "DO")			{Return = "DO";}
		else if(string == "DI")		{Return = "DI";}
		else if(string == "Counter")		{Return = "Counter";}
		else if(string == "AO")		{Return = "AO";}
		else if(string == "AI")		{Return = "AI";}
	}
	return Return;
}

JsonTransformXml.prototype._GetProperty_ = function(Attribute)
{
	var Property;
	Attribute = JsonTransformXml.prototype._GetReadWriteType_(Attribute);
	switch(parseInt(Attribute))
	{
		case 0:
			Property = 1;
		break;
		case 1:
			Property = 2;
		break;
		case 2:
			Property = 3;
		break;
	}
	return Property;
}

JsonTransformXml.prototype._GetRetainNumber_ = function(Retain)
{
	var RetainNumber;
	if(Retain == false)			{RetainNumber = 0;}
	else if(Retain == true)		{RetainNumber = 1;}
	return RetainNumber;
}

JsonTransformXml.prototype._GetSecureNumber_ = function(SecureBool)
{
	var Return;
	if(SecureBool==false || SecureBool=="false")	{Return = 0;}
	else if(SecureBool==true || SecureBool=="true")	{Return = 1;}
	return Return;
}

JsonTransformXml.prototype._GetPidAutoTune_ = function(Bool)
{
	var Return;
	if(Bool==false |Bool=="false")		{Return = 0;}
	else if(Bool==true || Bool=="true")	{Return = 1;}
	return Return;
}

JsonTransformXml.prototype._GetPidControllerMode_ = function(ControllerMode)
{
	var Return;
	if(ControllerMode=="DIRECT")		{Return = 0;}
	else if(ControllerMode=="REVERSE")	{Return = 1;}
	return Return;
}

JsonTransformXml.prototype._GetPidModuleVariabName_ = function(ModuleVariableIndex)
{
	if(ModuleVariableIndex == "//"){
		return 0;
	}
	var Return;
	var array=ModuleVariableIndex.split("/");
	var ModuleType=array[0];
	var ModuleIndex=array[1];
	var VariableIndex=array[2];
	if(array[0] == "MRTU Scaling" || array[0] == "MTCP Scaling")
	{

		var Module=GetValue.prototype._GetGlobalModule_(ModuleType);
		var ModuleName=JsonTransformXml.prototype._GetModuleName_(Module, ModuleIndex);
		var Variable=GetValue.prototype._GetGlobalVariable_(ModuleType);
		var VariableName=GetValue.prototype._GetModulePidScalingVariableName_(Variable, ModuleIndex, VariableIndex);
		ModuleType = ModuleType.split(" ")[0];
		Return=ModuleType+"_No."+ModuleIndex+"_"+ModuleName+"_"+VariableIndex.split("-")[0]+"_Scale."+VariableName;

	}
	else
	{
		var Module=GetValue.prototype._GetGlobalModule_(ModuleType);
		var ModuleName=JsonTransformXml.prototype._GetModuleName_(Module, ModuleIndex);
		var Variable=GetValue.prototype._GetGlobalVariable_(ModuleType);
		var VariableName=GetValue.prototype._GetModuleVariableName_(Variable, ModuleIndex, VariableIndex);
		Return=ModuleType+"_No."+ModuleIndex+"_"+ModuleName+"_"+VariableIndex.split("-")[0]+"."+VariableName;
	}
	return Return;
}

function IPJumpToNextField(e, currentField, nextFieldId) 
{
	var inputChar = e.key;
	if (isNaN(inputChar) && inputChar !== '.') {
		$(currentField).val(function (i, val) {
			return val.slice(0, -1);
		});
	}

	if ($(currentField).val().length >= $(currentField).attr('maxlength') || e.keyCode === 13 || inputChar === '.') {
		if (e.keyCode === 13 || inputChar === '.') {
			$(currentField).val(function (i, val) {
				return val.slice(0, -1);
			});
		}
		$('#' + nextFieldId).focus();
	}
}