//Json轉換Xml
ModuleToLocalDataLoggerCommon.prototype._GetDataLogServiceXml_ = async function()
{
	var LocalDataLogger = await ModuleToLocalDataLoggerCommon.prototype._GetLocalDataLoggerJson_();
	var RuntimeVariableArray = new Array();
	RuntimeVariableArray =  RuntimeVariableArray.concat(await ModuleToLocalDataLoggerCommon.prototype._GetRtuToLocalDataLoggerVariableArray_());
	RuntimeVariableArray = RuntimeVariableArray.concat(await ModuleToLocalDataLoggerCommon.prototype._GetTcpToLocalDataLoggerVariableArray_());
	var DeviceSDCardPath = ModuleToLocalDataLoggerCommon.prototype._GetDeviceSDCardPath_();
	
	var XmlObject=new Object();
	XmlObject["DataLogService"]=new Object();
	XmlObject["DataLogService"]["FileLogger"]=new Object();
	XmlObject["DataLogService"]["FileLogger"]["TaskName"]     = "DataLogTask";
	XmlObject["DataLogService"]["FileLogger"]["TaskID"]       = 1;
	XmlObject["DataLogService"]["FileLogger"]["StorageDevice "] = DeviceSDCardPath;
	XmlObject["DataLogService"]["FileLogger"]["LogPath"]      = "/mnt/SD/" + LocalDataLogger["FolderName"] + "/log.csv";
	XmlObject["DataLogService"]["FileLogger"]["Rotation"]     = LocalDataLogger["FileLength"];
	XmlObject["DataLogService"]["FileLogger"]["Times"]        = "local";
	XmlObject["DataLogService"]["FileLogger"]["SpaceUsage"]   = LocalDataLogger["DiskUsageRate"];
	XmlObject["DataLogService"]["FileLogger"]["IntervalTime"] = LocalDataLogger["LogInterval"];
	XmlObject["DataLogService"]["FileLogger"]["TimeAlignment"] = LocalDataLogger["TimeAlignment"];
	XmlObject["DataLogService"]["FileLogger"]["IsLogAllItems"] = "False";
	XmlObject["DataLogService"]["FileLogger"]["LogItems"] = new Object();
	XmlObject["DataLogService"]["FileLogger"]["LogItems"]["Name"] = new Array();
	XmlObject["DataLogService"]["FileLogger"]["LogItems"]["Name"] = RuntimeVariableArray;
	var xotree = new XML.ObjTree();
	var xml = xotree.writeXML(XmlObject);
	return xml;
}

ModuleToLocalDataLoggerCommon.prototype._GetDeviceSDCardPath_ = function()
{
	if(Global_FlashInformation == "/dev/ubi0_0")
	{
		return "/dev/mmcblk0p1";
	}
	else
	{
		return "/dev/mmcblk1p1";
	}
}

ModuleToLocalDataLoggerCommon.prototype._GetLocalDataLoggerJson_ = async function() {
    const Class = new LoadFile();
    try {
        const Return = await Class.ReadFile("./File/IoT_Platform/LocalDataLogger.json", {});
        return Return;
    } catch (error) {
        //console.error(`Error reading file: ${error}`);
        return {};
    }
};

ModuleToLocalDataLoggerCommon.prototype._GetRtuToLocalDataLoggerVariableArray_ = async function() {
    const Return = [];
    const Class = new LoadFile();

    try {
        const [JsonVariable, Module, ModuleVariable] = await Promise.all([
            Class.ReadFile("./File/RTU_Module/RtuToLocalDataLoggerVariable.json", {}),
            Class.ReadFile("./File/RTU_Module/Module.json", {}),
            Class.ReadFile("./File/RTU_Module/RtuVariable.json", {})
        ]);

        const number = Object.keys(JsonVariable);
        for (let i = 0; i < number.length; i++) {
            const SystemVariable = Object.keys(JsonVariable[number[i]]);
            for (let j = 0; j < SystemVariable.length; j++) {
                if (JsonVariable[number[i]][SystemVariable[j]]["LocalDataLoggerRecord"] === true) {
                    const ModuleName = JsonTransformXml.prototype._GetModuleName_(Module, number[i]);
                    const RuntimeVariable = `MRTU_No.${number[i]}_${ModuleName}_${SystemVariable[j].split("-")[0]}.${ModuleVariable[number[i]][SystemVariable[j]]["VariableName"]}`;
                    Return.push(RuntimeVariable);
                }
            }
        }
        return Return;
    } catch (error) {
        //console.error(`Error reading files: ${error}`);
        return [];
    }
};

ModuleToLocalDataLoggerCommon.prototype._GetTcpToLocalDataLoggerVariableArray_ = async function() {
    const Return = [];
    const Class = new LoadFile();

    try {
        const [JsonVariable, Module, ModuleVariable] = await Promise.all([
            Class.ReadFile("./File/TCP_Module/TcpToLocalDataLoggerVariable.json", {}),
            Class.ReadFile("./File/TCP_Module/Module.json", {}),
            Class.ReadFile("./File/TCP_Module/TcpVariable.json", {})
        ]);

        const number = Object.keys(JsonVariable);
        for (let i = 0; i < number.length; i++) {
            const SystemVariable = Object.keys(JsonVariable[number[i]]);
            for (let j = 0; j < SystemVariable.length; j++) {
                if (JsonVariable[number[i]][SystemVariable[j]]["LocalDataLoggerRecord"] === true) {
                    const ModuleName = JsonTransformXml.prototype._GetModuleName_(Module, number[i]);
                    const RuntimeVariable = `MTCP_No.${number[i]}_${ModuleName}_${SystemVariable[j].split("-")[0]}.${ModuleVariable[number[i]][SystemVariable[j]]["VariableName"]}`;
                    Return.push(RuntimeVariable);
                }
            }
        }
        return Return;
    } catch (error) {
        //console.error(`Error reading files: ${error}`);
        return [];
    }
};

