Main.prototype._GetHardwareData_ = async function() {
    const RReturn = $.Deferred();
    const Class = new LoadFile();

    try {
        const data = await Class.ReadFile("./File/ComPortInterfaceSetting.json", {});
        Global_ComPort = data;
        RReturn.resolve(true);
    } catch (error) {
        //console.error(`Error reading file: ${error}`);
        RReturn.resolve(false);
    }

    return RReturn.promise();
}

Main.prototype._GetAccountSetting_ = async function() {
    const RReturn = $.Deferred();
    const Class = new LoadFile();

    try {
        const data = await Class.ReadFile("./File/AccountSetting.json", {});
        Global_AccountSetting = data;
        RReturn.resolve(true);
    } catch (error) {
        //console.error(`Error reading file: ${error}`);
        RReturn.resolve(false);
    }

    return RReturn.promise();
}

Main.prototype._GetRtuModuleSettingData_ = async function() {
    const RReturn = $.Deferred();
    const Class = new LoadFile();

    try {
        const results = await Promise.all([
            Class.ReadFile("./File/RTU_Module/Index.json", {}),
            Class.ReadFile("./File/RTU_Module/Module.json", {}),
            Class.ReadFile("./File/RTU_Module/RtuVariable.json", {}),
            Class.ReadFile("./File/RTU_Module/RtuSetting.json", {}),
            Class.ReadFile("./File/RTU_Module/RtuIcpdasModule.json", {}),
            Class.ReadFile("./File/RTU_Module/RtuScalingVariable.json", {}),
            Class.ReadFile("./File/RTU_Module/RtuBitwiseVariable.json", {})
        ]);

        const [RtuIndex, RtuModule, RtuVariable, RtuSetting, RtuIcpdasModule, RtuScalingVariable, RtuBitwiseVariable] = results;

        Global_RtuIndex = RtuIndex;
        Global_RtuModule = RtuModule;
        Global_RtuVariable = RtuVariable;
        Global_RtuSetting = RtuSetting;
        Global_RtuScalingVariable = RtuScalingVariable;
        Global_RtuBitwiseVariable = RtuBitwiseVariable;
        Global_RtuIcpdasModule = RtuIcpdasModule;

        RReturn.resolve(true);
    } catch (error) {
        //console.error(`Error reading files: ${error}`);
        RReturn.resolve(false);
    }

    return RReturn.promise();
}

Main.prototype._GetTcpModuleSettingData_ = async function() {
    const RReturn = $.Deferred();
    const Class = new LoadFile();

    try {
        const results = await Promise.all([
            Class.ReadFile("./File/TCP_Module/Index.json", {}),
            Class.ReadFile("./File/TCP_Module/Module.json", {}),
            Class.ReadFile("./File/TCP_Module/TcpVariable.json", {}),
            Class.ReadFile("./File/TCP_Module/TcpSetting.json", {}),
            Class.ReadFile("./File/TCP_Module/TcpIcpdasModule.json", {}),
            Class.ReadFile("./File/TCP_Module/TcpScalingVariable.json", {}),
            Class.ReadFile("./File/TCP_Module/TcpBitwiseVariable.json", {})
        ]);

        const [TcpIndex, TcpModule, TcpVariable, TcpSetting, TcpIcpdasModule, TcpScalingVariable, TcpBitwiseVariable] = results;

        Global_TcpIndex = TcpIndex;
        Global_TcpModule = TcpModule;
        Global_TcpVariable = TcpVariable;
        Global_TcpSetting = TcpSetting;
        Global_TcpScalingVariable = TcpScalingVariable;
        Global_TcpBitwiseVariable = TcpBitwiseVariable;
        Global_TcpIcpdasModule = TcpIcpdasModule;

        RReturn.resolve(true);
    } catch (error) {
        //console.error(`Error reading files: ${error}`);
        RReturn.resolve(false);
    }

    return RReturn.promise();
}

Main.prototype._GetAsciiModuleSettingData_ = async function() {
    const RReturn = $.Deferred();
    const Class = new LoadFile();

    try {
        const results = await Promise.all([
            Class.ReadFile("./File/ASCII_Module/Index.json", {}),
            Class.ReadFile("./File/ASCII_Module/Module.json", {}),
            Class.ReadFile("./File/ASCII_Module/AsciiVariable.json", {}),
            Class.ReadFile("./File/ASCII_Module/AsciiSetting.json", {})
        ]);

        const [AsciiIndex, AsciiModule, AsciiVariable, AsciiSetting] = results;

        Global_AsciiIndex = AsciiIndex;
        Global_AsciiModule = AsciiModule;
        Global_AsciiVariable = AsciiVariable;
        Global_AsciiSetting = AsciiSetting;

        RReturn.resolve(true);
    } catch (error) {
        //console.error(`Error reading files: ${error}`);
        RReturn.resolve(false);
    }

    return RReturn.promise();
}

Main.prototype._GetSaveLanguageTxt_ = function()
{
	var Language;
	$.ajax(
		{
		url: "./Language/SaveLanguage.txt",
		type:"GET",
		async: false,
		cache:false,
		success: function(msg)
		{
			Language = msg;
		},
		error:function(xhr, ajaxOptions, thrownError)
		{
			console.log(xhr+":"+ajaxOptions+":"+thrownError);
		}
	});
	return Language;
};

Main.prototype._GetMqttModuleSettingData_ = async function() {
    const RReturn = $.Deferred();
    const Class = new LoadFile();

    try {
        const results = await Promise.all([
            Class.ReadFile("./File/MQTT_Module/Index.json", {}),
            Class.ReadFile("./File/MQTT_Module/Module.json", {}),
            Class.ReadFile("./File/MQTT_Module/MqttVariable.json", {}),
            Class.ReadFile("./File/MQTT_Module/MqttSetting.json", {})
        ]);

        const [MqttIndex, MqttModule, MqttVariable, MqttSetting] = results;

        Global_MqttIndex = MqttIndex;
        Global_MqttModule = MqttModule;
        Global_MqttVariable = MqttVariable;
        Global_MqttSetting = MqttSetting;

        RReturn.resolve(true);
    } catch (error) {
        //console.error(`Error reading files: ${error}`);
        RReturn.resolve(false);
    }

    return RReturn.promise();
}

Main.prototype._GetEipModuleSettingData_ = async function() 
{
    const RReturn = $.Deferred();
    const Class = new LoadFile();

    try {
        const results = await Promise.all([
            Class.ReadFile("./File/EIP_Module/ProductSpecification.json", {}),
            Class.ReadFile("./File/EIP_Module/Module.json", {}),
            Class.ReadFile("./File/EIP_Module/Index.json", {}),
            Class.ReadFile("./File/EIP_Module/EipSetting.json", {}),
            Class.ReadFile("./File/EIP_Module/ConnectionParameters.json", {}),
            Class.ReadFile("./File/EIP_Module/EipVariable.json", {})
        ]);

        const [EipProductSpecification, EipModule, EipIndex, EipSetting, ConnectionParameters, EipVariable] = results;

        Global_EipProductSpecification = EipProductSpecification;
        Global_EipModule = EipModule;
        Global_EipIndex = EipIndex;
        Global_EipSetting = EipSetting;
        Global_ConnectionParameters = ConnectionParameters;
        Global_EipVariable = EipVariable;

        RReturn.resolve(true);
    } catch (error) {
        //console.error(`Error reading files: ${error}`);
        RReturn.resolve(false);
    }

    return RReturn.promise();
}

Main.prototype._GetXVModuleSettingData_ = async function() 
{
    const RReturn = $.Deferred();
    const Class = new LoadFile();

    try {
        const results = await Promise.all([
            Class.ReadFile("./File/XV_Module/Module.json", {}),
            Class.ReadFile("./File/XV_Module/XVVariable.json", {})
        ]);

        const [XVModule, XVVariable] = results;

        Global_XVModule = XVModule;
        Global_XVVariable = XVVariable;

        RReturn.resolve(true);
    } catch (error) {
        //console.error(`Error reading files: ${error}`);
        RReturn.resolve(false);
    }

    return RReturn.promise();
}

Main.prototype._GetRegisterModuleSettingData_ = async function() 
{
    const RReturn = $.Deferred();
    const Class = new LoadFile();

    try {
        const [moduleData, indexData, settingData, variableData] = await Promise.all([
            Class.ReadFile("./File/Register_Module/Module.json", new Object()),
            Class.ReadFile("./File/Register_Module/Index.json", new Array()),
            Class.ReadFile("./File/Register_Module/RegisterSetting.json", new Object()),
            Class.ReadFile("./File/Register_Module/RegisterVariable.json", new Object())
        ]);

        Global_RegisterModule = moduleData;
        Global_RegisterIndex = indexData;
        Global_RegisterSetting = settingData;
        Global_RegisterVariable = variableData;

        RReturn.resolve(true);
    } catch (error) {
        //console.error(`Error reading files: ${error}`);
        RReturn.resolve(false);
    }

    return RReturn.promise();
}

Main.prototype._GetMqttGroupCloudSettingData_ = async function() 
{
    const RReturn = $.Deferred();
    const Class = new LoadFile();

    try {
        const data = await Class.ReadFile("./File/RemoteMQTTGroup/Index.json", new Array());
        Global_MqttGroupCloudIndex = data;
        RReturn.resolve(true);
    } catch (error) {
        //console.error(`Error reading file: ${error}`);
        RReturn.resolve(false);
    }

    return RReturn.promise();
}

Main.prototype._GetModuleSettingData_ = async function() 
{
    const RReturn = $.Deferred();

    try {
        const [res1, res2, res3, res4, res5, res6, res7, res8] = await Promise.all([
            Main.prototype._GetRtuModuleSettingData_(),
            Main.prototype._GetTcpModuleSettingData_(),
            Main.prototype._GetAsciiModuleSettingData_(),
            Main.prototype._GetMqttModuleSettingData_(),
            Main.prototype._GetEipModuleSettingData_(),
            Main.prototype._GetXVModuleSettingData_(),
            Main.prototype._GetRegisterModuleSettingData_(),
            Main.prototype._GetMqttGroupCloudSettingData_()
        ]);

        if (res1 === true && res2 === true && res3 === true && res4 === true &&
            res5 === true && res6 === true && res7 === true && res8 === true) {
            RReturn.resolve(true);
        } else {
            RReturn.resolve(false);
        }
    } catch (error) {
        //console.error(`Error getting module setting data: ${error}`);
        RReturn.resolve(false);
    }

    return RReturn.promise();
};

Main.prototype._GetModuleToOpcuaData_ = async function() {
    const RReturn = $.Deferred();
    const Class = new LoadFile();

    try {
        const [rtuData, rtuScalingData, rtuBitwiseData, tcpData, tcpScalingData, tcpBitwiseData, asciiData, mqttData, eipData, xvData, registerData] = await Promise.all([
            Class.ReadFile("./File/RTU_Module/RtuToOpcuaVariable.json", new Object()),
            Class.ReadFile("./File/RTU_Module/RtuScalingToOpcuaVariable.json", new Object()),
            Class.ReadFile("./File/RTU_Module/RtuBitwiseToOpcuaVariable.json", new Object()),
            Class.ReadFile("./File/TCP_Module/TcpToOpcuaVariable.json", new Object()),
            Class.ReadFile("./File/TCP_Module/TcpScalingToOpcuaVariable.json", new Object()),
            Class.ReadFile("./File/TCP_Module/TcpBitwiseToOpcuaVariable.json", new Object()),
            Class.ReadFile("./File/ASCII_Module/AsciiToOpcuaVariable.json", new Object()),
            Class.ReadFile("./File/MQTT_Module/MqttToOpcuaVariable.json", new Object()),
            Class.ReadFile("./File/EIP_Module/EipToOpcuaVariable.json", new Object()),
            Class.ReadFile("./File/XV_Module/XVToOpcuaVariable.json", new Object()),
            Class.ReadFile("./File/Register_Module/RegisterToOpcuaVariable.json", new Object())
        ]);

        Global_RtuToOpcuaVariable = rtuData;
        Global_RtuScalingToOpcuaVariable = rtuScalingData;
        Global_RtuBitwiseToOpcuaVariable = rtuBitwiseData;
        Global_TcpToOpcuaVariable = tcpData;
        Global_TcpScalingToOpcuaVariable = tcpScalingData;
        Global_TcpBitwiseToOpcuaVariable = tcpBitwiseData;
        Global_AsciiToOpcuaVariable = asciiData;
        Global_MqttToOpcuaVariable = mqttData;
        Global_EipToOpcuaVariable = eipData;
        Global_XVToOpcuaVariable = xvData;
        Global_RegisterToOpcuaVariable = registerData;
        RReturn.resolve(true);
    } catch (error) {
        //console.error("Error reading files:", error);
        RReturn.reject(false);
    }

    return RReturn.promise();
};

Main.prototype._GetModbusToMqttData_ = async function() {
    const RReturn = $.Deferred();
    const Class = new LoadFile();

    try {
        const [rtuVariable, rtuSetting, rtuScalingVariable, tcpVariable, tcpSetting, tcpScalingVariable, asciiVariable, asciiSetting] = await Promise.all([
            Class.ReadFile("./File/RTU_Module/RtuToMqttVariable.json", new Object()),
            Class.ReadFile("./File/RTU_Module/RtuToMqttSetting.json", new Object()),
            Class.ReadFile("./File/RTU_Module/RtuScalingToMqttVariable.json", new Object()),
            Class.ReadFile("./File/TCP_Module/TcpToMqttVariable.json", new Object()),
            Class.ReadFile("./File/TCP_Module/TcpToMqttSetting.json", new Object()),
            Class.ReadFile("./File/TCP_Module/TcpScalingToMqttVariable.json", new Object()),
            Class.ReadFile("./File/ASCII_Module/AsciiToMqttVariable.json", new Object()),
            Class.ReadFile("./File/ASCII_Module/AsciiToMqttSetting.json", new Object())
        ]);

        Global_RtuToMqttVariable = rtuVariable;
        Global_RtuToMqttSetting = rtuSetting;
        Global_RtuScalingToMqttVariable = rtuScalingVariable;
        Global_TcpToMqttVariable = tcpVariable;
        Global_TcpToMqttSetting = tcpSetting;
        Global_TcpScalingToMqttVariable = tcpScalingVariable;
        Global_AsciiToMqttVariable = asciiVariable;
        Global_AsciiToMqttSetting = asciiSetting;
        RReturn.resolve(true);
    } catch (error) {
        //console.error("Error reading files:", error);
        RReturn.reject(false);
    }

    return RReturn.promise();
};

Main.prototype._GetIotPlatformSettingData_ = async function() {
    const RReturn = $.Deferred();
    const Class = new LoadFile();

    try {
        const [remoteBroker, mqttJsonGroup, remoteMqttGroup, azurePlatform, opcUaLocalServer] = await Promise.all([
			Class.ReadFile("./File/IoT_Platform/RemoteBroker.json", new Object()),
			Class.ReadFile("./File/IoT_Platform/MqttJsonGroup.json", new Object()),
			Class.ReadFile("./File/RemoteMQTTGroup/RemoteMqttGroup.json", new Object()),
			Class.ReadFile("./File/IoT_Platform/Microsoft_Azure_Platform.json", new Object()),
			new Promise((resolve, reject) => {
				try {
					const result = Class.ReadXmlObject("./File/IoT_Platform/UAServerConfig.xml", new Object());
					resolve(result);
				} catch (error) {
					reject(error);
				}
			})
		]);
        Global_RemoteBroker = remoteBroker;
        Global_MqttJsonGroup = mqttJsonGroup;
        Global_RemoteMqttGroup = remoteMqttGroup;
        Global_AzurePlatform = azurePlatform;
        Global_OpcUaLocalServer = opcUaLocalServer;
        RReturn.resolve(true);
    } catch (error) {
        //console.error("Error reading files:", error);
        RReturn.reject(false);
    }

    return RReturn.promise();
};

Main.prototype._GetAdvancedFunctionData_ = async function() {
    const RReturn = $.Deferred();
    const Class = new LoadFile();

    try {
        const [pidOperation, iftttSetting, iftttVariable, localDataLogger, msSqlConnection, mysqlConnection, blockRule] = await Promise.all([
            Class.ReadFile("./File/PID_Operation/PidOperation.json", new Object()),
            Class.ReadFile("./File/IFTTT_Notify/Setting.json", new Object()),
            Class.ReadFile("./File/IFTTT_Notify/Variable.json", new Object()),
            Class.ReadFile("./File/IoT_Platform/LocalDataLogger.json", new Object()),
            Class.ReadFile("./File/IoT_Platform/MsSqlConnection.json", new Object()),
            Class.ReadFile("./File/IoT_Platform/MysqlConnection.json", new Object()),
            Class.ReadFile("./File/Block_List/BlockRule.json", new Object())
        ]);

        Global_PidOperation = pidOperation;
        Global_IftttConditionTriggerSetting = iftttSetting;
        Global_IftttConditionTriggerVariable = iftttVariable;
        Global_LocalDataLogger = localDataLogger;
        Global_MsSqlConnection = msSqlConnection;
        Global_MysqlConnection = mysqlConnection;
        Global_BlockRule = blockRule;
        RReturn.resolve(true);
    } catch (error) {
        //console.error("Error reading files:", error);
        RReturn.reject(false);
    }

    return RReturn.promise();
};


Main.prototype._GetLoggerSettingData_ = async function() {
    const RReturn = $.Deferred();
    const Class = new LoadFile();

    try {
        const [rtuToLocalDataLogger, tcpToLocalDataLogger, rtuToMsSql, tcpToMsSql, rtuToMysql, tcpToMysql, mqttToMysql, mqttToMsSql] = await Promise.all([
            Class.ReadFile("./File/RTU_Module/RtuToLocalDataLoggerVariable.json", new Object()),
            Class.ReadFile("./File/TCP_Module/TcpToLocalDataLoggerVariable.json", new Object()),
            Class.ReadFile("./File/RTU_Module/RtuToMsSqlVariable.json", new Object()),
            Class.ReadFile("./File/TCP_Module/TcpToMsSqlVariable.json", new Object()),
            Class.ReadFile("./File/RTU_Module/RtuToMysqlConnectionVariable.json", new Object()),
            Class.ReadFile("./File/TCP_Module/TcpToMysqlConnectionVariable.json", new Object()),
            Class.ReadFile("./File/MQTT_Module/MqttToMysqlVariable.json", new Object()),
            Class.ReadFile("./File/MQTT_Module/MqttToMsSqlVariable.json", new Object())
        ]);

        Global_RtuToLocalDataLoggerVariable = rtuToLocalDataLogger;
        Global_TcpToLocalDataLoggerVariable = tcpToLocalDataLogger;
        Global_RtuToMsSqlVariable = rtuToMsSql;
        Global_TcpToMsSqlVariable = tcpToMsSql;
        Global_RtuToMysqlConnectionVariable = rtuToMysql;
        Global_TcpToMysqlConnectionVariable = tcpToMysql;
        Global_MqttToMysqlVariable = mqttToMysql;
        Global_MqttToMsSqlVariable = mqttToMsSql;
        RReturn.resolve(true);
    } catch (error) {
        //console.error("Error reading files:", error);
        RReturn.reject(false);
    }

    return RReturn.promise();
};

Main.prototype._GetNetworkSettingData_ = async function() {
    const RReturn = $.Deferred();
    const Class = new LoadFile();

    try {
        const data = await Class.ReadFile("./File/NetworkSetting.json", new Object());
        Global_NetworkSettingVariable = data;
        RReturn.resolve(true);
    } catch (error) {
        //console.error("Error reading file:", error);
        RReturn.reject(false);
    }

    return RReturn.promise();
};

Main.prototype._LoadLeftListHtml_Part1_ = async function() {
    const Class = new LoadFile();

    try {
        const [systemSettingHtml, moduleSettingHtml, iotPlatformSettingHtml, convertSettingHtml] = await Promise.all([
            Class.ReadFile("./Plugin/Left_List/html/SystemSetting.html", new Object()),
            Class.ReadFile("./Plugin/Left_List/html/ModuleSetting.html", new Object()),
            Class.ReadFile("./Plugin/Left_List/html/IotPlatformSetting.html", new Object()),
            Class.ReadFile("./Plugin/Left_List/html/ConvertSetting.html", new Object())
        ]);

        Global_LeftListSystemSettingHtml = systemSettingHtml;
        Global_LeftListModuleSettingHtml = moduleSettingHtml;
        Global_LeftListIotPlatformSettingHtml = iotPlatformSettingHtml;
        Global_LeftListConvertSettingHtml = convertSettingHtml;
    } catch (error) {
        //console.error("Error reading files:", error);
    }
};

Main.prototype._LoadLeftListHtml_Part2_ = async function() {
    const Class = new LoadFile();

    try {
        const [advancedSettingHtml, listIOStatusHtml, contentIOStatusHtml, fileSettingHtml, loggerSettingHtml] = await Promise.all([
            Class.ReadFile("./Plugin/Left_List/html/AdvancedSetting.html", new Object()),
            Class.ReadFile("./Plugin/Left_List/html/IOStatus.html", new Object()),
            Class.ReadFile("./Plugin/IOStatus/html/IOStatus.html", new Object()),
            Class.ReadFile("./Plugin/Left_List/html/File.html", new Object()),
            Class.ReadFile("./Plugin/Left_List/html/LoggerSetting.html", new Object())
        ]);

        Global_LeftListAdvancedSettingHtml = advancedSettingHtml;
        Global_LeftListIOStatusHtml = listIOStatusHtml;
        Global_ContentIOStatusHtml = contentIOStatusHtml;
        Global_LeftListFileSettingHtml = fileSettingHtml;
        Global_LeftListLoggerSettingHtml = loggerSettingHtml;
    } catch (error) {
        //console.error("Error reading files:", error);
    }
};

Main.prototype._LoadDescriptionHtml_Part1_ = async function() {
    const Class = new LoadFile();

    try {
        const [descriptionSystemSettingHtml, descriptionModuleSettingHtml, descriptionIotPlatformSettingHtml, descriptionConvertSettingHtml] = await Promise.all([
            Class.ReadFile("./Plugin/Description/html/SystemSetting.html", new Object()),
            Class.ReadFile("./Plugin/Description/html/ModuleSetting.html", new Object()),
            Class.ReadFile("./Plugin/Description/html/IotPlatformSetting.html", new Object()),
            Class.ReadFile("./Plugin/Description/html/ConvertTransmission.html", new Object())
        ]);

        Global_DescriptionSystemSettingHtml = descriptionSystemSettingHtml;
        Global_DescriptionModuleSettingHtml = descriptionModuleSettingHtml;
        Global_DescriptionIotPlatformSettingHtml = descriptionIotPlatformSettingHtml;
        Global_DescriptionConvertSettingHtml = descriptionConvertSettingHtml;
    } catch (error) {
        //console.error("Error reading files:", error);
    }
};

Main.prototype._GetEipToMqttData_ = async function() 
{
	const RReturn = $.Deferred();
	const Class = new LoadFile();

	try {
		const [eipVariable, eipSetting] = await Promise.all([
			Class.ReadFile("./File/EIP_Module/EipToMqttVariable.json", new Object()),
			Class.ReadFile("./File/EIP_Module/EipToMqttSetting.json", new Object())
		]);

		Global_EipToMqttVariable = eipVariable;
		Global_EipToMqttSetting = eipSetting;
		RReturn.resolve(true);
	} catch (error) {
		RReturn.reject(false);
	}

	return RReturn.promise();
};

Main.prototype._GetModbusToMqttJsonData_ = async function() 
{
	const RReturn = $.Deferred();
	const Class = new LoadFile();

	const readFiles = [
		Class.ReadFile("./File/RTU_Module/RtuToMqttJsonVariable.json", new Object()),
		Class.ReadFile("./File/TCP_Module/TcpToMqttJsonVariable.json", new Object()),
		Class.ReadFile("./File/ASCII_Module/AsciiToMqttJsonVariable.json", new Object())
	];

	try {
		const [rtuJsonVariable, tcpJsonVariable, asciiJsonVariable] = await Promise.all(readFiles);
		Global_RtuToMqttJsonVariable = rtuJsonVariable;
		Global_TcpToMqttJsonVariable = tcpJsonVariable;
		Global_AsciiToMqttJsonVariable = asciiJsonVariable;
		RReturn.resolve(true);
	} catch (error) {
		//console.error("Error reading files:", error);
		RReturn.reject(false);
	}

	return RReturn.promise();
};


Main.prototype._GetConvertTransmissionData_ = function() 
{
	var RReturn = $.Deferred();

	Promise.all([
		Main.prototype._GetModuleToOpcuaData_(),
		Main.prototype._GetModbusToMqttData_(),
		Main.prototype._GetEipToMqttData_(),
		Main.prototype._GetModbusToMqttJsonData_()
	])
	.then(function(results) {
		const [res1, res2, res3, res4] = results;
		if(res1 === true && res2 === true && res3 === true && res4 === true) {
			RReturn.resolve(true);
		} else {
			RReturn.resolve(false);
		}
	})
	.catch(function(err) {
		console.error("Error occurred:", err);
		RReturn.reject(err);
	});

	return RReturn.promise();
};

Main.prototype._LoadLanguage_ = function()
{
	var Class = new LoadHtml();
	var JsonArray={Input:null};
	var Language = Main.prototype._GetSaveLanguageTxt_();
	Class.ReadHtml("./Language/"+ Language +".json", JsonArray);
	var TotalJson = new Object();
	var SetInterval = setInterval(function()
	{
		if(JsonArray["Input"] != null)
		{
			for(var i=0; i<JsonArray["Input"].length; i++)
			{
				var Key = Object.keys(JsonArray["Input"][i]);
				for(var j=0; j<Key.length; j++)
				{
					TotalJson[Key[j]] = new Object();
					TotalJson[Key[j]] = JsonArray["Input"][i][Key[j]];
				}
			}
			Global_TranslateJson = JSON.parse(JSON.stringify(TotalJson));
			clearInterval(SetInterval);
		}
	},500);
}

Main.prototype._GetLocalBrokerData_ = function()
{
	var RReturn = $.Deferred();
	var Class = new Cgi();
	var Return = {Input:null};
	Class.RestApi("GetLocalBrokerSetting", new Array(), true, Return);
	var SetInterval = setInterval(function(){
		if(Return["Input"] != null)
		{
			clearInterval(SetInterval);
			Global_LocalBroker = Return["Input"];
			
			RReturn.resolve(true);
		}
	},500);
	return RReturn.promise();
};


Main.prototype._AsynchronousInitializeGlobalVariables_ = function() {
    var RReturn = $.Deferred();

    Promise.all([
        Main.prototype._GetHardwareData_(),
        Main.prototype._GetAccountSetting_(), 
        Main.prototype._GetLocalBrokerData_(), 
        Main.prototype._GetModuleSettingData_(), 
        Main.prototype._GetConvertTransmissionData_(), 
        Main.prototype._GetIotPlatformSettingData_(), 
        Main.prototype._GetAdvancedFunctionData_(), 
        Main.prototype._GetLoggerSettingData_(),
        Main.prototype._GetNetworkSettingData_()
    ])
    .then(function(results) {
        const [res1, res2, res3, res4, res5, res6, res7, res8, res9] = results;
      
        if(res1 === true && res2 === true && res3 === true && res4 === true && res5 === true && res6 === true && res7 === true && res8 === true && res9 === true) {
            RReturn.resolve(true);
        } else {
            RReturn.resolve(false);
        }
    })
    .catch(function(err) {
        console.error("Error occurred:", err);
        RReturn.reject(err);
    });

    return RReturn.promise();
};


Main.prototype._LoadHtml_ = function(DivId, HtmlPath, Result)
{
	var Html = {Input:null};
	var Class = new LoadHtml();	
	Class.ReadHtml(HtmlPath, Html);
	var SetInterval = setInterval(function()
	{
		if(Html["Input"] != null)
		{
			clearInterval(SetInterval);
			var TranslateHtml = Class.TranslateHtml(Html["Input"]);
			$(DivId).empty();
			$(DivId).append(TranslateHtml);
			
			Result["Input"] = true;
		}
	},500);
};

Main.prototype._LoadDescriptionHtml_Part2_ = async function() 
{
    const Class = new LoadFile();

    try {
        const [descriptionAdvancedSettingHtml, descriptionLoggerSettingHtml] = await Promise.all([
            Class.ReadFile("./Plugin/Description/html/AdvancedSetting.html", new Object()),
            Class.ReadFile("./Plugin/Description/html/LoggerSetting.html", new Object())
        ]);

        Global_DescriptionAdvancedSettingHtml = descriptionAdvancedSettingHtml;
        Global_DescriptionLoggerSettingHtml = descriptionLoggerSettingHtml;
    } catch (error) {
        //console.error("Error reading files:", error);
    }
};

Main.prototype._LoadCenterContentHtml_Part1_ = async function() {
    const Class = new LoadFile();

    try {
        const [controllerServiceSettingHtml, controllerServiceSettingCss, timeSettingCss, timeSettingHtml, accountSettingHtml] = await Promise.all([
            Class.ReadFile("./Plugin/ControllerServiceSetting/html/ControllerServiceSetting.html", new Object()),
            Class.ReadFile("./Plugin/ControllerServiceSetting/html/Css.html", new Object()),
            Class.ReadFile("./Plugin/TimeSetting/html/TimeSetting.html", new Object()),
            Class.ReadFile("./Plugin/TimeSetting/html/Css.html", new Object()),
            Class.ReadFile("./Plugin/AccountSetting/html/AccountSetting.html", new Object())
        ]);

        Global_ControllerServiceSettingHtml = controllerServiceSettingHtml;
        Global_ControllerServiceSettingCss = controllerServiceSettingCss;
        Global_TimeSettingCss = timeSettingCss;
        Global_TimeSettingHtml = timeSettingHtml;
        Global_AccountSettingHtml = accountSettingHtml;
    } catch (error) {
        //console.error("Error reading files:", error);
    }
};

Main.prototype._LoadCenterContentHtml_Part2_ = async function() {
    const Class = new LoadFile();

    try {
        const [bootCss, bootHtml, comPortCss, comPortHtml, networkCss, networkUpdatePageHtml, networkHtml] = await Promise.all([
            Class.ReadFile("./Plugin/Boot/html/Css.html", new Object()),
            Class.ReadFile("./Plugin/Boot/html/Boot.html", new Object()),
            Class.ReadFile("./Plugin/ComPortInterfaceSetting/html/Css.html", new Object()),
            Class.ReadFile("./Plugin/ComPortInterfaceSetting/html/ComPortInterfaceSetting.html", new Object()),
            Class.ReadFile("./Plugin/NetworkSetting/html/Css.html", new Object()),
            Class.ReadFile("./Plugin/NetworkSetting/html/UpdatePage.html", new Object()),
            Class.ReadFile("./Plugin/NetworkSetting/html/NetworkSetting.html", new Object())
        ]);

        Global_BootCss = bootCss;
        Global_BootHtml = bootHtml;
        Global_ComPortInterfaceSettingHtml = comPortHtml;
        Global_ComPortInterfaceSettingCss = comPortCss;
        Global_NetworkSettingCssHtml = networkCss;
        Global_NetworkSettingUpdatePageHtml = networkUpdatePageHtml;
        Global_NetworkSettingHtml = networkHtml;
    } catch (error) {
        //console.error("Error reading files:", error);
    }
};

Main.prototype._LoadCenterContentHtml_Part3_ = async function() {
    const Class = new LoadFile();

    try {
        const [rtuCss, rtuFirstPageHtml, rtuSecondPageHtml, tcpCss, tcpFirstPageHtml, tcpSecondPageHtml] = await Promise.all([
            Class.ReadFile("./Plugin/RtuModule/html/Css.html", new Object()),
            Class.ReadFile("./Plugin/RtuModule/html/FirstPage.html", new Object()),
            Class.ReadFile("./Plugin/RtuModule/html/SecondPage.html", new Object()),
            Class.ReadFile("./Plugin/TcpModule/html/Css.html", new Object()),
            Class.ReadFile("./Plugin/TcpModule/html/FirstPage.html", new Object()),
            Class.ReadFile("./Plugin/TcpModule/html/SecondPage.html", new Object())
        ]);

        Global_RtuModuleCss = rtuCss;
        Global_RtuModuleFirstPageHtml = rtuFirstPageHtml;
        Global_RtuModuleSecondPageHtml = rtuSecondPageHtml;
        Global_TcpModuleCss = tcpCss;
        Global_TcpModuleFirstPageHtml = tcpFirstPageHtml;
        Global_TcpModuleSecondPageHtml = tcpSecondPageHtml;
    } catch (error) {
        //console.error("Error reading files:", error);
    }
};

Main.prototype._LoadCenterContentHtml_Part4_ = async function() {
    const Class = new LoadFile();

    try {
        const [asciiCss, asciiFirstPageHtml, asciiSecondPageHtml, mqttCss, mqttUpdatePageHtml, mqttFirstPageHtml, mqttSecondPageHtml] = await Promise.all([
            Class.ReadFile("./Plugin/AsciiModule/html/Css.html", new Object()),
            Class.ReadFile("./Plugin/AsciiModule/html/FirstPage.html", new Object()),
            Class.ReadFile("./Plugin/AsciiModule/html/SecondPage.html", new Object()),
            Class.ReadFile("./Plugin/MqttModule/html/Css.html", new Object()),
            Class.ReadFile("./Plugin/MqttModule/html/UpdatePage.html", new Object()),
            Class.ReadFile("./Plugin/MqttModule/html/FirstPage.html", new Object()),
            Class.ReadFile("./Plugin/MqttModule/html/SecondPage.html", new Object())
        ]);

        Global_AsciiModuleCssHtml = asciiCss;
        Global_AsciiModuleFirstPageHtml = asciiFirstPageHtml;
        Global_AsciiModuleSecondPageHtml = asciiSecondPageHtml;
        Global_MqttModuleCssHtml = mqttCss;
        Global_MqttModuleUpdatePageHtml = mqttUpdatePageHtml;
        Global_MqttModuleFirstPageHtml = mqttFirstPageHtml;
        Global_MqttModuleSecondPageHtml = mqttSecondPageHtml;
    } catch (error) {
        //console.error("Error reading files:", error);
    }
};

Main.prototype._LoadCenterContentHtml_Part5_ = async function() {
    const Class = new LoadFile();

    try {
        const [eipCss, eipFirstPageHtml, eipSecondPageHtml] = await Promise.all([
            Class.ReadFile("./Plugin/EipModule/html/Css.html", new Object()),
            Class.ReadFile("./Plugin/EipModule/html/FirstPage.html", new Object()),
            Class.ReadFile("./Plugin/EipModule/html/SecondPage.html", new Object())
        ]);

        Global_EipModuleCssHtml = eipCss;
        Global_EipModuleFirstPageHtml = eipFirstPageHtml;
        Global_EipModuleSecondPageHtml = eipSecondPageHtml;
    } catch (error) {
        //console.error("Error reading files:", error);
    }
};


Main.prototype._LoadVersion_ = function()
{
	var Result={"Input":null};
	var Class = new Cgi();
	Class.RestApi("GetVersion", new Array(), true, Result);
	var SetInterval = setInterval(function()
	{
		if(Result["Input"] != null)
		{
			Global_MiddlewareVersion   = Result["Input"][0];
			Global_MainProgramVersion  = Result["Input"][1];
			Global_WebInterfaceVersion = Result["Input"][2];
			Global_InstallInformation  = Result["Input"][3];
			Global_ModelName           = Result["Input"][4];
			
			clearInterval(SetInterval);
		}
	},500);
};

Main.prototype._LoadCenterContentHtml_XVModule_ = async function() {
    const Class = new LoadFile();

    try {
        const [xvCssHtml, xvFirstPageHtml, xvSecondPageHtml] = await Promise.all([
            Class.ReadFile("./Plugin/XVModule/html/Css.html", new Object()),
            Class.ReadFile("./Plugin/XVModule/html/FirstPage.html", new Object()),
            Class.ReadFile("./Plugin/XVModule/html/SecondPage.html", new Object())
        ]);

        Global_XVModuleCssHtml = xvCssHtml;
        Global_XVModuleFirstPageHtml = xvFirstPageHtml;
        Global_XVModuleSecondPageHtml = xvSecondPageHtml;
    } catch (error) {
        //console.error("Error reading files:", error);
    }
};

Main.prototype._LoadMysqlConnectionLeftListHtml_ = async function() {
    const Class = new LoadFile();

    try {
        const [mysqlCss, mysqlFirstPageHtml, mysqlSecondPageHtml] = await Promise.all([
            Class.ReadFile("./Plugin/MysqlConnection/html/Css.html", new Object()),
            Class.ReadFile("./Plugin/MysqlConnection/html/FirstPage.html", new Object()),
            Class.ReadFile("./Plugin/MysqlConnection/html/SecondPage.html", new Object())
        ]);

        Global_MysqlConnectionCss = mysqlCss;
        Global_MysqlConnectionFirstPageHtml = mysqlFirstPageHtml;
        Global_MysqlConnectionSecondPageHtml = mysqlSecondPageHtml;
    } catch (error) {
        //console.error("Error reading files:", error);
    }
};

Main.prototype._LoadRtuToMysqlConnectionLeftListHtml_ = async function() {
    const Class = new LoadFile();

    try {
        const [rtuCss, rtuUpdatePageHtml, rtuFirstPageHtml, rtuSecondPageHtml] = await Promise.all([
            Class.ReadFile("./Plugin/RtuToMysqlConnection/html/Css.html", new Object()),
            Class.ReadFile("./Plugin/RtuToMysqlConnection/html/UpdatePage.html", new Object()),
            Class.ReadFile("./Plugin/RtuToMysqlConnection/html/FirstPage.html", new Object()),
            Class.ReadFile("./Plugin/RtuToMysqlConnection/html/SecondPage.html", new Object())
        ]);

        Global_RtuToMysqlConnectionCss = rtuCss;
        Global_RtuToMysqlConnectionUpdatePageHtml = rtuUpdatePageHtml;
        Global_RtuToMysqlConnectionFirstPageHtml = rtuFirstPageHtml;
        Global_RtuToMysqlConnectionSecondPageHtml = rtuSecondPageHtml;
    } catch (error) {
        //console.error("Error reading files:", error);
    }
};

Main.prototype._LoadTcpToMysqlConnectionLeftListHtml_ = async function() {
    const Class = new LoadFile();

    try {
        const [tcpCss, tcpUpdatePageHtml, tcpFirstPageHtml, tcpSecondPageHtml] = await Promise.all([
            Class.ReadFile("./Plugin/TcpToMysqlConnection/html/Css.html", new Object()),
            Class.ReadFile("./Plugin/TcpToMysqlConnection/html/UpdatePage.html", new Object()),
            Class.ReadFile("./Plugin/TcpToMysqlConnection/html/FirstPage.html", new Object()),
            Class.ReadFile("./Plugin/TcpToMysqlConnection/html/SecondPage.html", new Object())
        ]);

        Global_TcpToMysqlConnectionCss = tcpCss;
        Global_TcpToMysqlConnectionUpdatePageHtml = tcpUpdatePageHtml;
        Global_TcpToMysqlConnectionFirstPageHtml = tcpFirstPageHtml;
        Global_TcpToMysqlConnectionSecondPageHtml = tcpSecondPageHtml;
    } catch (error) {
        //console.error("Error reading files:", error);
    }
};

Main.prototype._LoadMqttToMysqlLeftListHtml_ = async function() {
    const Class = new LoadFile();

    try {
        const [mqttCss, mqttUpdatePageHtml, mqttFirstPageHtml, mqttSecondPageHtml] = await Promise.all([
            Class.ReadFile("./Plugin/MqttToMysql/html/Css.html", new Object()),
            Class.ReadFile("./Plugin/MqttToMysql/html/UpdatePage.html", new Object()),
            Class.ReadFile("./Plugin/MqttToMysql/html/FirstPage.html", new Object()),
            Class.ReadFile("./Plugin/MqttToMysql/html/SecondPage.html", new Object())
        ]);

        Global_MqttToMysqlCss = mqttCss;
        Global_MqttToMysqlUpdatePageHtml = mqttUpdatePageHtml;
        Global_MqttToMysqlFirstPageHtml = mqttFirstPageHtml;
        Global_MqttToMysqlSecondPageHtml = mqttSecondPageHtml;
    } catch (error) {
        //console.error("Error reading files:", error);
    }
};

Main.prototype._LoadCenterContentHtml_Part6_ = function()
{
	Main.prototype._LoadMysqlConnectionLeftListHtml_();
	Main.prototype._LoadRtuToMysqlConnectionLeftListHtml_();
	Main.prototype._LoadTcpToMysqlConnectionLeftListHtml_();
	Main.prototype._LoadMqttToMysqlLeftListHtml_();
	Main.prototype._LoadMqttToMsSqlLeftListHtml_();
	Main.prototype._LoadCenterContentHtml_XVModule_();
}

Main.prototype._LoadMqttToMsSqlLeftListHtml_ = async function() {
    const Class = new LoadFile();

    try {
        const [mqttMsSqlCss, mqttMsSqlUpdatePageHtml, mqttMsSqlFirstPageHtml, mqttMsSqlSecondPageHtml] = await Promise.all([
            Class.ReadFile("./Plugin/MqttToMsSql/html/Css.html", new Object()),
            Class.ReadFile("./Plugin/MqttToMsSql/html/UpdatePage.html", new Object()),
            Class.ReadFile("./Plugin/MqttToMsSql/html/FirstPage.html", new Object()),
            Class.ReadFile("./Plugin/MqttToMsSql/html/SecondPage.html", new Object())
        ]);

        Global_MqttToMsSqlCss = mqttMsSqlCss;
        Global_MqttToMsSqlUpdatePageHtml = mqttMsSqlUpdatePageHtml;
        Global_MqttToMsSqlFirstPageHtml = mqttMsSqlFirstPageHtml;
        Global_MqttToMsSqlSecondPageHtml = mqttMsSqlSecondPageHtml;
    } catch (error) {
        //console.error("Error reading files:", error);
    }
};

Main.prototype._LoadRegisterToOpcuaHtml_ = async function() {
    const Class = new LoadFile();

    try {
        const [registerCss, registerFirstPageHtml, registerSecondPageHtml, registerUpdatePageHtml] = await Promise.all([
            Class.ReadFile("./Plugin/RegisterToOpcua/html/Css.html", new Object()),
            Class.ReadFile("./Plugin/RegisterToOpcua/html/FirstPage.html", new Object()),
            Class.ReadFile("./Plugin/RegisterToOpcua/html/SecondPage.html", new Object()),
            Class.ReadFile("./Plugin/RegisterToOpcua/html/UpdatePage.html", new Object())
        ]);

        Global_RegisterToOpcuaCss = registerCss;
        Global_RegisterToOpcuaFirstPageHtml = registerFirstPageHtml;
        Global_RegisterToOpcuaSecondPageHtml = registerSecondPageHtml;
        Global_RegisterToOpcuaUpdatePageHtml = registerUpdatePageHtml;
    } catch (error) {
        //console.error("Error reading files:", error);
    }
};

Main.prototype._LoadRegisterLeftListHtml_ = async function() {
    const Class = new LoadFile();

    try {
        const [registerCss, registerFirstPageHtml, registerSecondPageHtml] = await Promise.all([
            Class.ReadFile("./Plugin/RegisterModule/html/Css.html", new Object()),
            Class.ReadFile("./Plugin/RegisterModule/html/FirstPage.html", new Object()),
            Class.ReadFile("./Plugin/RegisterModule/html/SecondPage.html", new Object())
        ]);

        Global_RegisterModuleCss = registerCss;
        Global_RegisterModuleFirstPageHtml = registerFirstPageHtml;
        Global_RegisterModuleSecondPageHtml = registerSecondPageHtml;
    } catch (error) {
        //console.error("Error reading files:", error);
    }
};

Main.prototype._LoadPathHtml_ = async function() {
    const Class = new LoadFile();

    try {
        const [headPathHtml, otherPathHtml] = await Promise.all([
            Class.ReadFile("./Plugin/Main/html/Path/HeadPath.html", new Object()),
            Class.ReadFile("./Plugin/Main/html/Path/OtherPath.html", new Object())
        ]);

        Global_HeadPathHtml = headPathHtml;
        Global_OtherPathHtml = otherPathHtml;
    } catch (error) {
        //console.error("Error reading files:", error);
    }
};

Main.prototype._LoadCenterContentHtml_Part7_ = function()
{
	Main.prototype._LoadRegisterLeftListHtml_();
	Main.prototype._LoadRegisterToOpcuaHtml_();
}

Main.prototype._LoadCenterContentHtml_Part8_ = async function() {
    const Class = new LoadFile();

    try {
        const [webSecureCss, webSecureHtml, webSecure, ezuaqUtilityCss, ezuaqUtilityHtml, blockRuleCss, blockRuleFirstPageHtml, blockRuleSecondPageHtml, blockStatusCss, blockStatusHtml] = await Promise.all([
            Class.ReadFile("./Plugin/WebSecure/html/Css.html", new Object()),
            Class.ReadFile("./Plugin/WebSecure/html/WebSecure.html", new Object()),
            Class.ReadFile("./File/WebSecure.json", new Object()),
            Class.ReadFile("./Plugin/EZUAQUtility/html/Css.html", new Object()),
            Class.ReadFile("./Plugin/EZUAQUtility/html/EZUAQUtility.html", new Object()),
            Class.ReadFile("./Plugin/BlockRule/html/Css.html", new Object()),
            Class.ReadFile("./Plugin/BlockRule/html/FirstPage.html", new Object()),
            Class.ReadFile("./Plugin/BlockRule/html/SecondPage.html", new Object()),
            Class.ReadFile("./Plugin/BlockStatus/html/Css.html", new Object()),
            Class.ReadFile("./Plugin/BlockStatus/html/BlockStatus.html", new Object())
        ]);

        Global_WebSecureCss = webSecureCss;
        Global_WebSecureHtml = webSecureHtml;
        Global_WebSecure = webSecure;
        Global_EZUAQUtilityCss = ezuaqUtilityCss;
        Global_EZUAQUtilityHtml = ezuaqUtilityHtml;
        Global_BlockRuleCss = blockRuleCss;
        Global_BlockRuleFirstPageHtml = blockRuleFirstPageHtml;
        Global_BlockRuleSecondPageHtml = blockRuleSecondPageHtml;
        Global_BlockStatusCss = blockStatusCss;
        Global_BlockStatusHtml = blockStatusHtml;
    } catch (error) {
        //console.error("Error reading files:", error);
    }
};

Main.prototype._CheckLoginCredentials_ = function(Result)
{
	var Class = new Cgi();
	var Return = {Input:null};
	Class.RestApi("CheckLoginCredentials", new Array(), true, Return);
	var SetInterval = setInterval(function(){
		if(Return["Input"] != null)
		{
			clearInterval(SetInterval);
			Result["Input"]=Return["Input"];
			
		}
	},500);
};

Main.prototype._InitializeMainUi_ = function()
{
	$("#Main_Top-StepFlow").hide();
	var Result1 = {Input:null};  var Result2 = {Input:null};  var Result3 = {Input:null};  var Result4 = {Input:null};
	var Result5 = {Input:null};
	var SetInterval1 = setInterval(function(){
	if(typeof(Global_TranslateJson) != "undefined" && typeof(main_TopMenuCommon_mouseover) != "undefined" && typeof(main_TopMenuCommon_mouseout) != "undefined")
	{
		Main.prototype._LoadHtml_("#Main_Bottom-Information", "./Plugin/Main/html/Bottom/Information.html", Result1);
		Main.prototype._LoadHtml_("#Main_Top-Menu", "./Plugin/Top_Menu/html/Menu.html", Result2);
		Main.prototype._LoadHtml_("#Main_Top-StepFlow", "./Plugin/StepProcess/html/StepFlow.html", Result3);
		Main.prototype._LoadHtml_("#Main_Top-FunctionWizard", "./Plugin/StepProcess/html/FunctionWizard.html", Result4);
		Main.prototype._LoadHtml_("#Main_Top-SystemInformation", "./Plugin/SystemInformation/html/SystemInformation.html", Result5);
		clearInterval(SetInterval1);
	}},100);

	var SetInterval2 = setInterval(function(){
	if(Result1["Input"] == true && Result2["Input"] == true && Result3["Input"] == true && Result4["Input"] == true && Result5["Input"] == true)
	{
		var Size = $("#Main_Top-FunctionWizard").find(".FunctionWizardTable").find(".Select").find("option").size();
		for(var i=1; i<Size; i++)
		{
			$("#Main_Top-FunctionWizard").find(".FunctionWizardTable").find(".Select").find("option").eq(i).val(i-1);
		}
		clearInterval(SetInterval2);
	}},500);
}

Main.prototype._ShowMainUi_ = function()
{
	var SetInterval_1 = setInterval(function(){		
		if(typeof(Global_HeadPathHtml) != "undefined")
		{
			clearInterval(SetInterval_1);
			var Bar = new ProgressBar();
			Bar.HideProgressBar();
			$("#Main_Base").show();
		}
	},500);
	var SetInterval_2 = setInterval(function(){ 
		var StepFlowSize = $("#Main_Top-StepFlow").find(".StepTable").size();
		var MenuSize = $("#Main_Top-Menu").find(".Top-Menu").size();
		var FunctionWizardSize = $("#Main_Top-FunctionWizard").find(".FunctionWizardTable").size();
		if(StepFlowSize > 0 && MenuSize > 0 && FunctionWizardSize > 0 && 
		   typeof(main_SystemSetting_click) != "undefined" && typeof(StepFlow) != "undefined")
		{
			clearInterval(SetInterval_2);
			$("#Main_Top-StepFlow").show();
			$("#Main_Top-StepFlow").find(".StepTable").hide();
			$("#Main_Top-SystemInformation").show();
			$("#Main_Top-Menu").children("div").eq(0).click();
			var Class = new StepFlow();
			Class.StartFingerIcon();
			Main.prototype._ShowSystemInformation_();

			var TopMenuId = "Top-Menu-SystemSetting";
			var LeftListId = "Left-List-AccountSetting";
			var DefaultAccount = false;
			DefaultAccount = Main.prototype._CheckDefaultAccount_(TopMenuId, LeftListId);
			
			if(DefaultAccount == true)
			{
				Main.prototype._ClickElement_(TopMenuId, LeftListId);
				Main.prototype._DisableElement_(TopMenuId, LeftListId);
			}
		}
	},500);
}

Main.prototype._CheckDefaultAccount_ = function()
{
	var Return = false;

	if(Global_AccountSetting["Manager"]["Account"] == "root" &&
	   Global_AccountSetting["Manager"]["Password"] == "root")
	{
		Return = true;
	}
	return Return;
}

Main.prototype._ClickElement_ = function(TopMenuId, LeftListId)
{
	$("#Main_Top-Menu").find("#"+TopMenuId).click();
	$("#Main_Left-List").find("div").css('pointer-events', "none");
	$("#Main_Left-List").find("#"+LeftListId).click();
}

Main.prototype._DisableElement_ = function(TopMenuId, LeftListId)
{
	$("#Main_Top-FunctionWizard").css('pointer-events', "none");
	$("#Main_Top-FunctionWizard").css('opacity', 0.5);

	$("#Main_Top-Menu").find("div").css('pointer-events', "none");
	$("#Main_Top-Menu").find("div").css('opacity', 0.5);

	$("#Main_Top-Path").find("div").css('pointer-events', "none");
	$("#Main_Top-Path").find("div").css('opacity', 0.5);

	$("#Main_Left-List").find("div").css('pointer-events', "none");
	$("#Main_Left-List").find("div").css('opacity', 0.5);

	$("#Main_Top-Menu").find("#"+TopMenuId).css('pointer-events', "visible");
	$("#Main_Top-Menu").find("#"+TopMenuId).css('opacity', 1);

	$("#Main_Left-List").find("#"+LeftListId).css('pointer-events', "visible");
	$("#Main_Left-List").find("#"+LeftListId).css('opacity', 1);
}

Main.prototype._ShowSystemInformation_ = function()
{
	var Class = new SystemInformation;
	Class.ShowSystemInformationUi();
}

Main.prototype._SignInConnection_ = function()
{
	var SetInterval = setInterval(function()
	{
		Global_Socket.emit("MainPageConnection", true);
	},1000);
}

Main.prototype._StartMainLoad_ = async function() 
{
    const wrapInPromise = (method, ...args) => {
        return new Promise((resolve) => {
            const result = method(...args);
            if (result && typeof result.then === 'function') {
                result.then(resolve);
            } else {
                resolve(result);
            }
        });
    };

    await Promise.all([
        wrapInPromise(Main.prototype._LoadLanguage_),
        wrapInPromise(Main.prototype._AsynchronousInitializeGlobalVariables_),
        wrapInPromise(Main.prototype._LoadLeftListHtml_Part1_),
        wrapInPromise(Main.prototype._LoadLeftListHtml_Part2_),
        wrapInPromise(Main.prototype._LoadDescriptionHtml_Part1_),
        wrapInPromise(Main.prototype._LoadDescriptionHtml_Part2_),
        wrapInPromise(Main.prototype._LoadVersion_),
        wrapInPromise(Main.prototype._LoadHardwareInformation_),
        wrapInPromise(Main.prototype._LoadCenterContentHtml_Part1_),
        wrapInPromise(Main.prototype._LoadCenterContentHtml_Part2_),
        wrapInPromise(Main.prototype._LoadCenterContentHtml_Part3_),
        wrapInPromise(Main.prototype._LoadCenterContentHtml_Part4_),
        wrapInPromise(Main.prototype._LoadCenterContentHtml_Part5_),
        wrapInPromise(Main.prototype._LoadCenterContentHtml_Part6_),
        wrapInPromise(Main.prototype._LoadCenterContentHtml_Part7_),
        wrapInPromise(Main.prototype._LoadCenterContentHtml_Part8_),
        wrapInPromise(Main.prototype._LoadPathHtml_),
        wrapInPromise(Main.prototype._InitializeMainUi_),
        wrapInPromise(Main.prototype._ShowMainUi_)
    ]);
};

Main.prototype._LoadHardwareInformation_ = function()
{	
	var Result = {Input:null};
	var Class = new Transmission;
	Class.TransmissionArray("GetFlashVersionInformation", new Array(), Result);
	var SetInterval = setInterval(function()
	{
		if(Result["Input"] != null)
		{
			Global_FlashInformation = Result["Input"];
			clearInterval(SetInterval);
		}
	},1000);
}