StepFlow.prototype._TransmissionJson_ = function(ssocket, Command, string, Callback)
{
	var Length=20000, index=0;  var array = new Array("Start","");
	ssocket.emit(Command, array);	
	ssocket.on(Command, function (Return) {
		if(Return == "Start" || Return == "Send")
		{
			if(string.length > (index+Length)){
				array = new Array("Send", string.substring(index, index+Length));
			}
			else if(string.length <= (index+Length)){
				array = new Array("End", string.substring(index, string.length));
			}
			index = index + Length;
			ssocket.emit(Command, array);	
		}
		else if(Return == "End")
		{
			Callback();
		}
	});
};

StepFlow.prototype._SaveFinished_ = function(that, ssocket, Mode)
{
	ssocket.emit("SaveFinished");
	ssocket.on("SaveFinished", function (Return) {
		if(Return == true)
		{
			StepFlow.prototype._SaveXml_(Mode, that);
		}
		ssocket.emit("SocketClose");
	});
};

StepFlow.prototype._SaveStart_ = function(that, Mode)
{
	$(that).closest('.Row').find(".BigLoading").hide();
	var ssocket = io.connect();
	ssocket.emit("BackgroundExecution");
	ssocket.on("BackgroundExecution", function (Return) {
	if(Return == true)
	{
		StepFlow.prototype._SaveJson_(that, ssocket, Mode);
	}
	});
};

StepFlow.prototype._SaveJson_ = function(that, ssocket, Mode)
{
	if(Mode=="RtuToOpcua")                 {StepFlow.prototype._RtuToOpcua_(that, ssocket, Mode);}
	else if(Mode=="TcpToOpcua")            {StepFlow.prototype._TcpToOpcua_(that, ssocket, Mode);}
	else if(Mode=="AsciiToOpcua")          {StepFlow.prototype._AsciiToOpcua_(that, ssocket, Mode);}
	else if(Mode=="EipToOpcua")            {StepFlow.prototype._EipToOpcua_(that, ssocket, Mode);}
	else if(Mode=="MqttToOpcua")           {StepFlow.prototype._MqttToOpcua_(that, ssocket, Mode);}
	else if(Mode=="RtuToMqtt")             {StepFlow.prototype._RtuToMqtt_(that, ssocket, Mode);}
	else if(Mode=="TcpToMqtt")             {StepFlow.prototype._TcpToMqtt_(that, ssocket, Mode);}
	else if(Mode=="AsciiToMqtt")           {StepFlow.prototype._AsciiToMqtt_(that, ssocket, Mode);}
    else if(Mode=="EipToMqtt")             {StepFlow.prototype._EipToMqtt_(that, ssocket, Mode);}
	else if(Mode=="RtuToMqttJson")         {StepFlow.prototype._RtuToMqttJson_(that, ssocket, Mode);}
	else if(Mode=="TcpToMqttJson")         {StepFlow.prototype._TcpToMqttJson_(that, ssocket, Mode);}
	else if(Mode=="AsciiToMqttJson")       {StepFlow.prototype._AsciiToMqttJson_(that, ssocket, Mode);}
	else if(Mode=="PidOperation")          {StepFlow.prototype._PidOperation_(that, ssocket, Mode);}
	else if(Mode=="PidOperation + ToOpcua"){StepFlow.prototype._PidOperationToOpcua_(that, ssocket, Mode);}
	else if(Mode=="IftttConditionTrigger") {StepFlow.prototype._IftttConditionTrigger_(that, ssocket, Mode);}
	else if(Mode=="TcpToMsSql")   {StepFlow.prototype._TcpToMsSql_(that, ssocket, Mode);}
	else if(Mode=="RtuToMsSql")   {StepFlow.prototype._RtuToMsSql_(that, ssocket, Mode);}
};

StepFlow.prototype._SaveXml_ = async function(Mode, that)
{
	if(Mode=="EipToOpcua" ||
	   Mode=="RtuToOpcua" || 
	   Mode=="TcpToOpcua" || 
	   Mode=="AsciiToOpcua"||
	   Mode=="MqttToOpcua")                 {StepFlow.prototype._ToOpcua_(that);}
	else if(Mode=="EipToMqtt" ||
			Mode=="RtuToMqtt" || 
			Mode=="TcpToMqtt" || 
			Mode=="AsciiToMqtt")            {StepFlow.prototype._ToMqtt_(that);}
	else if(Mode=="RtuToMqttJson" || 
			Mode=="TcpToMqttJson" || 
			Mode=="AsciiToMqttJson")        {StepFlow.prototype._ToMqtt_(that);}
	else if(Mode=="PidOperation")           {StepFlow.prototype._ToPidOperation_(that);}
	else if(Mode=="PidOperation + ToOpcua") {StepFlow.prototype._ToPidOperationAndOpcua_(that);}
	else if(Mode=="IftttConditionTrigger")  {StepFlow.prototype._ToAllModuleDriver_(that);}
	else if(Mode=="TcpToMsSql")    {StepFlow.prototype._ToAll_(that);}
	else if(Mode=="RtuToMsSql")    {StepFlow.prototype._ToAll_(that);}
};

StepFlow.prototype._ToOpcua_ = async function(that) 
{
    var ssocket = io.connect();

    var Class = new JsonTransformXml();
	 var Xml_4 = await Class.TransformUAServerDataXml();
    await sendTransmissionJson(ssocket, "SaveUAServerDataXml", Xml_4);
	var Xml_3 = await Class.TransformMqttDri();
    await sendTransmissionJson(ssocket, "SaveMqttDri", Xml_3);
	var Xml_2 = await Class.TransformModbusDri();
    await sendTransmissionJson(ssocket, "SaveModbusDri", Xml_2);
	var Xml_1 = await Class.TransformVariableXml();   
    await sendTransmissionJson(ssocket, "SaveVariableTableXml", Xml_1);

    ssocket.emit("SaveFinished");

    ssocket.on("SaveFinished", function(Return) {
        ssocket.emit("SocketClose");
        $(that).closest('.Row').find(".BigLoading").hide();
    });

    // Class = null; // 如果需要釋放資源，可以取消註解
};


StepFlow.prototype._ToMqtt_ = async function(that) 
{
    var ssocket = io.connect();

    var Class = new JsonTransformXml();
   
    var Xml_3 = await Class.TransformMqttServiceXml();
    await sendTransmissionJson(ssocket, "SaveMQTTServiceXml", Xml_3);
	var Xml_2 = await Class.TransformModbusDri();
    await sendTransmissionJson(ssocket, "SaveModbusDri", Xml_2);
	var Xml_1 = await Class.TransformVariableXml();
    await sendTransmissionJson(ssocket, "SaveVariableTableXml", Xml_1);

    ssocket.emit("SaveFinished");

    ssocket.on("SaveFinished", function(Return) {
        ssocket.emit("SocketClose");
        $(that).closest('.Row').find(".BigLoading").hide();
    });

};


StepFlow.prototype._ToPidOperation_ = async function(that) 
{
    var ssocket = io.connect();
    var ClassCallback = new GetValue();
    //var Send = new Transmission();
    var Class = new JsonTransformXml();

	var Xml_4 = await Class.TransformPidDriverDri();

    await sendTransmissionJson(ssocket, "SavePidDriverDri", Xml_4);
    await ClassCallback.MethodTableXmlCallback(ssocket);
	var Xml_2 = await Class.TransformModbusDri();

    await sendTransmissionJson(ssocket, "SaveModbusDri", Xml_2);
	var Xml_1 = await Class.TransformVariableXml();
    await sendTransmissionJson(ssocket, "SaveVariableTableXml", Xml_1);

    ssocket.emit("SaveFinished");

    ssocket.on("SaveFinished", function(Return) {
        ssocket.emit("SocketClose");
        $(that).closest('.Row').find(".BigLoading").hide();
    });

};


StepFlow.prototype._ToPidOperationAndOpcua_ = async function(that) 
{
    var ssocket = io.connect();
    var Class = new GetValue();
    await Class.VariableTableXmlCallback(ssocket);
    await Class.ModbusDriCallback(ssocket);
    await Class.PidDriverDriCallback(ssocket);
    await Class.MethodTableXmlCallback(ssocket);

    var Send = new Transmission();
    var ClassXml = new JsonTransformXml();
    var Xml = await ClassXml.TransformUAServerDataXml();
    Send.TransmissionJson(ssocket, "SaveUAServerDataXml", Xml);
    
    ssocket.on("SaveFinished", function(Return) {
        ssocket.emit("SocketClose");
        $(that).closest('.Row').find(".BigLoading").hide();
    });
};

StepFlow.prototype._ToAllModuleDriver_ = async function(that) 
{
    var ssocket = io.connect();

    var Class = new GetValue();
    await Class._VariableTableXmlCallback_(ssocket);
    await Class._ModbusDriCallback_(ssocket);

    Class = new Transmission();
    var JsonString = JSON.stringify(Global_RtuIndex);
    await sendTransmissionJson(ssocket, "SaveRtuIndex", JsonString);

    ssocket.emit("SaveFinished");

    ssocket.on("SaveFinished", function(Return) {
        ssocket.emit("SocketClose");
        $(that).closest('.Row').find(".BigLoading").hide();
    });

    // Class = null; // 如果需要釋放資源，可以取消註解
};


StepFlow.prototype._ToAll_ = function(that) 
{
    var wrapInPromise = (method, ...args) => {
        return new Promise((resolve) => {
            method(...args, () => resolve());
        });
    };
	
    var ssocket = io.connect();

    var GetValueClass = new GetValue();

    var executeCallbacks = async function() {
        try {
            var JsonTransformClass = new JsonTransformXml();
            var TransmissionClass = new Transmission();
            var Xml = await JsonTransformClass.TransformPidDriverDri();
            await wrapInPromise(TransmissionClass.TransmissionJson, ssocket, "SavePidDriverDri", Xml);
            await GetValueClass._MethodTableXmlCallback_(ssocket);
            await GetValueClass._MqttServiceXmlCallback_(ssocket);
            await GetValueClass._UAServerDataXmlCallback_(ssocket);
            await GetValueClass._MqttDriCallback_(ssocket);
            await GetValueClass._ModbusDriCallback_(ssocket);
            await GetValueClass._VariableTableXmlCallback_(ssocket);

            // Emit SaveFinished after all callbacks are executed
            ssocket.emit("SaveFinished");

            ssocket.on("SaveFinished", function(Return) {
                 ssocket.emit("SocketClose");
                $(that).closest('.Row').find(".BigLoading").hide();
            });

        } catch (error) {
            //console.error("Error executing callbacks:", error);
        }
    };

    executeCallbacks();
};


StepFlow.prototype._RtuToOpcua_ = function(that, ssocket, Mode)
{
	var xotree = new XML.ObjTree();
	var xml = xotree.writeXML(Global_OpcUaLocalServer);
	var array = new Array(xml);
	ssocket.emit("SaveOpcUaLocalServer", array);
	
	var Callback0 = function(){StepFlow.prototype._SaveFinished_(that, ssocket, Mode);}

	var JsonString0 = JSON.stringify(Global_RtuToOpcuaVariable);
	var Callback1 = function(){StepFlow.prototype._TransmissionJson_(ssocket, "SaveRtuToOpcuaVariable", JsonString0, Callback0);}

	var Callback2 = RtuModuleFirstPage.prototype._ComPortCallback_(ssocket, Callback1);
	var Callback3 = RtuModuleFirstPage.prototype._AsciiCallback_(ssocket, Callback2);
	var Callback4 = RtuModuleFirstPage.prototype._RtuCallback_(ssocket, Callback3);
	
	var JsonString1 = JSON.stringify(Global_RtuIndex);
	$(that).closest('.Row').find(".BigLoading").show();
	var Class = new Transmission();
	Class.TransmissionJson(ssocket, "SaveRtuIndex", JsonString1, Callback4);
};

StepFlow.prototype._TcpToOpcua_ = function(that, ssocket, Mode)
{
	var xotree = new XML.ObjTree();
	var xml = xotree.writeXML(Global_OpcUaLocalServer);
	var array = new Array(xml);
	ssocket.emit("SaveOpcUaLocalServer", array);
	
	var Callback0 = function(){StepFlow.prototype._SaveFinished_(that, ssocket, Mode);}
	
	var JsonString0 = JSON.stringify(Global_TcpToOpcuaVariable);
	var Callback1 = function(){StepFlow.prototype._TransmissionJson_(ssocket, "SaveTcpToOpcuaVariable", JsonString0, Callback0);}

	var Callback2 = TcpModuleFirstPage.prototype._TcpCallback_(ssocket, Callback1);
	var JsonString1 = JSON.stringify(Global_TcpIndex);
	$(that).closest('.Row').find(".BigLoading").show();
	var Class = new Transmission();
	Class.TransmissionJson(ssocket, "SaveTcpIndex", JsonString1, Callback2);
};

StepFlow.prototype._AsciiToOpcua_ = function(that, ssocket, Mode)
{
	var xotree = new XML.ObjTree();
	var xml = xotree.writeXML(Global_OpcUaLocalServer);
	var array = new Array(xml);
	ssocket.emit("SaveOpcUaLocalServer", array);
	
	var Callback0 = function(){StepFlow.prototype._SaveFinished_(that, ssocket, Mode);}
	
	var JsonString0 = JSON.stringify(Global_AsciiToOpcuaVariable);
	var Callback1 = function(){StepFlow.prototype._TransmissionJson_(ssocket, "SaveAsciiToOpcuaVariable", JsonString0, Callback0);}

	var Callback2 = AsciiModuleFirstPage.prototype._ComPortCallback_(ssocket, Callback1);
	var Callback3 = AsciiModuleFirstPage.prototype._RtuCallback_(ssocket, Callback2);
	var Callback4 = AsciiModuleFirstPage.prototype._AsciiCallback_(ssocket, Callback3);
	var JsonString1 = JSON.stringify(Global_AsciiIndex);
	$(that).closest('.Row').find(".BigLoading").show();
	AsciiModuleFirstPage.prototype._TransmissionJson_(ssocket, "SaveAsciiIndex", JsonString1, Callback4);
};

StepFlow.prototype._MqttToOpcua_ = function(that, ssocket, Mode)
{
	var xotree = new XML.ObjTree();
	var xml = xotree.writeXML(Global_OpcUaLocalServer);
	var array = new Array(xml);
	ssocket.emit("SaveOpcUaLocalServer", array);
	
	var Callback0 = function(){StepFlow.prototype._SaveFinished_(that, ssocket, Mode);}
	
	var JsonString0 = JSON.stringify(Global_MqttToOpcuaVariable);
	var Callback1 = function(){StepFlow.prototype._TransmissionJson_(ssocket, "SaveMqttToOpcuaVariable", JsonString0, Callback0);}

	var Callback2 = MqttModuleFirstPage.prototype._MqttModuleCallback_(ssocket, Callback1);
	var JsonString1 = JSON.stringify(Global_MqttIndex);
	$(that).closest('.Row').find(".BigLoading").show();
	MqttModuleFirstPage.prototype._TransmissionJson_(ssocket, "SaveMqttIndex", JsonString1, Callback2);
};

StepFlow.prototype._RtuToMqtt_ = function(that, ssocket, Mode)
{
	var array = new Array(Global_RemoteBroker);
	ssocket.emit("SaveRemoteBrokerSetting", array);
	
	var Callback0 = function(){StepFlow.prototype._SaveFinished_(that, ssocket, Mode);}

	var JsonString1 = JSON.stringify(Global_RtuToMqttSetting);
	var Callback1 = function(){RtuToMqttFirstPage.prototype._TransmissionJson_(ssocket, "SaveRtuToMqttSetting", JsonString1, Callback0);}

	var JsonString2 = JSON.stringify(Global_RtuToMqttVariable);
	var Callback2 = function(){RtuToMqttFirstPage.prototype._TransmissionJson_(ssocket, "SaveRtuToMqttVariable", JsonString2, Callback1);}

	var Callback3 = RtuModuleFirstPage.prototype._ComPortCallback_(ssocket, Callback2);
	var Callback4 = RtuModuleFirstPage.prototype._AsciiCallback_(ssocket, Callback3);
	var Callback5 = RtuModuleFirstPage.prototype._RtuCallback_(ssocket, Callback4);

	var JsonString3 = JSON.stringify(Global_RtuIndex);
	$(that).closest('.Row').find(".BigLoading").show();
	var Class = new Transmission();
	Class.TransmissionJson(ssocket, "SaveRtuIndex", JsonString3, Callback5);
};

StepFlow.prototype._TcpToMqtt_ = function(that, ssocket, Mode) {
    var array = new Array(Global_RemoteBroker);
    ssocket.emit("SaveRemoteBrokerSetting", array);

    var Callback0 = function() { StepFlow.prototype._SaveFinished_(that, ssocket, Mode); };

    var JsonString1 = JSON.stringify(Global_TcpToMqttSetting);
    var Callback1 = function() { TcpToMqttFirstPage.prototype._TransmissionJson_(ssocket, "SaveTcpToMqttSetting", JsonString1, Callback0); };
    var JsonString2 = JSON.stringify(Global_TcpToMqttVariable);
    var Callback2 = function() { TcpToMqttFirstPage.prototype._TransmissionJson_(ssocket, "SaveTcpToMqttVariable", JsonString2, Callback1); };

    var JsonString3 = JSON.stringify(Global_TcpScalingToMqttVariable);
    var Callback3 = function() { TcpToMqttFirstPage.prototype._TransmissionJson_(ssocket, "SaveTcpScalingToMqttVariable", JsonString3, Callback2); };

    var Callback4 = TcpModuleFirstPage.prototype._TcpCallback_(ssocket, Callback3);
    var JsonString4 = JSON.stringify(Global_TcpIndex);
    $(that).closest('.Row').find(".BigLoading").show();
    var Class = new Transmission();
    Class.TransmissionJson(ssocket, "SaveTcpIndex", JsonString4, Callback4);
};

StepFlow.prototype._AsciiToMqtt_ = function(that, ssocket, Mode)
{
	var array = new Array(Global_RemoteBroker);
	ssocket.emit("SaveRemoteBrokerSetting", array);
	
	var Callback0 = function(){StepFlow.prototype._SaveFinished_(that, ssocket, Mode);}
	
	var JsonString1 = JSON.stringify(Global_AsciiToMqttSetting);
	var Callback1 = function(){AsciiToMqttFirstPage.prototype._TransmissionJson_(ssocket, "SaveAsciiToMqttSetting", JsonString1, Callback0);}
	
	var JsonString2 = JSON.stringify(Global_AsciiToMqttVariable);
	var Callback2 = function(){AsciiToMqttFirstPage.prototype._TransmissionJson_(ssocket, "SaveAsciiToMqttVariable", JsonString2, Callback1);}
	
	var Callback3 = AsciiModuleFirstPage.prototype._ComPortCallback_(ssocket, Callback2);
	var Callback4 = AsciiModuleFirstPage.prototype._RtuCallback_(ssocket, Callback3);
	var Callback5 = AsciiModuleFirstPage.prototype._AsciiCallback_(ssocket, Callback4);
	var JsonString3 = JSON.stringify(Global_AsciiIndex);
	$(that).closest('.Row').find(".BigLoading").show();
	AsciiModuleFirstPage.prototype._TransmissionJson_(ssocket, "SaveAsciiIndex", JsonString3, Callback5);
};

StepFlow.prototype._RtuToMqttJson_ = function(that, ssocket, Mode)
{
	var array = new Array(Global_RemoteBroker);
	ssocket.emit("SaveRemoteBrokerSetting", array);

	var Callback0 = function(){StepFlow.prototype._SaveFinished_(that, ssocket, Mode);}

	var JsonString1 = JSON.stringify(Global_MqttJsonGroup);
	var Callback1 = function(){StepFlow.prototype._TransmissionJson_(ssocket, "SaveMqttJsonGroup", JsonString1, Callback0);}

	var JsonString2 = JSON.stringify(Global_RtuToMqttJsonVariable);
	var Callback2 = function(){StepFlow.prototype._TransmissionJson_(ssocket, "SaveRtuToMqttJsonVariable", JsonString2, Callback1);}

	var Callback3 = RtuModuleFirstPage.prototype._ComPortCallback_(ssocket, Callback2);
	var Callback4 = RtuModuleFirstPage.prototype._AsciiCallback_(ssocket, Callback3);
	var Callback5 = RtuModuleFirstPage.prototype._RtuCallback_(ssocket, Callback4);

	var JsonString3 = JSON.stringify(Global_RtuIndex);
	$(that).closest('.Row').find(".BigLoading").show();
	var Class = new Transmission();
	Class.TransmissionJson(ssocket, "SaveRtuIndex", JsonString3, Callback5);
};

StepFlow.prototype._TcpToMqttJson_ = function(that, ssocket, Mode)
{
	var array = new Array(Global_RemoteBroker);
	ssocket.emit("SaveRemoteBrokerSetting", array);

	var Callback0 = function(){StepFlow.prototype._SaveFinished_(that, ssocket, Mode);}

	var JsonString1 = JSON.stringify(Global_MqttJsonGroup);
	var Callback1 = function(){StepFlow.prototype._TransmissionJson_(ssocket, "SaveMqttJsonGroup", JsonString1, Callback0);}

	var JsonString2 = JSON.stringify(Global_TcpToMqttJsonVariable);
	var Callback2 = function(){StepFlow.prototype._TransmissionJson_(ssocket, "SaveTcpToMqttJsonVariable", JsonString2, Callback1);}

	var Callback3 = TcpModuleFirstPage.prototype._TcpCallback_(ssocket, Callback2);
	var JsonString3 = JSON.stringify(Global_TcpIndex);
	$(that).closest('.Row').find(".BigLoading").show();
	var Class = new Transmission();
	Class.TransmissionJson(ssocket, "SaveTcpIndex", JsonString3, Callback3);
};

StepFlow.prototype._PidOperation_ = async function(that, ssocket, Mode) 
{
    var array = Global_LocalBroker;
    ssocket.emit("SaveLocalBrokerSetting", array);
    array = new Array(Global_RemoteBroker);
    ssocket.emit("SaveRemoteBrokerSetting", array);

    var Class = new GetValue();
    await Class._ComPortCallback_(ssocket);
    await Class._RtuModuleCallback_(ssocket);
    await Class._TcpModuleCallback_(ssocket);
    await Class._AsciiModuleCallback_(ssocket);

    Class = new Transmission();
    var JsonString = JSON.stringify(Global_PidOperation);
    $(that).closest('.Row').find(".BigLoading").show();
    await sendTransmissionJson(ssocket, "SavePidOperationVariable", JsonString);

    StepFlow.prototype._SaveFinished_(that, ssocket, Mode);
};

StepFlow.prototype._PidOperationToOpcua_ = async function(that, ssocket, Mode) 
{
    var Class = new Transmission();
    Class.SaveOpcUaLocalServer();
    Class.SaveLocalBrokerSetting();
    Class.SaveRemoteBrokerSetting();

    var Class = new GetValue();
    await Class._ComPortCallback_(ssocket);
    await Class._RtuModuleCallback_(ssocket);
    await Class._TcpModuleCallback_(ssocket);
    await Class._AsciiModuleCallback_(ssocket);
    await Class._AllModuleToOpcuaCallback_(ssocket);

    Class = new Transmission();
    var JsonString = JSON.stringify(Global_PidOperation);
    $(that).closest('.Row').find(".BigLoading").show();
    await sendTransmissionJson(ssocket, "SavePidOperationVariable", JsonString);

    StepFlow.prototype._SaveFinished_(that, ssocket, Mode);
};


StepFlow.prototype._IftttConditionTrigger_ = async function(that, ssocket, Mode) 
{
    var Class = new GetValue();
    await Class._ComPortCallback_(ssocket);
    await Class._RtuModuleCallback_(ssocket);
    await Class._TcpModuleCallback_(ssocket);
    await Class._AsciiModuleCallback_(ssocket);

    Class = new Transmission();
    var JsonString1 = JSON.stringify(Global_IftttConditionTriggerSetting);
    var JsonString2 = JSON.stringify(Global_IftttConditionTriggerVariable);

    $(that).closest('.Row').find(".BigLoading").show();
    await sendTransmissionJson(ssocket, "SaveIftttConditionTriggerVariable", JsonString2);
    await sendTransmissionJson(ssocket, "SaveIftttConditionTriggerSetting", JsonString1);

    StepFlow.prototype._SaveFinished_(that, ssocket, Mode);
};


StepFlow.prototype._TcpToMsSql_ = async function(that, ssocket, Mode) 
{
    var Class = new GetValue();
    await Class._TcpModuleCallback_(ssocket);
    await Class._TcpToMsSqlVariableCallback_(ssocket);

    Class = new Transmission();
    var JsonString1 = JSON.stringify(Global_MsSqlConnection);
    $(that).closest('.Row').find(".BigLoading").show();
    await sendTransmissionJson(ssocket, "SaveMsSqlConnection", JsonString1);

    StepFlow.prototype._SaveFinished_(that, ssocket, Mode);
};

StepFlow.prototype._RtuToMsSql_ = async function(that, ssocket, Mode) 
{
    var Class = new GetValue();
    await Class._RtuModuleCallback_(ssocket);
    await Class._RtuToMsSqlVariableCallback_(ssocket);

    Class = new Transmission();
    var JsonString1 = JSON.stringify(Global_MsSqlConnection);
    $(that).closest('.Row').find(".BigLoading").show();
    await sendTransmissionJson(ssocket, "SaveMsSqlConnection", JsonString1);

    StepFlow.prototype._SaveFinished_(that, ssocket, Mode);
};

StepFlow.prototype._TcpToMysqlConnection_ = async function(that, ssocket, Mode) 
{
    var Class = new GetValue();
    await Class._TcpModuleCallback_(ssocket);
    await Class._TcpToMysqlConnectionVariableCallback_(ssocket);

    Class = new Transmission();
    var JsonString1 = JSON.stringify(Global_MysqlConnection);
    $(that).closest('.Row').find(".BigLoading").show();
    await sendTransmissionJson(ssocket, "SaveMysqlConnection", JsonString1);

    StepFlow.prototype._SaveFinished_(that, ssocket, Mode);
};

StepFlow.prototype._RtuToMysqlConnection_ = async function(that, ssocket, Mode) 
{
    var Class = new GetValue();
    await Class._RtuModuleCallback_(ssocket);
    await Class._RtuToMysqlConnectionVariableCallback_(ssocket);

    Class = new Transmission();
    var JsonString1 = JSON.stringify(Global_MysqlConnection);
    $(that).closest('.Row').find(".BigLoading").show();
    await sendTransmissionJson(ssocket, "SaveMysqlConnection", JsonString1);

    StepFlow.prototype._SaveFinished_(that, ssocket, Mode);
};


StepFlow.prototype._AllEnableElement_ = function()
{
	$("#Main_Top-Path").find("div").css('pointer-events', "visible");
	$("#Main_Top-Path").find("div").css('opacity', 1);
	
	$("#Main_Top-Menu").find("div").css('pointer-events', "visible");
	$("#Main_Top-Menu").find("div").css('opacity', 1);
	
	$("#Main_Left-List").find("div").css('pointer-events', "visible");
	$("#Main_Left-List").find("div").css('opacity', 1);
};

StepFlow.prototype._ClickElement_ = function(that, TopMenuId, LeftListId)
{
	$("#Main_Top-Menu").find("#"+TopMenuId).click();
	$("#Main_Left-List").find("div").css('pointer-events', "none");
	$("#Main_Left-List").find("#"+LeftListId).click();
	StepFlow.prototype._ChangeDivCss_(that);
	$("#Main_Top-Path").find("div").css('pointer-events', "visible");
	$("#Main_Top-Menu").find("div").css('pointer-events', "visible");
	$("#Main_Left-List").find("div").css('pointer-events', "visible");
};

StepFlow.prototype._DisableElement_ = function(TopMenuId, LeftListId)
{
	StepFlow.prototype._StopFingerIcon_();
	$("#Main_Top-Path").find("div").css('pointer-events', "none");
	$("#Main_Top-Path").find("div").css('opacity', 0.5);

	$("#Main_Top-Menu").find("div").css('pointer-events', "none");
	$("#Main_Top-Menu").find("div").css('opacity', 0.5);

	$("#Main_Left-List").find("div").css('pointer-events', "none");
	$("#Main_Left-List").find("div").css('opacity', 0.5);

	$("#Main_Top-Menu").find("#"+TopMenuId).css('opacity', 1);
	$("#Main_Left-List").find("#"+LeftListId).css('opacity', 1);
};

StepFlow.prototype._ShowStepFlowRow_ = function(Index)
{
	if(Index == "null"){
		$("#Main_Top-StepFlow").find(".StepTable").hide();
		StepFlow.prototype._AllEnableElement_();
	}
	else{
		$("#Main_Top-StepFlow").find(".StepTable").find(".Row").hide();
		$("#Main_Top-StepFlow").find(".StepTable").find(".Row").eq(Index).show();
		$("#Main_Top-StepFlow").find(".StepTable").show();
		$("#Main_Top-StepFlow").find(".StepTable").find(".Row").eq(Index).find(".StepText").eq(0).click();
	}
};

StepFlow.prototype._ChangeDivCss_ = function(that)
{
	var LeftDivId="#Main_Left-Step", TopDivId="#Main_Top-StepFlow";
	var Class = new StepCommon();
	Class.ChangeDivCss(that, TopDivId);
	
};

StepFlow.prototype._RunProject_ = function(that)
{
	$(that).closest('.Column').find(".Message").eq(1).show();
	StepFlow.prototype._RunMainProgram_(that);
	StepFlow.prototype._RunMqttBroker_();
};

StepFlow.prototype._RunProjectNoHide_ = function(that)
{
	$(that).closest('.Column').find(".Message").eq(1).show();
	StepFlow.prototype._RunMainProgramNoHide_(that);
};

StepFlow.prototype._RunProject_BackstageService_ = function(that)
{
	$(that).closest('.Column').find(".Message").eq(1).show();
	var Result_1={"Input":null};  var Result_2={"Input":null};
	var Class = new Transmission();
	Class.TransmissionArray("StartMainSystem", new Array(), Result_1);
	var SetInterval_1 = setInterval(function(){
		if(Result_1["Input"] == true){
			clearInterval(SetInterval_1);
			Class.TransmissionArray("StartBackstageService", new Array(), Result_2);
		}
	},500);
	var SetInterval_2 = setInterval(function(){
		if(Result_2["Input"] == true)
		{
			clearInterval(SetInterval_2);
			$(that).closest('.Column').find(".Message").hide();
			$(that).closest('.Column').find(".Message").eq(0).show();
			setTimeout(function()
			{
				$("#Main_Top-FunctionWizard").find(".FunctionWizardTable").find(".Row").eq(0).find(".Select").val("null");
				StepFlow.prototype._AllEnableElement_();
				$("#Main_Top-StepFlow").find(".StepTable").hide();
				$(that).closest('.Column').find(".Message").hide();
			}, 2000);
		}
	},500);
};

StepFlow.prototype._RunMainProgram_ = function(that)
{
	var ssocket = io.connect();
	ssocket.emit('StartMainSystem');
	ssocket.on('StartMainSystem', function (Return) {
		if(Return == true)
		{
			ssocket.emit("SocketClose");
			$(that).closest('.Column').find(".Message").hide();
			$(that).closest('.Column').find(".Message").eq(0).show();
			var SetInterval = setInterval(function()
			{
				$("#Main_Top-FunctionWizard").find(".FunctionWizardTable").find(".Row").eq(0).find(".Select").val("null");
				StepFlow.prototype._AllEnableElement_();
				$("#Main_Top-StepFlow").find(".StepTable").hide();
				$(that).closest('.Column').find(".Message").hide();
				clearInterval(SetInterval);
			},2500);
		}
		else
		{
			ssocket.emit('StartMainSystem');
		}
	});
};

StepFlow.prototype._RunMainProgramNoHide_ = function(that)
{
	var ssocket = io.connect();
	ssocket.emit('StartMainSystem');
	ssocket.on('StartMainSystem', function (Return) {
		if(Return == true)
		{
			ssocket.emit("SocketClose");
			$(that).closest('.Column').find(".Message").hide();
			$(that).closest('.Column').find(".Message").eq(0).show();
			var SetInterval = setInterval(function()
			{
				$(that).closest('.Column').find(".Message").hide();
				clearInterval(SetInterval);
			},2500);
		}
		else
		{
			ssocket.emit('StartMainSystem');
		}
	});
};

StepFlow.prototype._RunMqttBroker_ = function()
{
	var ssocket = io.connect();
	ssocket.emit('StartMqttBroker');
	ssocket.on('StartMqttBroker', function (Return) 
	{
		if(Return == true)
		{
			ssocket.emit("SocketClose");
		}
		else
		{
			ssocket.emit('StartMqttBroker');
		}
	});
};

StepFlow.prototype._SelectComPortSetting_ = function(that)
{
	var TopMenuId="Top-Menu-SystemSetting", LeftListId="Left-List-ComPortSetting";
	StepFlow.prototype._ClickElement_(that, TopMenuId, LeftListId);
	StepFlow.prototype._DisableElement_(TopMenuId, LeftListId);
};

StepFlow.prototype._StartFingerIcon_ = function()
{
	var Column = $("#Main_Top-FunctionWizard").find(".FunctionWizardTable").find(".Row").find(".Column");
	Column.eq(1).show();
	Global_SetInterval = setInterval(function(){
		if(Column.eq(2).find(".Select").css("border-color") == "rgb(255, 0, 0)"){
			Column.eq(2).find(".Select").css("border-color", "rgb(170, 170, 170)");
		}
		else{
			Column.eq(2).find(".Select").css("border-color", "rgb(255, 0, 0)");
		}
		Column.eq(1).find("img").hide(400);
		Column.eq(1).find("img").show(400);
	}, 1000);
};

StepFlow.prototype._StopFingerIcon_ = function()
{
	clearInterval(Global_SetInterval);
	var Column = $("#Main_Top-FunctionWizard").find(".FunctionWizardTable").find(".Row").find(".Column");
	Column.eq(1).hide();
	Column.eq(2).find(".Select").css("border-color", "#AAAAAA");
	Column.eq(2).find(".Select").css("border-width", "1px");
};

StepFlow.prototype._SelectBrokerSetting_ = function(that)
{
	var TopMenuId="Top-Menu-IotPlatformSetting", LeftListId="Left-List-LocalBroker";
	StepFlow.prototype._ClickElement_(that, TopMenuId, LeftListId);
	StepFlow.prototype._DisableElement_(TopMenuId, LeftListId);
	$("#Main_Left-List").find("#Left-List-LocalBroker").css('pointer-events', "visible");
	$("#Main_Left-List").find("#Left-List-LocalBroker").css('opacity', 1);
	$("#Main_Left-List").find("#Left-List-RemoteBroker").css('pointer-events', "visible");
	$("#Main_Left-List").find("#Left-List-RemoteBroker").css('opacity', 1);
};

StepFlow.prototype._SelectMqttGroupConnection_ = function(that)
{
	var TopMenuId="Top-Menu-IotPlatformSetting", LeftListId="Left-List-MqttJsonGroup";
	StepFlow.prototype._ClickElement_(that, TopMenuId, LeftListId);
	StepFlow.prototype._DisableElement_(TopMenuId, LeftListId);
};

StepFlow.prototype._SelectAzureSetting_ = function(that)
{
	var TopMenuId="Top-Menu-IotPlatformSetting", LeftListId="Left-List-AzurePlatform";
	StepFlow.prototype._ClickElement_(that, TopMenuId, LeftListId);
	StepFlow.prototype._DisableElement_(TopMenuId, LeftListId);
};

StepFlow.prototype._SelectOpcUaLocalServer_ = function(that)
{
	var TopMenuId="Top-Menu-IotPlatformSetting", LeftListId="Left-List-LocalServer";
	StepFlow.prototype._ClickElement_(that, TopMenuId, LeftListId);
	StepFlow.prototype._DisableElement_(TopMenuId, LeftListId);
};

StepFlow.prototype._MasterRtuToOpcua_ = function(that)
{
	var TopMenuId="Top-Menu-ConvertTransmission", LeftListId="Left-List-RtuToOpcua";
	StepFlow.prototype._ClickElement_(that, TopMenuId, LeftListId);
	StepFlow.prototype._DisableElement_(TopMenuId, LeftListId);
};

StepFlow.prototype._MasterTcpToOpcua_ = function(that)
{
	var TopMenuId="Top-Menu-ConvertTransmission", LeftListId="Left-List-TcpToOpcua";
	StepFlow.prototype._ClickElement_(that, TopMenuId, LeftListId);
	StepFlow.prototype._DisableElement_(TopMenuId, LeftListId);
};

StepFlow.prototype._MasterAsciiToOpcua_ = function(that)
{
	var TopMenuId="Top-Menu-ConvertTransmission", LeftListId="Left-List-AsciiToOpcua";
	StepFlow.prototype._ClickElement_(that, TopMenuId, LeftListId);
	StepFlow.prototype._DisableElement_(TopMenuId, LeftListId);
};

StepFlow.prototype._SelectMqttToOpcua_ = function(that)
{
	var TopMenuId="Top-Menu-ConvertTransmission", LeftListId="Left-List-MqttToOpcua";
	StepFlow.prototype._ClickElement_(that, TopMenuId, LeftListId);
	StepFlow.prototype._DisableElement_(TopMenuId, LeftListId);
};

StepFlow.prototype._AllModuleToOpcua_ = function(that)
{
	var TopMenuId="Top-Menu-ConvertTransmission", LeftListId="Left-List-RtuToOpcua";
	StepFlow.prototype._ClickElement_(that, TopMenuId, LeftListId);
	StepFlow.prototype._DisableElement_(TopMenuId, LeftListId);
	var Div=$('#Main_Left-List').find("div");
	$('#Left-List-RtuToOpcua').css('pointer-events', "visible");
	$('#Left-List-TcpToOpcua').css('pointer-events', "visible");
	$('#Left-List-AsciiToOpcua').css('pointer-events', "visible");
	$('#Left-List-RtuToOpcua').css('opacity', 1);
	$('#Left-List-TcpToOpcua').css('opacity', 1);
	$('#Left-List-AsciiToOpcua').css('opacity', 1);
};

StepFlow.prototype._MasterRtuToMqtt_ = function(that)
{
	var TopMenuId="Top-Menu-ConvertTransmission", LeftListId="Left-List-RtuToMqtt";
	StepFlow.prototype._ClickElement_(that, TopMenuId, LeftListId);
	StepFlow.prototype._DisableElement_(TopMenuId, LeftListId);
};

StepFlow.prototype._MasterTcpToMqtt_ = function(that)
{
	var TopMenuId="Top-Menu-ConvertTransmission", LeftListId="Left-List-TcpToMqtt";
	StepFlow.prototype._ClickElement_(that, TopMenuId, LeftListId);
	StepFlow.prototype._DisableElement_(TopMenuId, LeftListId);
};

StepFlow.prototype._MasterAsciiToMqtt_ = function(that)
{
	var TopMenuId="Top-Menu-ConvertTransmission", LeftListId="Left-List-AsciiToMqtt";
	StepFlow.prototype._ClickElement_(that, TopMenuId, LeftListId);
	StepFlow.prototype._DisableElement_(TopMenuId, LeftListId);
};

StepFlow.prototype._MasterRtuToMqttJson_ = function(that)
{
	var TopMenuId="Top-Menu-ConvertTransmission", LeftListId="Left-List-RtuToMqttJson";
	StepFlow.prototype._ClickElement_(that, TopMenuId, LeftListId);
	StepFlow.prototype._DisableElement_(TopMenuId, LeftListId);
};

StepFlow.prototype._MasterTcpToMqttJson_ = function(that)
{
	var TopMenuId="Top-Menu-ConvertTransmission", LeftListId="Left-List-TcpToMqttJson";
	StepFlow.prototype._ClickElement_(that, TopMenuId, LeftListId);
	StepFlow.prototype._DisableElement_(TopMenuId, LeftListId);
};

StepFlow.prototype._MasterAsciiToMqttJson_ = function(that)
{
	var TopMenuId="Top-Menu-ConvertTransmission", LeftListId="Left-List-AsciiToMqttJson";
	StepFlow.prototype._ClickElement_(that, TopMenuId, LeftListId);
	StepFlow.prototype._DisableElement_(TopMenuId, LeftListId);
};



StepFlow.prototype._MasterRtuModule_ = function(that)
{
	var TopMenuId="Top-Menu-ModuleSetting", LeftListId="Left-List-RTU";
	StepFlow.prototype._ClickElement_(that, TopMenuId, LeftListId);
	StepFlow.prototype._DisableElement_(TopMenuId, LeftListId);
};

StepFlow.prototype._MasterTcpModule_ = function(that)
{
	var TopMenuId="Top-Menu-ModuleSetting", LeftListId="Left-List-TCP";
	StepFlow.prototype._ClickElement_(that, TopMenuId, LeftListId);
	StepFlow.prototype._DisableElement_(TopMenuId, LeftListId);
};

StepFlow.prototype._MasterAsciiModule_ = function(that)
{
	var TopMenuId="Top-Menu-ModuleSetting", LeftListId="Left-List-ASCII";
	StepFlow.prototype._ClickElement_(that, TopMenuId, LeftListId);
	StepFlow.prototype._DisableElement_(TopMenuId, LeftListId);
};

StepFlow.prototype._MqttModule_ = function(that)
{
	var TopMenuId="Top-Menu-ModuleSetting", LeftListId="Left-List-MQTT";
	StepFlow.prototype._ClickElement_(that, TopMenuId, LeftListId);
	StepFlow.prototype._DisableElement_(TopMenuId, LeftListId);
};

StepFlow.prototype._AllModule_ = function(that)
{
	var TopMenuId="Top-Menu-ModuleSetting", LeftListId="Left-List-RTU";
	StepFlow.prototype._ClickElement_(that, TopMenuId, LeftListId);
	StepFlow.prototype._DisableElement_(TopMenuId, LeftListId);
	$("#Main_Left-List").find(".Left-List").css('pointer-events', "visible");
	$("#Main_Left-List").find(".Left-List").css('opacity', 1);
};

StepFlow.prototype._MasterModbusModule_ = function(that)
{
	var TopMenuId="Top-Menu-ModuleSetting", LeftListId="Left-List-RTU";
	StepFlow.prototype._ClickElement_(that, TopMenuId, LeftListId);
	StepFlow.prototype._StopFingerIcon_();
	StepFlow.prototype._DisableElement_(TopMenuId, LeftListId);
	$("#Main_Left-List").find("#Left-List-RTU").css('pointer-events', "visible");
	$("#Main_Left-List").find("#Left-List-RTU").css('opacity', 1);
	$("#Main_Left-List").find("#Left-List-TCP").css('pointer-events', "visible");
	$("#Main_Left-List").find("#Left-List-TCP").css('opacity', 1);
	$("#Main_Left-List").find("#Left-List-ASCII").css('pointer-events', "visible");
	$("#Main_Left-List").find("#Left-List-ASCII").css('opacity', 1);
};
StepFlow.prototype._UnlockAllModule_ = function(that)
{
	var TopMenuId="Top-Menu-ModuleSetting", LeftListId="Left-List-RTU";
	StepFlow.prototype._ClickElement_(that, TopMenuId, LeftListId);
	StepFlow.prototype._StopFingerIcon_();
	//StepFlow.prototype._DisableElement_(TopMenuId, LeftListId);
	/*$("#Main_Left-List").find("#Left-List-RTU").css('pointer-events', "visible");
	$("#Main_Left-List").find("#Left-List-RTU").css('opacity', 1);
	$("#Main_Left-List").find("#Left-List-TCP").css('pointer-events', "visible");
	$("#Main_Left-List").find("#Left-List-TCP").css('opacity', 1);
	$("#Main_Left-List").find("#Left-List-ASCII").css('pointer-events', "visible");
	$("#Main_Left-List").find("#Left-List-ASCII").css('opacity', 1);*/
	$("#Main_Left-List").find("#Left-List-MqttToIoTCloud").css('pointer-events', "visible");
	$("#Main_Left-List").find("#Left-List-MqttToIoTCloud").css('opacity', 1);
};


StepFlow.prototype._SelectPidOperation_ = function(that)
{
	var TopMenuId="Top-Menu-AdvancedSetting", LeftListId="Left-List-PID";
	StepFlow.prototype._ClickElement_(that, TopMenuId, LeftListId);
	StepFlow.prototype._DisableElement_(TopMenuId, LeftListId);
};

StepFlow.prototype._SelectIftttConditionTrigger_ = function(that)
{
	var TopMenuId="Top-Menu-AdvancedSetting", LeftListId="Left-List-IftttConditionTrigger";
	StepFlow.prototype._ClickElement_(that, TopMenuId, LeftListId);
	StepFlow.prototype._DisableElement_(TopMenuId, LeftListId);
};







StepFlow.prototype._SelectMsSqlConnection_ = function(that)
{
	var TopMenuId="Top-Menu-AdvancedSetting", LeftListId="Left-List-MsSqlConnection";
	StepFlow.prototype._ClickElement_(that, TopMenuId, LeftListId);
	StepFlow.prototype._DisableElement_(TopMenuId, LeftListId);
};

StepFlow.prototype._SelectRtuModuleRecord_ = function(that)
{
	var TopMenuId="Top-Menu-LoggerSetting", LeftListId="Left-List-RtuToMsSql";
	StepFlow.prototype._ClickElement_(that, TopMenuId, LeftListId);
	StepFlow.prototype._DisableElement_(TopMenuId, LeftListId);
};

StepFlow.prototype._SelectTcpModuleRecord_ = function(that)
{
	var TopMenuId="Top-Menu-LoggerSetting", LeftListId="Left-List-TcpToMsSql";
	StepFlow.prototype._ClickElement_(that, TopMenuId, LeftListId);
	StepFlow.prototype._DisableElement_(TopMenuId, LeftListId);
};

StepFlow.prototype._SelectMysqlConnection_ = function(that)
{
	var TopMenuId="Top-Menu-AdvancedSetting", LeftListId="Left-List-MysqlConnection";
	StepFlow.prototype._ClickElement_(that, TopMenuId, LeftListId);
	StepFlow.prototype._DisableElement_(TopMenuId, LeftListId);
};

StepFlow.prototype._SelectRtuToMysqlConnection_ = function(that)
{
	var TopMenuId="Top-Menu-LoggerSetting", LeftListId="Left-List-RtuToMysqlConnection";
	StepFlow.prototype._ClickElement_(that, TopMenuId, LeftListId);
	StepFlow.prototype._DisableElement_(TopMenuId, LeftListId);
};

StepFlow.prototype._SelectTcpToMysqlConnection_ = function(that)
{
	var TopMenuId="Top-Menu-LoggerSetting", LeftListId="Left-List-TcpToMysqlConnection";
	StepFlow.prototype._ClickElement_(that, TopMenuId, LeftListId);
	StepFlow.prototype._DisableElement_(TopMenuId, LeftListId);
};

StepFlow.prototype._SelectMqttToMysql_ = function(that)
{
	var TopMenuId="Top-Menu-LoggerSetting", LeftListId="Left-List-MqttToMysql";
	StepFlow.prototype._ClickElement_(that, TopMenuId, LeftListId);
	StepFlow.prototype._DisableElement_(TopMenuId, LeftListId);
};

StepFlow.prototype._SelectMqttToMsSql_ = function(that)
{
	var TopMenuId="Top-Menu-LoggerSetting", LeftListId="Left-List-MqttToMsSql";
	StepFlow.prototype._ClickElement_(that, TopMenuId, LeftListId);
	StepFlow.prototype._DisableElement_(TopMenuId, LeftListId);
};

StepFlow.prototype._SelectIoStatus_ = function(that)
{
	var TopMenuId="Top-Menu-IoStatus", LeftListId;
	StepFlow.prototype._ClickElement_(that, TopMenuId, LeftListId);
	StepFlow.prototype._DisableElement_(TopMenuId, LeftListId);
	$("#Main_Left-List").find("div").css('pointer-events', "visible");
	$("#Main_Left-List").find("div").css('opacity', 1);
	$("#Main_Top-FunctionWizard").find(".FunctionWizardTable").find(".Row").eq(0).find(".Select").val("null");
	StepFlow.prototype._AllEnableElement_();
	$("#Main_Top-StepFlow").find(".StepTable").hide();
};

StepFlow.prototype._SelectOpcuaCertificate_ = function(that)
{
	var TopMenuId="Top-Menu-File", LeftListId="Left-List-OpcuaCertificate";
	StepFlow.prototype._ClickElement_(that, TopMenuId, LeftListId);
	StepFlow.prototype._DisableElement_(TopMenuId, LeftListId);
};

StepFlow.prototype._SelectMqttCertificate_ = function(that)
{
	var TopMenuId="Top-Menu-File", LeftListId="Left-List-MqttCertificate";
	StepFlow.prototype._ClickElement_(that, TopMenuId, LeftListId);
	StepFlow.prototype._DisableElement_(TopMenuId, LeftListId);
};

StepFlow.prototype._LockAllUi_ = function()
{
	$("#Main_Top-StepFlow").find("div").css('pointer-events', "none");
	if($("#Main_Top-StepFlow").find(".Row").is(":visible") == false)
	{
		$("#Main_Top-Menu").find("div").css('pointer-events', "none");
		$("#Main_Left-List").find("div").css('pointer-events', "none");
		$("#Main_Top-Path").find("div").css('pointer-events', "none");
	}
};

StepFlow.prototype._UnLockAllUi_ = function()
{
	$("#Main_Top-StepFlow").find("div").css('pointer-events', "visible");
	if($("#Main_Top-StepFlow").find(".Row").is(":visible") == false)
	{
		$("#Main_Top-Menu").find("div").css('pointer-events', "visible");
		$("#Main_Left-List").find("div").css('pointer-events', "visible");
		$("#Main_Top-Path").find("div").css('pointer-events', "visible");
	}
};