#! /bin/bash

. ./function.sh
#2021/01/03
mkdir /tmp/Project/;
cp -rf /app/Web/public/File /tmp/Project/;
rm /tmp/Project/File/Version.txt;
rm /tmp/Project/File/Factory/Version.txt;
cp -rf /app/Web/cgi-bin /tmp/Project/;
cp -rf /app/Certificates /tmp/Project/;
cp -rf /app/DDNS/inadyn.conf /tmp/Project;
cp -rf /app/MQTT/Broker/mosquitto.conf /tmp/Project/;
cp -rf /app/runtime/project /tmp/Project/;
cp -rf /app/Wireless/wvdial.conf /tmp/Project/;
cp -rf /app/Firewall/blocklist/rule_config.json /tmp/Project/;
#2021/01/03
Return=$(UsbCheckTarFileName);
if [ $Return -eq -1 ]; then
    ShowCheckTarFileNameError;
    Beep 4 0.001 0.5;
    exit 0;
fi

ClearEeprom;
ShowStartInstall;
Beep 1 1 0.001;
ClearApp;
RemoveApp;
CreateEnvironment;
UsbCopyInstallFileToEnvironment;

Return=$(UsbComparisonTarFile);
if [ $Return -eq -1 ]; then
    ShowComparisonTarFileError;
    Beep 4 0.001 0.5;
    exit 0;
fi

Install_openvpn_if_needed;

#RemoveFactory;
DecompressedFile;
UsbCopyEnvironment;
UsbSetEnvironment;
ChmodFile;
UsbDeleteResidualFile;
Sync;
SetEeprom "UsbUpdate";

#2021/01/03 
cp -rf /tmp/Project/File /app/Web/public/;
cp -rf /tmp/Project/cgi-bin /app/Web/;
cp -rf /tmp/Project/Certificates /app/;
cp -rf /tmp/Project/inadyn.conf /app/DDNS;
cp -rf /tmp/Project/mosquitto.conf /app/MQTT/Broker/;
cp -rf /tmp/Project/project /app/runtime/;
cp -rf /tmp/Project/wvdial.conf /app/Wireless/;
cp -rf /tmp/Project/rule_config.json /app/Firewall/blocklist/;  
rm -rf /tmp/Project/;
/Init/Device_Driver/Multi_ComPort_driver.sh;
Sync;
#2021/01/03
ShowInstallSuccess;
Beep 1 1 0.5;
Beep 1 1 0.001;
